// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'ngCart', 'ngIOS9UIWebViewPatch', 'ionRadioFix', 'ngAnimate'])

.service('sharedProperties', function($ionicHistory, $rootScope, $state, ngCart, $timeout, $ionicPopup, $http, ionicToast) {

    $rootScope.version = 'v2.0.12';
    $rootScope.appOwner = [{
        index: 0,
        logo: 'ezee_imenu.png',
        splashname: 'eZee iMenu',
        versionname: 'eZee iMenu',
        theme: "#3f4392",
        color: "#fff"
    }, {
        index: 1,
        logo: 'aariz.png',
        splashname: '',
        versionname: 'eyesMenu',
        theme: "#fff",
        color: "#3f4392"
    }, {
        index: 2,
        logo: 'gmenu.png',
        splashname: '',
        versionname: 'gMenu',
        theme: "#fff",
        color: "#3f4392"
    }]
    $rootScope.selected = 0;
    window.localStorage.setItem('selected_index', $rootScope.selected);
    window.localStorage.setItem('version', $rootScope.version);
    $rootScope.burrpMsg = '';
    $rootScope.pop = $ionicPopup;
    $rootScope.cartcounter = 0;
    $rootScope.sendingOrderPopup = '';
    $rootScope.routingPopup = '';
    var MENU_GROUP = [];
    var MENU_ITEM = [];
    var MODIFIER = [];
    var UNIT = [];
    var LANGDATA = [];
    var REMARKS = [];
    var getcustid = '';
    var getrestid = window.localStorage.getItem('restid');
    var gettableno = '';
    var getCustmail = '';
    var currencysymbol = window.localStorage.getItem('currencysymbol');
    var sermaster = new Boolean();
    var ws;
    var lstordid;
    var lastSordid;
    var lastSorcartdid;
    var Lastmdid;

    //        return {
    $rootScope.get_service_path = function() {
        return SERVICE_PATH;
    };

    $rootScope.get_server_path = function() {
        return $rootScope.SERVER_PATH;
    };

    $rootScope.closeLoader = function() {
        $timeout(function() {
            var allLoaders = document.querySelectorAll('.loadingData');
            if (allLoaders.length > 0) {
                for (var i = 0; i < allLoaders.length; i++) {
                    if (!allLoaders[i].classList.contains('.loaded'))
                        allLoaders[i].classList.add('loaded');
                }
            }
        }, 3000);
    }

    $rootScope.initCartDB = function() {
        var shortName = 'iMenu_Cart';
        var version = '1.0';
        var displayName = 'iMenu_Cart';
        var maxSize = 1100000;

        // open the database
        this.db = window.openDatabase(shortName, version, displayName, maxSize);

        // create the cartItems table
        this.db.transaction(
            function(transaction) {

                transaction.executeSql(
                    'CREATE TABLE IF NOT EXISTS cart_master ' +
                    ' (cartid INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,' +
                    '   menugrpitemunkid INTEGER, menugrpitemname TEXT, menugrpitemprice REAL, qty INTEGER, customerunkid INTEGER, restaurantunkid INTEGER, totalqtyprice REAL, cartorderdate DATETIME,tableno INTEGER, ismodifier INTEGER, menugrpcode TEXT, menuitemcode INTEGER, menuitemtype TEXT, menuitemremark TEXT, iscustomremark TEXT, unitid INTEGER , unitname TEXT, unitprice REAL, orderSeq INTEGER, isordered INTEGER, orderunkid TEXT, ratings INTEGER);', [],
                    function(transaction, results) { /*alert("cart_master Successfully Created")*/ },
                    function(transaction, error) { /*alert("cart_master Fail")*/ }
                );

                transaction.executeSql('CREATE TABLE IF NOT EXISTS carttrans_master (carttransunkid INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, cartid INTEGER, modifierunkid INTEGER, modifiergrpitemunkid INTEGER, modifiername Text, modifiergrpitemprice REAL, modiitemcode INTEGER, modiitemtype TEXT, modifierunitunkid INTEGER, modifierunitname TEXT);', [],
                    function(transaction, results) { /*alert("carttrans_master Successfully Created")*/ },
                    function(transaction, error) { /*alert("carttrans_master Fail")*/ }
                );
            }
        );
    };

    $rootScope.droprecreate = function() {
        var shortName = 'iMenu_Cart';
        var version = '1.0';
        var displayName = 'iMenu_Cart';
        var maxSize = 1100000;
        if (this.db == null) {
            this.db = window.openDatabase(shortName, version, displayName, maxSize);
        }

        $rootScope.clearCartItems();
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('DROP TABLE IF EXISTS cart_master', [],
                    function(transaction, results) { /*console.log("Successfully Dropped")*/ },
                    function(transaction, error) { /*console.log("Could not delete")*/ }
                );
                transaction.executeSql('DROP TABLE IF EXISTS carttrans_master', [],
                    function(transaction, results) { /*console.log("Successfully Dropped")*/ },
                    function(transaction, error) { /*console.log("Could not delete")*/ }
                );

                transaction.executeSql(
                    'CREATE TABLE IF NOT EXISTS cart_master ' +
                    ' (cartid INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,' +
                    '   menugrpitemunkid INTEGER, menugrpitemname TEXT, menugrpitemprice REAL, qty INTEGER, customerunkid INTEGER, restaurantunkid INTEGER, totalqtyprice REAL, cartorderdate DATETIME,tableno INTEGER, ismodifier INTEGER, menugrpcode TEXT, menuitemcode INTEGER, menuitemtype TEXT, menuitemremark TEXT, iscustomremark TEXT, unitid INTEGER , unitname TEXT, unitprice REAL, orderSeq INTEGER, isOrdered INTEGER, orderunkid TEXT, ratings INTEGER);'
                );

                transaction.executeSql('CREATE TABLE IF NOT EXISTS carttrans_master (carttransunkid INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, cartid INTEGER, modifierunkid INTEGER, modifiergrpitemunkid INTEGER, modifiername Text, modifiergrpitemprice REAL, modiitemcode INTEGER, modiitemtype TEXT, modifierunitunkid INTEGER, modifierunitname TEXT);');
            }
        );
    }

    $rootScope.deleteTables = function() {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('DELETE FROM cart_master', [],
                    function() { /*console.log("Successfully Deleted")*/ },
                    function() { /*console.log("Could not delete");*/
                        this.errorHandler
                    }
                );
                transaction.executeSql('DELETE FROM carttrans_master', [],
                    function() { /*console.log("Successfully Deleted")*/ },
                    function() { /*console.log("Could not delete");*/
                        this.errorHandler
                    }
                );
            }
        );
    }

    $rootScope.addToCart = function(Itemid, Itemname, Itemprice, Idmgpcode, Idmnuitemcode, Idmnuitemtype, Idunitid, Idunitname, Idunitprice, modiObj, orderSeq, remark, custom, itemqty) {
        var Cartlastid = '';
        var fullDate = new Date();
        var twoDigitMonth = ((fullDate.getMonth().length + 1) === 1) ? (fullDate.getMonth() + 1) : '0' + (fullDate.getMonth() + 1);
        var twoDigitDate = fullDate.getDate() + "";
        if (twoDigitDate.length == 1) twoDigitDate = "0" + twoDigitDate;
        var currentDate = twoDigitMonth + "/" + twoDigitDate + "/" + fullDate.getFullYear();
        var modilength = modiObj.length;

        this.db.transaction(
            function(transaction) {
                transaction.executeSql('insert into cart_master (menugrpitemunkid, menugrpitemname, menugrpitemprice, qty, customerunkid, restaurantunkid, totalqtyprice, cartorderdate, tableno, ismodifier, menugrpcode, menuitemcode, menuitemtype, menuitemremark, iscustomremark, unitid, unitname, unitprice, orderSeq, isOrdered, orderunkid, ratings) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [Itemid, Itemname, parseFloat(Itemprice, 10), itemqty, getcustid, getrestid, parseFloat(Idunitprice, 10) * 1, currentDate, gettableno, 1, Idmgpcode, Idmnuitemcode, Idmnuitemtype, remark, custom, Idunitid, Idunitname, Idunitprice, orderSeq, 0, "", 1],
                    function(tr, re) {
                        Cartlastid = re.insertId;

                        if (modilength != 0) {
                            var totalamtmodi = 0;
                            for (var i = 0; i < modiObj.length; i++) {

                                var mgrpid = modiObj[i]['modifiergrpunkid'];
                                var mitemid = modiObj[i]['modifieritemunkid'];
                                var modifierunitunkid = modiObj[i]['unitid'];
                                var modifierunitname = modiObj[i]['unitname'];
                                var mitmPrice = modiObj[i]['modifieritemprice'];
                                var mitemname = modiObj[i]['modifieritemname'];
                                var mitemcode = modiObj[i]['modifieritem_code'];
                                var mitemtype = modiObj[i]['modifiertype']

                                totalamtmodi += parseFloat(mitmPrice, 10);

                                transaction.executeSql('insert into carttrans_master (cartid, modifierunkid, modifiergrpitemunkid, modifiername, modifiergrpitemprice, modiitemcode, modiitemtype, modifierunitunkid, modifierunitname) values (?, ?, ?, ?, ?, ?, ?, ?, ?)', [Cartlastid, mitemid, mgrpid, mitemname, mitmPrice, mitemcode, mitemtype, modifierunitunkid, modifierunitname],
                                    function(transac, reslt) {

                                    },
                                    $rootScope.dbErrorHandler
                                );

                            }
                            var totalamt = parseFloat(Itemprice, 10) + totalamtmodi;
                            transaction.executeSql('update cart_master set totalqtyprice = ? where cartid = ?', [totalamt, Cartlastid],
                                function(t, r) {
                                    $rootScope.TotalItems(this.showItem);
                                },
                                $rootScope.dbErrorHandler
                            );
                        }
                    },
                    $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.TotalItems = function() {
        var len;
        this.db.transaction(
            function(transaction) {
                transaction.executeSql(
                    'SELECT * FROM cart_master  order by cartid asc;', [],
                    function(transaction, result) {
                        len = result.rows.length;
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.getCartId = function() {
        var len;
        this.db.transaction(
            function(transaction) {
                transaction.executeSql(
                    'SELECT seq FROM sqlite_sequence', [],
                    function(transaction, result) {
                        len = result.rows.length;
                        if (len > 0) {
                            var tmp = result.rows.item(0);
                            $rootScope.lastCartId = parseInt(tmp.seq) + 1;
                        } else {
                            $rootScope.lastCartId = 1;
                        }
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.getItemForFeedback = function() {
        var len;
        this.db.transaction(
            function(transaction) {
                transaction.executeSql(
                    'select distinct menugrpitemunkid, menugrpitemname from cart_master', [],
                    function(transaction, result) {
                        len = result.rows.length;
                        if (len > 0) {
                            for (i = 0; i < len; i++) {
                                var tmp = result.rows.item(i);
                                $rootScope.itemsForFeedback.push({
                                    menugrpitemunkid: tmp.menugrpitemunkid,
                                    menugrpitemname: tmp.menugrpitemname,
                                    rate: 0
                                });
                            }
                        }
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.LoadCart = function() {
        var len;
        var global_cart = [];
        var cartmodifiers = [];
        this.db.transaction(
            function(transaction) {
                transaction.executeSql(
                    'SELECT * FROM cart_master order by cartid asc;', [],
                    function(transaction, result) {
                        var cartdata = [];
                        len = result.rows.length;
                        for (i = 0; i < len; i++) {
                            var row = result.rows.item(i);
                            var itemobj = new Object();
                            itemobj.cartid = row.cartid;
                            itemobj.itemid = row.menugrpitemunkid;
                            itemobj.name = row.menugrpitemname;
                            itemobj.unit = row.unitname;
                            itemobj.unitid = row.unitid;
                            itemobj.price = row.unitprice;
                            itemobj.quantity = row.qty;
                            itemobj.itemremarks = row.menuitemremark;
                            itemobj.modifierunkid = [];
                            itemobj.menugroupcode = row.menugrpcode;
                            itemobj.menuitemcode = row.menuitemcode;
                            itemobj.menuitemtype = row.menuitemtype;
                            itemobj.orderSeq = row.orderSeq;
                            itemobj.menuitemremark = row.menuitemremark;
                            itemobj.iscustomremark = row.iscustomremark;
                            itemobj.isordered = row.isOrdered;
                            itemobj.orderunkid = row.orderunkid;
                            itemobj.itemtotal = parseFloat(itemobj.price);
                            itemobj.rating = row.ratings;
                            global_cart.push(itemobj);
                        }
                    },
                    this.errorHandler
                );

                transaction.executeSql('SELECT cartid, modifierunkid, modifiername, modifiergrpitemprice, modifiergrpitemunkid, modifiername, modifierunitunkid, modifierunitname FROM carttrans_master', [],
                    function(transac, reslt) {
                        for (j = 0; j < reslt.rows.length; j++) {
                            var modifrow = reslt.rows.item(j);
                            var modif = new Object();
                            modif.cartid = modifrow.cartid;
                            modif.modifieritemunkid = modifrow.modifierunkid;
                            modif.modifieritemname = modifrow.modifiername;
                            modif.modifierunitunkid = modifrow.modifierunitunkid;
                            modif.unitname = modifrow.modifierunitname;
                            modif.modifieritemprice = modifrow.modifiergrpitemprice;
                            modif.modifiergroupname = modifrow.modifiergroupname;
                            modif.modifiergrpunkid = modifrow.modifiergrpunkid;
                            modif.modifiertype = modifrow.modifiertype;
                            cartmodifiers.push(modif);
                        }
                    },
                    $rootScope.dbErrorHandler
                );

                setTimeout(function() {

                    var grandtot = 0;
                    for (i = 0; i < global_cart.length; i++) {
                        var tot = 0;
                        var mod = [];
                        for (j = 0; j < cartmodifiers.length; j++) {
                            if (cartmodifiers[j].cartid == global_cart[i].cartid) {
                                var modif = new Object();
                                modif.cartid = cartmodifiers[j]['cartid'];
                                modif.modifieritemunkid = cartmodifiers[j]['modifieritemunkid'];
                                modif.modifierunitunkid = cartmodifiers[j]['modifierunitunkid'];
                                modif.unitname = cartmodifiers[j]['unitname'];
                                modif.modifieritemname = cartmodifiers[j]['modifieritemname'];
                                modif.modifieritemprice = cartmodifiers[j]['modifieritemprice'];
                                modif.modifiergroupname = cartmodifiers[j]['modifiergroupname'];
                                modif.modifiergrpunkid = cartmodifiers[j]['modifiergrpunkid'];
                                modif.modifiertype = cartmodifiers[j]['modifiertype'];
                                mod.push(modif);
                                tot = parseFloat(tot) + parseFloat(modif.modifieritemprice);
                            }
                        }

                        grandtot = parseFloat(grandtot) + parseFloat(global_cart[i].price);
                        global_cart[i].modifierunkid = mod;
                    }
                }, 2000)

                $rootScope.cartcounter = 0;
                setTimeout(function() {
                    for (ii = 0; ii < global_cart.length; ii++) {
                        var data = [];
                        data.cartid = global_cart[ii].cartid;
                        data.itemid = global_cart[ii].itemid;
                        data.menugroupcode = global_cart[ii].menugroupcode;
                        data.menuitemcode = global_cart[ii].menuitemcode;
                        data.menuitemtype = global_cart[ii].menuitemtype;
                        data.orderSeq = global_cart[ii].orderSeq;
                        data.unit = global_cart[ii].unit;
                        data.unitid = global_cart[ii].unitid;
                        data.menuitemremark = global_cart[ii].menuitemremark;
                        data.iscustomremark = global_cart[ii].iscustomremark;
                        data.isordered = global_cart[ii].isordered;
                        data.orderunkid = global_cart[ii].orderunkid;
                        data.rating = global_cart[ii].rating;

                        data.modifierunkid = [];
                        if (global_cart[ii].modifierunkid != undefined) {
                            for (jj = 0; jj < global_cart[ii].modifierunkid.length; jj++) {
                                var tmp = [];
                                tmp.cartid = global_cart[ii].cartid;
                                tmp.modifiergrpunkid = '';
                                tmp.modifieritem_code = global_cart[ii].modifierunkid[jj].modifieritemname;
                                tmp.modifieritemname = global_cart[ii].modifierunkid[jj].modifieritemname;
                                tmp.modifieritemprice = global_cart[ii].modifierunkid[jj].modifieritemprice;
                                tmp.modifieritemunkid = global_cart[ii].modifierunkid[jj].modifieritemunkid;
                                tmp.modifiertype = true;
                                tmp.unitid = global_cart[ii].modifierunkid[jj].modifierunitunkid;
                                tmp.unitname = global_cart[ii].modifierunkid[jj].unitname;
                                data.modifierunkid.push(tmp);
                            }
                        }

                        if (data.isordered == 0) {
                            $rootScope.cartcounter++;
                        }

                        ngCart.addItem(parseInt(global_cart[ii].cartid), global_cart[ii].name, parseFloat(global_cart[ii].price), parseInt(global_cart[ii].quantity), data);
                    }

                }, 2000)
            }
        );
    }

    $rootScope.dbErrorHandler = function(transaction, error) {
        alert('Error: ' + error.message + ' [Code: ' + error.code + ']');

        function alertDismissed() {
            return false;
        }
    }

    $rootScope.resetWebSQL = function(orderSeq) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('delete from sqlite_sequence', [],
                    function(tra, suc) {},
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.clearCartRowItem = function(orderSeq) {
        this.db.transaction(
            function(transaction) {

                transaction.executeSql('delete from cart_master where cartid = ? ', [orderSeq],
                    function(tra, suc) {
                        transaction.executeSql(
                            'delete from carttrans_master where cartid = ? ', [orderSeq],
                            function() {},
                            this.errorHandler
                        );
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.clearCartRowItemFromOrder = function(orderunkid) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT cartid FROM cart_master where orderunkid = ? and isordered = 0', [orderunkid],
                    function(trans, orderitems) {
                        if (orderitems.rows.length > 0) {
                            transaction.executeSql('delete from cart_master where cartid = ?', [orderitems.rows.item(0).cartid],
                                function(tra, suc) {
                                    transaction.executeSql(
                                        'delete from carttrans_master where cartid = ?', [orderitems.rows.item(0).cartid],
                                        function() {},
                                        this.errorHandler
                                    );
                                },
                                this.errorHandler
                            );
                        }
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.incrementCartRowItem = function(orderSeq, qty) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('update cart_master set qty = ? where cartid = ?', [qty, orderSeq],
                    function(transaction, result) {}, $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.updateRemark = function(cartid, remark, custom) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('update cart_master set menuitemremark = ?, iscustomremark = ? where cartid = ?', [remark, custom, cartid],
                    function() {}, $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.updateRating = function(orderno, itemid, rating, unitid) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('update cart_master set ratings = ? where menugrpitemunkid = ? and orderunkid = ? and unitid = ?', [rating, itemid, orderno, unitid],
                    function() {}, $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.decrementCartRowItem = function(orderSeq) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('select qty from cart_master where cartid = ?', [orderSeq],
                    function(transaction, result) {
                        if (result.rows.length > 0) { // there is an existing record

                            var quantity = result.rows.item(0).qty;
                            transaction.executeSql('update cart_master set qty = qty - 1 where cartid = ?', [orderSeq],
                                function() {},
                                this.errorHandler
                            );
                        }
                    }, $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.confirmOrder = function() {
        $rootScope.getLastOrderItems();
    }

    /*
        option : 0 - Delete All items from cart and webSQL
        option : 1 - Delete All items from cart and webSQL which are not ordered (isOrdered == 0)
    */
    $rootScope.clearCartItems = function(option) {
        if (option == 1) {
            this.db.transaction(
                function(transaction) {
                    transaction.executeSql(
                        'SELECT * FROM cart_master WHERE isOrdered = 0', [],
                        function(transaction, result) {

                            for (var i = 0; i < result.rows.length; i++) {
                                var row = result.rows.item(i);

                                transaction.executeSql('DELETE FROM cart_master WHERE cartid = ?', [row.cartid],
                                    function(trans, res) {},
                                    this.errorHandler
                                );

                                transaction.executeSql('DELETE FROM carttrans_master WHERE cartid = ?', [row.cartid],
                                    function(trans, res) {},
                                    this.errorHandler
                                );
                            }
                        },
                        this.errorHandler
                    );
                }
            );
        } else if (option === 0) {
            this.db.transaction(
                function(transaction) {
                    transaction.executeSql(
                        'delete from cart_master', [],
                        function() {},
                        this.errorHandler
                    );

                    transaction.executeSql(
                        'delete from carttrans_master', [],
                        function() {},
                        this.errorHandler
                    );

                    transaction.executeSql(
                        'delete from sqlite_sequence ', [],
                        function() {},
                        this.errorHandler
                    );
                }
            );
            window.localStorage.setItem("orderunkid_array", '');
            $rootScope.lastCartId = 1;
        }
    }

    $rootScope.BurrpOrder = function(lastorder) {
        var srvordno;
        var tsmp = new Date().getTime();

        var tableno = "";
        var tmpwaitermode = window.localStorage.getItem("waitermode");
        if (tmpwaitermode != '') {
            if (tmpwaitermode == 1) {
                if (window.localStorage.getItem("TableNumber") == 'None') {
                    tableno = window.localStorage.getItem("tmptableno");
                } else
                    tableno = window.localStorage.getItem("TableNumber");
            } else {
                tableno = window.localStorage.getItem("TableNumber");
            }
        }

        var tabno;
        tabno = tableno.replace(/\s/g, "-");
        srvordno = window.localStorage.getItem("restaurantcode") + tsmp;
        window.localStorage.setItem("orderno", srvordno);
        window.localStorage.setItem("Lastorderid", srvordno);


        var GuestEmail = window.localStorage.getItem("cmail");
        var ordcomment = "";
        var custid = window.localStorage.getItem("cid");
        var Idordpref = 1;
        if (window.localStorage.getItem('orderpreference') == 0)
            Idordpref = 1;
        else if (window.localStorage.getItem('orderpreference') == 1)
            Idordpref = 3;

        var IdGuestName = "";
        var IdGuestEmail = "";
        var IdGuestPhone = "";
        var numadult = 0;
        var numchild = 0;

        if (window.localStorage.getItem("guestdetailchoice") != '') {
            var obj = JSON.parse(window.localStorage.getItem("guestdetailchoice"));

            IdGuestName = obj.name;
            IdGuestEmail = obj.email;
            IdGuestPhone = obj.phone;
            numadult = obj.adult;
            numchild = obj.child;
        }

        var IdWaiterName = "";
        var IdWaiterId = "";
        var IdWaiterCode = "";

        IdWaiterName = window.localStorage.getItem("WaiterName");
        IdWaiterId = window.localStorage.getItem("WaiterId");
        IdWaiterCode = window.localStorage.getItem("WaiterCode");

        var order_item = [];
        var total = 0;
        var year = lastorder[0][0].orderdate;
        var ordertime = lastorder[0][0].orderplacedtime;

        for (var i = 0; i < lastorder[1].length; i++) {

            var modifer_itms = [];
            var idmodifier = lastorder[1][i]['modifierparentid'];
            var idordtrn = lastorder[1][i]['cartid'];
            if (idmodifier == 0) {
                for (var j = 0; j < lastorder[1].length; j++) {

                    if (i != j) {
                        var idmdfr = lastorder[1][j]['cartid'];
                        if (idordtrn == idmdfr) {
                            modifer_itms.push({

                                "item_code": lastorder[1][j]['menugrpitemunkid'],
                                "item_name": lastorder[1][j]['menugrpitemname'],
                                "unit_name": lastorder[1][j]['unitname'],
                                "price": lastorder[1][j]['menugrpitemprice'],
                                "quantity": 1
                            });
                        }
                    }
                }

                var itemremark = '';

                if (lastorder[1][i]['iscustomremark'].length > 0)
                    itemremark = lastorder[1][i]['iscustomremark'];
                else {
                    if (lastorder[1][i]['menuitemremark'].length > 0) {

                        var tmp = JSON.parse(lastorder[1][i]['menuitemremark']);
                        for (index = 0; index < tmp.length; index++) {
                            itemremark += tmp[index].name + ',';
                        }

                        itemremark = itemremark.substring(0, itemremark.length - 1);
                    }
                }

                total = total + (parseFloat(lastorder[1][i]['unitprice']) * parseInt(lastorder[1][i]['itemquantity']))
                order_item.push({
                    "item_code": lastorder[1][i]['menugrpitemunkid'],
                    "item_name": lastorder[1][i]['menugrpitemname'],
                    "Unit_Name": lastorder[1][i]['unitname'],
                    "price": (parseFloat(lastorder[1][i]['unitprice'] * lastorder[1][i]['itemquantity'])).toFixed(localStorage.getItem("decimal")),
                    /*  lastorder[1][i]['unitprice']    */
                    "unitprice": lastorder[1][i]['unitprice'].toFixed(localStorage.getItem("decimal")),
                    "Unit_Code": lastorder[1][i]['unitid'],
                    "PreparationRemark": itemremark,
                    "quantity": lastorder[1][i]['itemquantity'],
                    "modifer": modifer_itms
                });
            }
        }


        var cc = [];

        cc.push({
            "command_id": "1001",
            "registration_id": window.localStorage.getItem("registrationid"),
            "restaurantcode": localStorage.getItem('restid'),
            "outlet": window.localStorage.getItem("Outlet"),
            "order_no": srvordno,
            "order_comments": window.localStorage.getItem("guestcomment"),
            "orderstatus": "Pending",
            "paymentstatus": "Pending",
            "order_type": Idordpref,
            "customer_name": IdGuestName,
            "customer_email": IdGuestEmail,
            "customer_mobile": IdGuestPhone,
            "adult": numadult,
            "child": numchild,
            "table_no": tableno,
            "Waiter_Name": IdWaiterName,
            "Code": IdWaiterCode,
            "order_item": order_item
        });

        var Final_json = cc;
        var arr = [];
        arr.push({
            order: Final_json
        });

        /*  --------  Send order to burrp  ----------  */
        $rootScope.sendMessage(Final_json);
        //console.log(JSON.stringify(Final_json))
        //$rootScope.sendingOrderPopup.close();
        /* ------------------------------------------ */
    }

    /*
        val = 1 : Waiter
        val = 2 : Bill
    */
    $rootScope.waiterOrBill = function(bill_waiter, table) {

        if (table != '') {

            var burrpmsg = '';
            var usermsg = '';
            if (bill_waiter == 1) {
                usermsg = "Calling Waiter..";
                burrpmsg = "Waiter call";
            } else if (bill_waiter == 2) {
                usermsg = "Requesting Bill..";
                burrpmsg = "Bill call";
            }
            $rootScope.sendingOrderPopup = $ionicPopup.show({
                template: '<div>' + usermsg + '</div>',
                cssClass: 'custompopup',
                title: $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg49),
                buttons: []
            });
            $rootScope.sendingOrderPopup.then(function(res) {});

            $timeout(function() {
                var cc = [];
                var msg = '';
                cc.push({
                    "command_id": "2001",
                    "table_no": table,
                    "message": burrpmsg
                });
                $rootScope.sendMessage(cc);
            }, 1000)
        } else {
            ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg22), 'top', false, $rootScope.messagetimeout, '');
        }
    }

    $rootScope.getLastOrderItems = function() {
        var mstrordarr = [];
        var tranordarr1 = [];
        var tranordarr2 = [];
        var tmp_modifiers = [];

        var cnt = 1;
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT * FROM cart_master where isOrdered=0 order by cartid', [],
                    function(trans, res) {

                        cnt = 1;
                        if (res.rows.length > 0) {
                            var obj = new Object();
                            obj.orderunkid = '';
                            obj.customerunkid = '';
                            obj.restaurantunkid = '';
                            obj.Tableno = '';
                            obj.orderno = '';

                            obj.orderdate = $rootScope.GetCurrentDate();
                            var fullDate = new Date();
                            var twoDigitHour = fullDate.getHours() + "";
                            if (twoDigitHour.length == 1) twoDigitHour = "0" + twoDigitHour;
                            var twoDigitMint = fullDate.getMinutes() + "";
                            if (twoDigitMint.length == 1) twoDigitMint = "0" + twoDigitMint;
                            var twoDigitSec = fullDate.getSeconds() + "";
                            if (twoDigitSec.length == 1) twoDigitSec = "0" + twoDigitSec;
                            var CurrentTime = twoDigitHour + ":" + twoDigitMint + ":" + twoDigitSec; //Get Current Time
                            obj.orderplacedtime = CurrentTime;
                            obj.orderexecuteddatetime = '';
                            obj.contactemail = '';
                            obj.totalbillamount = '';
                            obj.ordercomments = '';
                            obj.orderstatus = '';
                            tranordarr1.push(obj);
                        }

                        for (var j = 0; j < res.rows.length; j++) {

                            var rw = res.rows.item(j);
                            if (j == 0) {
                                cnt = rw.cartid;
                            }
                            var itm = new Object();
                            itm.ordertransunkid = cnt;
                            cnt = cnt + 1;
                            itm.cartid = rw.cartid
                            itm.orderunkid = 1;
                            itm.menugrpitemunkid = rw.menugrpitemunkid;
                            itm.menugrpitemname = rw.menugrpitemname;
                            itm.menugrpitemprice = rw.menugrpitemprice;
                            itm.modifierparentid = 0;
                            itm.menugrpitemdiscamount = 0;
                            itm.menugrpitemtaxamount = 0;
                            itm.itemquantity = rw.qty;
                            itm.itemtotalamount = parseFloat(rw.qty * rw.totalqtyprice);
                            itm.menugrpcode = rw.menugrpcode;
                            itm.menuitemcode = rw.menugrpcode;
                            itm.menuitemtype = rw.menuitemtype;
                            itm.menuitemremark = rw.menuitemremark;
                            itm.iscustomremark = rw.iscustomremark;
                            itm.unitid = rw.unitid;
                            itm.unitname = rw.unitname;
                            itm.unitprice = rw.unitprice;
                            tranordarr2.push(itm);
                        }
                    },
                    this.errorHandler
                );

                transaction.executeSql('SELECT carttrans_master.* FROM cart_master, carttrans_master where cart_master.cartid=carttrans_master.cartid and cart_master.isOrdered=0', [],
                    function(tra, res1) {
                        for (var k = 0; k < res1.rows.length; k++) {
                            var modrw = res1.rows.item(k);
                            var itms = new Object();
                            itms.ordertransunkid = cnt;
                            cnt = cnt + 1;
                            itms.cartid = modrw.cartid;
                            itms.orderunkid = 1;
                            itms.menugrpitemunkid = modrw.modifiergrpitemunkid;
                            itms.menugrpitemname = modrw.modifiername;
                            itms.modifierunitunkid = modrw.modifierunitunkid;
                            itms.menugrpitemprice = modrw.modifiergrpitemprice;
                            itms.modifierparentid = 0;
                            itms.menugrpitemdiscamount = 0;
                            itms.menugrpitemtaxamount = 0;
                            itms.itemquantity = 1;
                            itms.itemtotalamount = 0;
                            itms.menugrpcode = modrw.modifierunkid;
                            itms.menuitemcode = modrw.modiitemcode;
                            itms.menuitemtype = modrw.modiitemtype;
                            itms.menuitemremark = '';
                            itms.unitid = '';
                            itms.unitname = modrw.modifierunitname;
                            itms.unitprice = '';
                            tmp_modifiers.push(itms);
                        }
                    },
                    this.errorHandler
                );


                setTimeout(function() {

                    var tmp = tranordarr2;
                    for (i = 0; i < tmp_modifiers.length; i++) {
                        for (j = 0; j < tmp.length; j++) {
                            if (tmp_modifiers[i].cartid == tmp[j].cartid) {
                                tmp_modifiers[i].modifierparentid = tmp[j].menugrpitemunkid;
                                break;
                            }
                        }

                        tranordarr2.push(tmp_modifiers[i]);
                    }

                    mstrordarr.push(tranordarr1);
                    mstrordarr.push(tranordarr2);

                    if (window.localStorage.getItem("isburrp") == "true" || window.localStorage.getItem("isburrp") == true) {
                        setTimeout(function() {
                            $rootScope.BurrpOrder(mstrordarr);
                        }, 100)
                    } else {
                        $rootScope.addServerorder(mstrordarr);
                    }

                }, 1000);
            }
        );
    }

    $rootScope.addServerorder = function(lastorder) {
        var tsmp = new Date().getTime();

        var tabno = "";
        var tmpwaitermode = window.localStorage.getItem("waitermode");
        if (tmpwaitermode != '') {
            if (tmpwaitermode == 1) {
                if (window.localStorage.getItem("TableNumber") == 'None') {
                    tabno = window.localStorage.getItem("tmptableno");
                } else
                    tabno = window.localStorage.getItem("TableNumber");
            } else {
                tabno = window.localStorage.getItem("TableNumber");
            }
        }

        var srvordno = window.localStorage.getItem("restaurantcode") + tsmp;
        window.localStorage.setItem("orderno", srvordno);
        window.localStorage.setItem("Lastorderid", srvordno);

        var allordr = [];

        var GuestEmail = window.localStorage.getItem("cmail");
        var ordcomment = "";
        var custid = window.localStorage.getItem("cid");
        var Idordpref = '';
        var IdGuestName = "";
        var IdGuestEmail = "";
        var IdGuestPhone = "";
        var IdWaiterName = "";
        var IdWaiterId = "";
        var IdWaiterCode = "";

        IdWaiterName = window.localStorage.getItem("WaiterName");
        IdWaiterId = window.localStorage.getItem("WaiterId");
        IdWaiterCode = window.localStorage.getItem("WaiterCode");


        //======== Json for Websocket ===========//

        var order_item = [];
        var total = 0;
        var year = lastorder[0][0].orderdate;
        var ordertime = lastorder[0][0].orderplacedtime;
        for (var i = 0; i < lastorder[1].length; i++) {

            var modifer_itms = [];
            var idmodifier = lastorder[1][i]['modifierparentid'];
            //var idordtrn = lastorder[1][i]['ordertransunkid'];
            var idordtrn = lastorder[1][i]['cartid'];
            if (idmodifier == 0) {
                for (var j = 0; j < lastorder[1].length; j++) {

                    if (i != j) {
                        var idmdfr = lastorder[1][j]['cartid'];
                        if (idordtrn == idmdfr) {
                            modifer_itms.push({

                                "modifierunkid": lastorder[1][j]['menugrpitemunkid'],
                                "modifierunitunkid": lastorder[1][j]['modifierunitunkid'],
                                "modifierunitname": lastorder[1][j]['modifierunitname'],
                                "name": lastorder[1][j]['menugrpitemname'],
                                "price": lastorder[1][j]['menugrpitemprice']
                            });
                        }
                    }
                }

                var itemremark = '';

                if (lastorder[1][i]['iscustomremark'].length > 0)
                    itemremark = lastorder[1][i]['iscustomremark'];
                else {
                    if (lastorder[1][i]['menuitemremark'].length > 0) {

                        var tmp = JSON.parse(lastorder[1][i]['menuitemremark']);
                        for (index = 0; index < tmp.length; index++) {
                            itemremark += tmp[index].name + ',';
                        }

                        itemremark = itemremark.substring(0, itemremark.length - 1);
                    }
                }

                total = total + (parseFloat(lastorder[1][i]['unitprice']) * parseInt(lastorder[1][i]['itemquantity']))
                order_item.push({
                    "item_code": lastorder[1][i]['menugrpitemunkid'],
                    "name": lastorder[1][i]['menugrpitemname'],
                    "unit": lastorder[1][i]['unitname'],
                    "price": lastorder[1][i]['unitprice'],
                    "unitprice": lastorder[1][i]['menugrpitemprice'],
                    "unitid": lastorder[1][i]['unitid'],
                    "itemremark": itemremark,
                    "quantity": lastorder[1][i]['itemquantity'],
                    "modifierunkid": modifer_itms
                });

            }
        }


        var cc = [];

        cc.push({
            "outlet": window.localStorage.getItem("Outlet"),
            "registration_id": window.localStorage.getItem("registrationid"),
            "orderno": srvordno,
            "restaurantcode": localStorage.getItem('restid'),
            "yearcode": year,
            "datetime": ordertime,
            "comment": window.localStorage.getItem("guestcomment"),
            "orderstatus": "Pending",
            "paymentstatus": "Pending",
            "ordertype": Idordpref,
            "devicesource": "",
            "total": total,
            "customerunkid": custid,
            "customer_name": IdGuestName,
            "customer_email": IdGuestEmail,
            "customer_mobile": IdGuestPhone,
            "tableno": tabno,
            "waitername": IdWaiterName,
            "waitercode": IdWaiterCode,
            "item": order_item
        });

        var Final_json = cc;
        var arr = [];
        arr.push({
            order: Final_json
        });

        var res = $http.get($rootScope.SERVER_PATH + "orderprocess.php", {
            params: {
                "ordr": JSON.stringify(arr[0])
            }
        });
        res.success(function(data, status, headers, config) {

            $rootScope.orderSendingMesssage = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg60);

            $timeout(function() {

                for (i = 0; i < ngCart.getItems().length; i++) {
                    if (ngCart.getItems()[i]._data.isordered == 0) {
                        ngCart.getItems()[i]._data.isordered = 1;
                        ngCart.getItems()[i]._data.orderunkid = srvordno;
                    }
                }

                $timeout(function() {

                    $rootScope.cartcounter = 0;
                    $rootScope.cartToOrder();
                    var obj = new Object;
                    obj.orderunkid = srvordno;
                    obj.tableno = tabno;
                    obj.israted = 0;

                    if (window.localStorage.getItem("orderunkid_array") == null || window.localStorage.getItem("orderunkid_array") == 'null') {
                        window.localStorage.setItem("orderunkid_array", '');
                    }

                    if (window.localStorage.getItem("orderunkid_array").length > 0) {
                        allordr = JSON.parse(window.localStorage.getItem("orderunkid_array"));
                        allordr.push(obj);
                    } else {
                        allordr.push(obj);
                    }
                    window.localStorage.setItem("orderunkid_array", JSON.stringify(allordr));
                    window.localStorage.setItem("guestcomment", '');

                    $timeout(function() {
                        $rootScope.sendingOrderPopup.close();
                    }, 3000)
                    $timeout(function() {
                        $state.go("app.myOrders", {});
                    }, 1000);
                    // $rootScope.DeleteExtraOrderFromCart();
                }, 1000);
            }, 10);
        });

        res.error(function(data, status, headers, config) {
            $timeout(function() {
                $rootScope.sendingOrderPopup.close();

                ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
            }, 1000);
        });
    }

    $rootScope.cartToOrder = function() {
        this.db.transaction(
            function(transaction) {
                var table = localStorage.getItem("TableNumber");
                var orderid = localStorage.getItem("Lastorderid");
                transaction.executeSql('UPDATE cart_master set isOrdered=1, tableno=?, orderunkid=? WHERE isOrdered=0', [table, orderid],
                    function(transaction, result) {},
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.viewOrder = function() {
        this.getAllOrderItems();

        setTimeout(function() {
            var foodcart = [];
            foodcart.items = [];
            $rootScope.clearCartItems();
        }, 10);

    }

    $rootScope.getAllOrderItems = function() {

        $rootScope.initCartDB();
        $rootScope.DeleteExtraOrder();
        $rootScope.getOrders();
        $rootScope.getItems();
        $rootScope.getModifier();
    }

    $rootScope.DeleteExtraOrderFromCart = function() {
        var orderid = 0;
        if (window.localStorage.getItem("orderunkid_array") != '' && window.localStorage.getItem("orderunkid_array") != null) {
            var ordernumbers = JSON.parse(window.localStorage.getItem("orderunkid_array"))

            if (ordernumbers.length > 10) {
                orderid = ordernumbers[0].orderunkid;
                ordernumbers.splice(0, 1);
                window.localStorage.setItem("orderunkid_array", JSON.stringify(ordernumbers))
            }
        }
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT * FROM cart_master WHERE isOrdered == 1 AND orderunkid = ?', [orderid],
                    function(transaction, result) {
                        if (result.rows.length > 0) {
                            for (var i = 0; i < result.rows.length; i++) {
                                transaction.executeSql('DELETE FROM cart_master where cartid = ?', [result.rows.item(i).cartid],
                                    function() {},
                                    this.errorHandler
                                );

                                transaction.executeSql('DELETE FROM carttrans_master where cartid = ?', [result.rows.item(i).cartid],
                                    function() {},
                                    this.errorHandler
                                );
                            }
                        }
                    },
                    this.errorHandler
                );
            }
        );
    }

    /*
        edit_or_repeat = 1  (Edit Order)
        edit_or_repeat = 0  (Repeat Order)
    */
    $rootScope.duplicateOrder = function(orderno, edit_or_repeat) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT * FROM cart_master WHERE orderunkid = ?', [orderno],
                    function(transaction, result) {
                        if (result.rows.length > 0) {
                            $rootScope.cartcounter = result.rows.length;
                            for (var i = 0; i < result.rows.length; i++) {
                                $rootScope.duplicate_cartmaster(result.rows.item(i).cartid, result.rows.item(i).menugrpitemunkid, result.rows.item(i).menugrpitemname, result.rows.item(i).menugrpitemprice, result.rows.item(i).qty, result.rows.item(i).customerunkid, result.rows.item(i).restaurantunkid, result.rows.item(i).totalqtyprice, result.rows.item(i).cartorderdate, result.rows.item(i).tableno, result.rows.item(i).ismodifier, result.rows.item(i).menugrpcode, result.rows.item(i).menuitemcode, result.rows.item(i).menuitemtype, result.rows.item(i).menuitemremark, result.rows.item(i).iscustomremark, result.rows.item(i).unitid, result.rows.item(i).unitname, result.rows.item(i).unitprice, result.rows.item(i).orderSeq, (edit_or_repeat == 1) ? result.rows.item(i).orderunkid : '', 1);
                                if (i == result.rows.length - 1) {
                                    $rootScope.getCartId();
                                    $rootScope.duplicateOrderinCart(edit_or_repeat);
                                }
                            }
                        }
                    },
                    $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.duplicate_cartmaster = function(cartid, menugrpitemunkid, menugrpitemname, menugrpitemprice, qty, customerunkid, restaurantunkid, totalqtyprice, cartorderdate, tableno, ismodifier, menugrpcode, menuitemcode, menuitemtype, menuitemremark, iscustomremark, unitid, unitname, unitprice, orderSeq, orderunkid, ratings, image) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('insert into cart_master (menugrpitemunkid, menugrpitemname,  menugrpitemprice, qty, customerunkid, restaurantunkid, totalqtyprice, cartorderdate, tableno, ismodifier, menugrpcode, menuitemcode, menuitemtype, menuitemremark, iscustomremark, unitid, unitname, unitprice, orderSeq, isOrdered, orderunkid, ratings) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [menugrpitemunkid, menugrpitemname, menugrpitemprice, qty, customerunkid, restaurantunkid, totalqtyprice, cartorderdate, tableno, ismodifier, menugrpcode, menuitemcode, menuitemtype, menuitemremark, iscustomremark, unitid, unitname, unitprice, orderSeq, 0, orderunkid, ratings],
                    function(transaction, cart_result) {
                        var lastid = cart_result.insertId;

                        $rootScope.duplicate_carttransactionmaster(cartid, cart_result.insertId);
                    },
                    $rootScope.dbErrorHandler
                );
            });
    }

    $rootScope.duplicate_carttransactionmaster = function(cartid, insertId) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT * FROM carttrans_master WHERE cartid = ?', [cartid],
                    function(transaction, carttrans_result) {
                        for (var j = 0; j < carttrans_result.rows.length; j++) {
                            transaction.executeSql('insert into carttrans_master (cartid, modifierunkid, modifiergrpitemunkid, modifiername, modifiergrpitemprice, modiitemcode, modiitemtype, modifierunitunkid, modifierunitname) values (?, ?, ?, ?, ?, ?, ?, ?, ?)', [insertId, carttrans_result.rows.item(j).modifierunkid, carttrans_result.rows.item(j).modifiergrpitemunkid, carttrans_result.rows.item(j).modifiername, carttrans_result.rows.item(j).modifiergrpitemprice, carttrans_result.rows.item(j).modiitemcode, carttrans_result.rows.item(j).modiitemtype, carttrans_result.rows.item(j).modifierunitunkid, carttrans_result.rows.item(j).modifierunitname],
                                function(transac, reslt) {},
                                $rootScope.dbErrorHandler
                            );
                        }
                    },
                    $rootScope.dbErrorHandler
                );
            });
    }


    /*
        edit_or_repeat = 1  (Edit Order)
        edit_or_repeat = 0  (Repeat Order)
    */
    $rootScope.duplicateOrderinCart = function(edit_or_repeat) {
        $rootScope.cartcounter = 0;
        var global_cart = [];
        var cartmodifiers = [];
        this.db.transaction(
            function(transaction) {
                transaction.executeSql(
                    'SELECT * FROM cart_master WHERE isOrdered = 0', [],
                    function(transaction, result) {
                        var cartdata = [];
                        len = result.rows.length;
                        for (i = 0; i < len; i++) {
                            var row = result.rows.item(i);
                            var itemobj = new Object();
                            itemobj.cartid = row.cartid;
                            itemobj.iscustomremark = row.iscustomremark;
                            itemobj.isordered = 0;
                            itemobj.itemid = row.menugrpitemunkid;
                            itemobj.menugroupcode = row.menugrpcode;
                            itemobj.menugrpitemimage = row.image;
                            itemobj.menuitemcode = row.menuitemcode;
                            itemobj.menuitemremark = row.menuitemremark;
                            itemobj.menuitemtype = row.menuitemtype;
                            itemobj.orderSeq = row.orderSeq;
                            itemobj.orderunkid = (edit_or_repeat == 1) ? row.orderunkid : '';
                            itemobj.rating = row.ratings;
                            itemobj.unit = row.unitname;
                            itemobj.unitid = row.unitid;
                            itemobj.modifierunkid = [];
                            itemobj.name = row.menugrpitemname;
                            itemobj.price = row.unitprice;
                            itemobj.quantity = row.qty;
                            $rootScope.duplicateOrderTransactioninCart(itemobj, row.cartid)

                            if (i == len - 1) {
                                // $timeout(function(){
                                $state.go("app.foodcart", {});
                                // }, 1000)
                            }
                        }
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.duplicateOrderTransactioninCart = function(itemobj, cartid) {

        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT cartid, modifierunkid, modifiername, modifiergrpitemprice, modifiergrpitemunkid, modifiername, modifierunitunkid, modifierunitname FROM carttrans_master WHERE cartid = ?', [cartid],
                    function(transac, reslt) {
                        if (reslt.rows.length > 0) {
                            $rootScope.cartmodifiers = []
                            for (j = 0; j < reslt.rows.length; j++) {
                                var modifrow = reslt.rows.item(j);
                                var modif = new Object();
                                modif.cartid = modifrow.cartid;
                                modif.modifiergrpunkid = modifrow.modifiergrpitemunkid;
                                modif.modifieritemunkid = modifrow.modifierunkid;
                                modif.modifieritemname = modifrow.modifiername;
                                modif.modifieritem_code = modifrow.modifiername;
                                modif.unitid = modifrow.modifierunitunkid;
                                modif.unitname = modifrow.modifierunitname;
                                modif.modifieritemprice = modifrow.modifiergrpitemprice;
                                modif.modifiertype = modifrow.modifiertype;
                                $rootScope.cartmodifiers.push(modif);

                                if (j == reslt.rows.length - 1) {
                                    itemobj.modifierunkid = $rootScope.cartmodifiers;
                                    ngCart.addItem(itemobj.cartid, itemobj.name, itemobj.price, itemobj.quantity, itemobj);
                                    $rootScope.cartcounter++;
                                    $rootScope.cartmodifiers = [];
                                }
                            }
                        } else {
                            itemobj.modifierunkid = [];
                            ngCart.addItem(itemobj.cartid, itemobj.name, itemobj.price, itemobj.quantity, itemobj);
                            $rootScope.cartcounter++;
                        }
                    },
                    $rootScope.dbErrorHandler
                );
            }
        );
    }

    $rootScope.getCustomerOrders = function() {
        var orderArray = [];
        var last = 0;
        var foodcart = document.querySelector('food-cart');
        var allorderfoodcart = document.querySelector('All-Order-Record');
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('SELECT orderunkid, Tableno, orderno, orderdate, orderplacedtime, totalbillamount, israted FROM customer_order_master ORDER BY orderunkid DESC LIMIT 0, 5', [],
                    function(transaction, result) {
                        if (result.rows.length > 0) {
                            for (var i = 0; i < result.rows.length; i++) {
                                orderArray.push(result.rows.item(i));
                                last = result.rows.item(i).orderunkid;
                                if (i == 0) {
                                    foodcart.Lastorderid = last;
                                }
                            }
                            foodcart.orderlist = orderArray;
                            allorderfoodcart.orderlist = orderArray;
                        }
                    },
                    this.errorHandler
                );
            }
        );
    }

    $rootScope.custHistory = function(data) {
        for (i = 0; i < data.length; i++) {
            Itemid = data[i]['_id'];
            Itemname = data[i]['_name'];
            Itemprice = data[i]['_price'];
            Idmgpcode = data[i]['_quantity'],
                Idmnuitemcode = '',
                Idmnuitemtype = '',
                Idunitid = data[i]['_data'][0]['unitid'];
            Idunitname = data[i]['_data'][0]['unit'];
            Idunitprice = data[i]['_price'];
            modiObj = data[i]['_data'][0]['modifierunkid'];
            orderSeq = 0;
            remark = '';
            custom = data[i]['_data'][0]['cartid'];
            rating = data[i]['_data'][0]['rating'];
            //  alert(custom)
            isordered = data[i]['_data'][0]['isordered'];
            $rootScope.addToCart1(Itemid, Itemname, Itemprice, Idmgpcode, Idmnuitemcode, Idmnuitemtype, Idunitid, Idunitname, Idunitprice, modiObj, orderSeq, remark, custom, isordered, rating);
        }
    }

    $rootScope.addToCart1 = function(Itemid, Itemname, Itemprice, Idmgpcode, Idmnuitemcode, Idmnuitemtype, Idunitid, Idunitname, Idunitprice, modiObj, orderSeq, remark, custom, isordered, rating) {
        var Cartlastid = '';
        var fullDate = new Date();
        var twoDigitMonth = ((fullDate.getMonth().length + 1) === 1) ? (fullDate.getMonth() + 1) : '0' + (fullDate.getMonth() + 1);
        var twoDigitDate = fullDate.getDate() + "";
        if (twoDigitDate.length == 1) twoDigitDate = "0" + twoDigitDate;
        var currentDate = twoDigitMonth + "/" + twoDigitDate + "/" + fullDate.getFullYear();
        var modilength = modiObj.length;

        this.db.transaction(
            function(transaction) {
                transaction.executeSql('insert into cart_master (menugrpitemunkid, menugrpitemname, menugrpitemprice, qty, customerunkid, restaurantunkid, totalqtyprice, cartorderdate, tableno, ismodifier, menugrpcode, menuitemcode, menuitemtype, menuitemremark, iscustomremark, unitid, unitname, unitprice, orderSeq, isordered, orderunkid, ratings) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [Itemid, Itemname, parseFloat(Itemprice, 10), Idmgpcode, getcustid, getrestid, parseFloat(Idunitprice, 10) * 1, currentDate, gettableno, 1, Idmgpcode, Idmnuitemcode, Idmnuitemtype, remark, custom, Idunitid, Idunitname, Idunitprice, orderSeq, isordered, custom, rating],
                    function(tr, re) {
                        Cartlastid = re.insertId;

                        if (modilength != 0) {
                            var totalamtmodi = 0;
                            for (var i = 0; i < modiObj.length; i++) {
                                var mgrpid = modiObj[i]['modifiergrpunkid'];
                                var mitemid = modiObj[i]['modifieritemunkid'];
                                var modifierunitunkid = modiObj[i]['unitid'];
                                var modifierunitname = modiObj[i]['unitname'];
                                var mitmPrice = modiObj[i]['modifieritemprice'];
                                var mitemname = modiObj[i]['modifieritemname'];
                                var mitemcode = modiObj[i]['modifieritem_code'];
                                var mitemtype = modiObj[i]['modifiertype']

                                totalamtmodi += parseFloat(mitmPrice, 10);

                                transaction.executeSql('insert into carttrans_master (cartid, modifierunkid, modifiergrpitemunkid, modifiername, modifiergrpitemprice, modiitemcode, modiitemtype, modifierunitunkid, modifierunitname) values (?, ?, ?, ?, ?, ?, ?, ?, ?)', [Cartlastid, mitemid, mgrpid, mitemname, mitmPrice, mitemcode, mitemtype, modifierunitunkid, modifierunitname],
                                    function(transac, reslt) {

                                    },
                                    $rootScope.dbErrorHandler
                                );

                            }
                            var totalamt = parseFloat(Itemprice, 10) + totalamtmodi;
                            transaction.executeSql('update cart_master set totalqtyprice = ? where cartid = ?', [totalamt, Cartlastid],
                                function(t, r) {
                                    $rootScope.TotalItems(this.showItem);
                                },
                                $rootScope.dbErrorHandler
                            );
                        }
                    },
                    $rootScope.dbErrorHandler
                );
            });
    }

    $rootScope.customerOrderHistory = function(allorderdata) {
        var orders = allorderdata;
        var orderhistorylist = [];
        var itemhistorylist = [];
        var modifierhistorylist = [];

        this.db.transaction(
            function(transaction) {
                transaction.executeSql('CREATE TABLE IF NOT EXISTS customer_order_master (orderunkid INTEGER, customerunkid INTEGER, restaurantunkid INTEGER, Tableno INTEGER, orderno TEXT, orderdate DATETIME, orderplacedtime DATETIME, orderexecuteddatetime DATETIME, contactemail TEXT, totalbillamount REAL, ordercomments TEXT, orderstatus TEXT, israted INTEGER );', [],
                    function(transaction, results) { /*console.log("order_master Successfully Created")*/ },
                    function(transaction, error) { /*console.log("order_master fail")*/ }
                );

                transaction.executeSql('CREATE TABLE IF NOT EXISTS customer_ordertrans_master (ordertransunkid INTEGER, orderunkid INTEGER, menugrpitemunkid INTEGER, menugrpitemname TEXT, menugrpitemprice REAL, modifierparentid INTEGER, menugrpitemdiscamount REAL, menugrpitemtaxamount REAL, itemquantity INTEGER, itemtotalamount INTEGER, menugrpcode INTEGER, menuitemcode INTEGER, menuitemtype TEXT, menuitemremark TEXT, unitid INTEGER, unitname TEXT, unitprice REAL);', [],
                    function(transaction, results) { /*console.log("ordertrans_master Successfully Created")*/ },
                    function(transaction, error) { /*console.log("ordertrans_master Fail")*/ }
                );

                transaction.executeSql('DELETE from sqlite_sequence', [],
                    function(transaction, results) { /*console.log("ordertrans_master Successfully Created")*/ },
                    function(transaction, error) { /*console.log("ordertrans_master Fail")*/ }
                );
            }
        );

        if (orders.order_master.length > 0) {
            for (i = 0; i < orders.order_master.length; i++) {
                var ordr = new Object();
                ordr.orderunkid = orders.order_master[i].orderunkid;
                ordr.customerunkid = orders.order_master[i].customerunkid;
                ordr.restaurantcode = 0;
                ordr.Tableno = 0; // orders.order_master[i].Tableno;
                ordr.orderno = orders.order_master[i].orderno;
                ordr.orderdate = ''; // orders.order_master[i].orderdate;
                ordr.orderplacedtime = ''; // orders.order_master[i].orderplacedtime;
                ordr.orderexecuteddatetime = ''; // orders.order_master[i].orderexecuteddatetime;
                ordr.contactemail = ''; // orders.order_master[i].contactemail;
                ordr.totalbillamount = orders.order_master[i].totalbillamount;
                ordr.ordercomments = ''; // orders.order_master[i].ordercomments;
                ordr.orderstatus = ''; // orders.order_master[i].orderstatus;
                ordr.israted = orders.order_master[i].ratingflag;
                orderhistorylist.push(ordr);
                this.addToCustomer_order(ordr);
            }

            if (orders.order_transaction.length > 0) {
                for (j = 0; j < orders.order_transaction.length; j++) {
                    var itm = new Object();
                    itm.ordertransunkid = orders.order_transaction[j].ordertransunkid;
                    itm.orderunkid = orders.order_transaction[j].orderunkid;
                    itm.menugrpitemunkid = orders.order_transaction[j].menugrpitemunkid;
                    itm.menugrpitemname = orders.order_transaction[j].menugrpitemname;
                    itm.menugrpitemprice = orders.order_transaction[j].menugrpitemprice;
                    itm.modifierparentid = orders.order_transaction[j].modifierparentid;
                    itm.menugrpitemdiscamount = 0;
                    itm.menugrpitemtaxamount = 0;
                    itm.itemquantity = orders.order_transaction[j].itemquantity;
                    itm.itemtotalamount = orders.order_transaction[j].itemtotalamount;
                    itm.menugrpcode = 0;
                    itm.menuitemcode = 0;
                    itm.menuitemtype = 0;
                    itm.menuitemremark = '';
                    itm.unitid = 0;
                    itm.unitname = orders.order_transaction[j].unitname;
                    itm.unitprice = orders.order_transaction[j].unitprice;

                    if (itm.modifierparentid == 0) {
                        itemhistorylist.push(itm);
                    } else {
                        modifierhistorylist.push(itm);
                    }

                    this.addToCustomer_order_transaction(itm);
                }
            }
        }
    }

    $rootScope.addToCustomer_order = function(ordr) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('insert into order_master (orderunkid, customerunkid, restaurantunkid, Tableno, orderno, orderdate, orderplacedtime, orderexecuteddatetime, contactemail,totalbillamount, ordercomments, orderstatus, israted) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 0)', [parseInt(ordr.orderunkid), parseInt(ordr.customerunkid), parseInt(ordr.restaurantunkid), parseInt(ordr.Tableno), ordr.orderno, ordr.orderdate, ordr.orderplacedtime, ordr.orderexecuteddatetime, ordr.contactemail, parseFloat(ordr.totalbillamount), ordr.ordercomments, ordr.orderstatus],
                    function(transaction, results) {},
                    function(transaction, error) {
                        console.log(error);
                    }
                );
            }
        );
    }

    $rootScope.addToCustomer_order_transaction = function(ordr_trans) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('insert into ordertrans_master (ordertransunkid, orderunkid, menugrpitemunkid, menugrpitemname, menugrpitemprice, modifierparentid, menugrpitemdiscamount,  menugrpitemtaxamount, itemquantity, itemtotalamount, menugrpcode, menuitemcode, menuitemtype, menuitemremark, unitid, unitname, unitprice) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [parseInt(ordr_trans.ordertransunkid), parseInt(ordr_trans.orderunkid), parseInt(ordr_trans.menugrpitemunkid), ordr_trans.menugrpitemname, parseFloat(ordr_trans.menugrpitemprice), parseInt(ordr_trans.modifierparentid), parseFloat(ordr_trans.menugrpitemdiscamount), parseFloat(ordr_trans.menugrpitemtaxamount), parseInt(ordr_trans.itemquantity), parseFloat(ordr_trans.itemtotalamount), ordr_trans.menugrpcode, ordr_trans.menuitemcode, ordr_trans.menuitemtype, ordr_trans.menuitemremark, parseInt(ordr_trans.unitid), ordr_trans.unitname, ordr_trans.unitprice],
                    function(transaction, results) {},
                    function(transaction, error) {
                        console.log(error);
                    }
                );
            }
        );
    }

    $rootScope.rateOrder = function(orderunkid) {
        this.db.transaction(
            function(transaction) {
                transaction.executeSql('update order_master set israted = 1 where orderunkid = ?', [parseInt(orderunkid)],
                    function(transaction, result) {},
                    function(transaction, error) {}
                );
            }
        );
    }

    $rootScope.GetCurrentDate = function() {
        var fullDate = new Date();
        var twoDigitMonth = ((fullDate.getMonth().length + 1) === 1) ? (fullDate.getMonth() + 1) : '0' + (fullDate.getMonth() + 1);
        var twoDigitDate = fullDate.getDate() + "";
        if (twoDigitDate.length == 1) twoDigitDate = "0" + twoDigitDate;
        var currentDate = twoDigitMonth + "/" + twoDigitDate + "/" + fullDate.getFullYear();

        return currentDate;
    }


    $rootScope.GetCurrentTime = function() {
        var fullDate = new Date();
        var twoDigitHour = fullDate.getHours() + "";
        if (twoDigitHour.length == 1) twoDigitHour = "0" + twoDigitHour;
        var twoDigitMint = fullDate.getMinutes() + "";
        if (twoDigitMint.length == 1) twoDigitMint = "0" + twoDigitMint;
        var twoDigitSec = fullDate.getSeconds() + "";
        if (twoDigitSec.length == 1) twoDigitSec = "0" + twoDigitSec;
        var CurrentTime = twoDigitHour + ":" + twoDigitMint + ":" + twoDigitSec; //Get Current Time

        return CurrentTime;
    }

    $rootScope.connect = function(host) {
        if (typeof ws != "undefined") {
            ws.close();
            $rootScope.burrpConnection = 0;
        }

        ws = new WebSocket(host);
        ws.onopen = function() {
            ws.send('Connected');
           // console.log("Request sent.");
            $rootScope.burrpConnection = 1;
        };

        ws.onclose = function(msg) {

            // if (msg.code == 1000)
            //     reason = "1000 - Normal closure, meaning that the purpose for which the connection was established has been fulfilled.";
            // else if(msg.code == 1001)
            //     reason = "1001 - An endpoint is \"going away\", such as a server going down or a browser having navigated away from a page.";
            // else if(msg.code == 1002)
            //     reason = "1002 - An endpoint is terminating the connection due to a protocol error";
            // else if(msg.code == 1003)
            //     reason = "1003 - An endpoint is terminating the connection because it has received a type of data it cannot accept (e.g., an endpoint that understands only text data MAY send this if it receives a binary message).";
            // else if(msg.code == 1004)
            //     reason = "1004 - Reserved. The specific meaning might be defined in the future.";
            // else if(msg.code == 1005)
            //     reason = "1005 - No status code was actually present.";
            // else if(msg.code == 1006)
            //    reason = "1006 - The connection was closed abnormally, e.g., without sending or receiving a Close control frame";
            // else if(msg.code == 1007)
            //     reason = "1007 - An endpoint is terminating the connection because it has received data within a message that was not consistent with the type of the message (e.g., non-UTF-8 [http://tools.ietf.org/html/rfc3629] data within a text message).";
            // else if(msg.code == 1008)
            //     reason = "1008 - An endpoint is terminating the connection because it has received a message that \"violates its policy\". This reason is given either if there is no other sutible reason, or if there is a need to hide specific details about the policy.";
            // else if(msg.code == 1009)
            //    reason = "1009 - An endpoint is terminating the connection because it has received a message that is too big for it to process.";
            // else if(msg.code == 1010)
            //     reason = "1010 - An endpoint (client) is terminating the connection because it has expected the server to negotiate one or more extension, but the server didn't return them in the response message of the WebSocket handshake. <br /> Specifically, the extensions that are needed are: " + event.reason;
            // else if(msg.code == 1011)
            //     reason = "1011 - A server is terminating the connection because it encountered an unexpected condition that prevented it from fulfilling the request.";
            // else if(msg.code == 1015)
            //     reason = "1015 - The connection was closed due to a failure to perform a TLS handshake (e.g., the server certificate can't be verified).";
            // else
            //     reason = msg.code + " - Unknown reason";

            // ionicToast.show(reason, 'top', false, $rootScope.messagetimeout*2, '');
            console.log('Disconnected');
            if (ws != undefined)
                ws.close();
            ws = undefined;
            $rootScope.burrpConnection = 0;
        };

        ws.onerror = function(error) {
            console.log(error)
            console.log("Error..");
            ws.close();
            ws = undefined;
        };

        ws.onmessage = function(event) {
            console.log("message")
        };
    }

    $rootScope.wsOnMessage = function() {
        ws.onmessage = function(evt) {
            console.log('received data:' + evt.data + "\n");
        };
    }

    $rootScope.socketclose = function() {
        if (typeof ws != "undefined") {
            ws.close();
            ws = undefined;
            $rootScope.burrpConnection = 0;
        }
    }

    $rootScope.ReconnectWithiMonitor = function(popup) {

        ws = undefined;
        posip = window.localStorage.getItem('POSip');
        posport = window.localStorage.getItem('POSport');
        if ('WebSocket' in window) {
            this.connect("ws://" + posip + ":" + posport + "/");
        }

        if (ws.readyState == 0) {
            $rootScope.burrpConnection = 0;
            return 0;
        } else if (ws.readyState == 1) {
            $rootScope.burrpConnection = 1;
            return 1;
        } else if (ws.readyState == 2) {
            ws = undefined;
            ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
            $rootScope.burrpConnection = 0;
            return 2;
        } else if (ws.readyState == 3) {
            ws = undefined;
            ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
            $rootScope.burrpConnection = 0;
            return 3;
        }
    }

    $rootScope.isJson = function(str) {
        try {
            JSON.parse(str);
        } catch (e) {
            return false;
        }
        return true;
    }

    $rootScope.sendMessage = function(message) {

        if (typeof ws == "undefined") {
            posip = window.localStorage.getItem('POSip');
            posport = window.localStorage.getItem('POSport');

            if ('WebSocket' in window) {
                console.log("ws://" + posip + ":" + posport + "/")
                this.connect("ws://" + posip + ":" + posport + "/");
            }

            setTimeout(function() {
                $rootScope.sendMessage(message);
            }, 1000);
        } else {
            if (message == "Close") {
                ws.close();
                ws = undefined;
                $rootScope.burrpConnection = 0;
                return 0;
            }
            if (message == "Reconnect") {
                ws.close();
                posip = window.localStorage.getItem('POSip');
                posport = window.localStorage.getItem('POSport');
                this.connect("ws://" + posip + ":" + posport + "/");
                setTimeout(function() {
                    $rootScope.sendMessage("Connected");
                }, 1000);
            } else if (message == "Connected") {
                if (ws.readyState == 0) {
                    $rootScope.burrpConnection = 0;
                    if ($rootScope.languageLabels.MESSAGE != undefined)
                        ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
                    else {
                        setTimeout(function() {
                            ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
                        }, 5000)
                    }
                    return 0;
                } else if (ws.readyState == 1) {
                    $rootScope.burrpConnection = 1;
                    return 1;
                } else if (ws.readyState == 2) {
                    ws = undefined;
                    ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
                    $rootScope.burrpConnection = 0;
                    return 2;
                } else if (ws.readyState == 3) {
                    ws = undefined;
                    ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
                    $rootScope.burrpConnection = 0;
                    return 3;
                }
            } else {
                if (ws.readyState == 0) {
                    setTimeout(function() {
                        $rootScope.sendingOrderPopup.close();
                        ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
                    }, 100)
                } else if (ws.readyState == 1) {
                    var accept_imonitor_request = 1;
                    var imonitorresponse = 0;
                    ws.send(JSON.stringify(message));
                    var msgflag = null;

                    $timeout(function() {
                        if (imonitorresponse == 0) {
                            $rootScope.orderSendingMesssage = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg83);
                        }
                    }, 30000);

                    $timeout(function() {
                        $rootScope.burrpConnection = 1;
                        accept_imonitor_request = 0;
                        if (imonitorresponse == 0) {
                            $rootScope.orderSendingMesssage = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg84);
                            $timeout(function() {
                                $rootScope.sendingOrderPopup.close();
                                ionicToast.show($rootScope.orderSendingMesssage, 'top', false, $rootScope.messagetimeout, '');
                            }, 2000);
                        }
                    }, 60000);

                    ws.onmessage = function(evt) {
                        if (message[0].command_id == '1001') {
                            if (accept_imonitor_request == 1) {
                                imonitorresponse = 1;
                                $rootScope.burrpConnection = 1;
                                window.localStorage.setItem('orderflag', '1');

                                if ($rootScope.isJson(evt.data)) {
                                    msgflag = evt.data;
                                    window.localStorage.setItem('orderMSG', msgflag);
                                    if (evt.data != null) {
                                        var locordstr = window.localStorage.getItem('orderMSG');
                                        var locjsnstr = JSON.parse(locordstr);

                                        var IdOrdFlag = locjsnstr['code'];

                                        if (IdOrdFlag != "000") {

                                            var errormsg = '';
                                            if (IdOrdFlag == "001")
                                                errormsg = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg74); //  Outlet not configured
                                            else if (IdOrdFlag == "002")
                                                errormsg = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg62); //  Table not found
                                            else if (IdOrdFlag == "003")
                                                errormsg = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg63); //  Item not found
                                            else if (IdOrdFlag == "004")
                                                errormsg = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg61); //  Unit not found
                                            else {
                                                errormsg = locjsnstr['description'];
                                            }

                                            setTimeout(function() {
                                                $rootScope.sendingOrderPopup.close();
                                            }, 900);

                                            setTimeout(function() {
                                                ionicToast.show(errormsg, 'top', false, $rootScope.messagetimeout, '');
                                            }, 1000);
                                        }
                                        if (IdOrdFlag == "000") {
                                            if (message[0].command_id == "1001") {

                                                $rootScope.orderSendingMesssage = $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg60);
                                                window.localStorage.setItem("guestcomment", '');
                                                window.localStorage.setItem("guestdetailchoice", '');
                                                window.localStorage.setItem('orderMSG', '');
                                                $rootScope.cartToOrder();
                                                //$rootScope.DeleteExtraOrderFromCart();

                                                for (var i = 0; i < ngCart.getItems().length; i++) {
                                                    if (ngCart.getItems()[i]._data.isordered == 0) {
                                                        ngCart.getItems()[i]._data.isordered = 1;
                                                        ngCart.getItems()[i]._data.rating = 1;
                                                        ngCart.getItems()[i]._data.orderunkid = window.localStorage.getItem("Lastorderid");
                                                    }
                                                }

                                                var allordr = [];
                                                var obj = new Object;
                                                obj.orderunkid = window.localStorage.getItem("Lastorderid");
                                                obj.tableno = window.localStorage.getItem("TableNumber");
                                                obj.israted = 0;

                                                if (window.localStorage.getItem("orderunkid_array") != null && window.localStorage.getItem("orderunkid_array") != "null" && window.localStorage.getItem("orderunkid_array").length > 0) {
                                                    allordr = JSON.parse(window.localStorage.getItem("orderunkid_array"));
                                                    allordr.push(obj);
                                                } else {
                                                    allordr.push(obj);
                                                }
                                                window.localStorage.setItem("orderunkid_array", JSON.stringify(allordr));

                                                setTimeout(function() {
                                                    $timeout(function() {
                                                        $rootScope.sendingOrderPopup.close();
                                                    }, 3000)
                                                    $state.go("app.myOrders", {});
                                                    $rootScope.cartcounter = 0;
                                                }, 1000)

                                                setTimeout(function() {
                                                    $rootScope.sendingOrderPopup.close();
                                                }, 2000)
                                            } else if (message[0].command_id == "2001") {
                                                setTimeout(function() {
                                                    $rootScope.sendingOrderPopup.close();
                                                    if (message[0].message == "Waiter call")
                                                        ionicToast.show("Waiter Request Sent.", 'top', false, $rootScope.messagetimeout, '');
                                                    else if (message[0].message == "Bill call")
                                                        ionicToast.show("Bill Request Sent.", 'top', false, $rootScope.messagetimeout, '');
                                                }, 1000)
                                            }
                                        } else if (IdOrdFlag == "001") {
                                            return false;
                                        } else if (IdOrdFlag == "002") {
                                            return false;
                                        } else if (IdOrdFlag == "003") {
                                            return false;
                                        } else if (IdOrdFlag == "004") {
                                            return false;
                                        } else {
                                            return false;
                                        }
                                    } else {
                                        $rootScope.sendingOrderPopup.close();
                                        ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
                                    }
                                } else {
                                    $rootScope.sendingOrderPopup.close();
                                    ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
                                }
                            } else {
                                ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg52), 'top', false, $rootScope.messagetimeout, '');
                            }
                        } else if (message[0].command_id == '2001') {
                            $rootScope.sendingOrderPopup.close();
                            if (message[0].message == "Waiter call") {
                                ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.LABEL.lbl169), 'top', false, $rootScope.messagetimeout, '');
                            } else if (message[0].message == "Bill call") {
                                ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.LABEL.lbl170), 'top', false, $rootScope.messagetimeout, '');
                            }
                        }
                    }
                } else if (ws.readyState == 2) {
                    console.log("2")
                } else if (ws.readyState == 3) {
                    console.log("3")
                }
            }
        }
    }

    $rootScope.connectserver = function() {
        posip = window.localStorage.getItem('POSip');
        posport = window.localStorage.getItem('POSport');
        if (posip == null || posip == " " || posip == '' || posip == undefined) {
            window.localStorage.setItem('socketstat', '0');
        } else {
            if (posport == null || posport == " " || posport == '' || posport == undefined || posport == "undefined") {
                window.localStorage.setItem('socketstat', '0');
            } else {
                if ('WebSocket' in window) {
                    this.connect("ws://" + posip + ":" + posport + "/");
                }
            }
        }
    }
})

.run(function($ionicPlatform, $rootScope, $cordovaFile, $ionicHistory, $cordovaNetwork, ngCart, $timeout, sharedProperties, $ionicPopup, ionicToast, $http) {

    $rootScope.isbouncy = false;
    $rootScope.messagetimeout = 2500;
    $rootScope.alertMessage = function(message) {
        var myPopup = $ionicPopup.show({
            template: message,
            cssClass: 'custompopup',
            title: $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg16),
            buttons: [{
                text: $rootScope.utf8_decode($rootScope.languageLabels.LABEL.lbl146),
                onTap: function(e) {}
            }]
        });
    }

    $rootScope.orderSendingMesssage = '';
    $rootScope.cartcounter = 0;
    $rootScope.noitem = 0;
    $rootScope.burrpConnection = 0;
    $rootScope.burrpmode = (window.localStorage.getItem("isburrp") == 'true' || window.localStorage.getItem("isburrp") == true) ? true : false;
    if (window.localStorage.getItem("orderchoice") == true || window.localStorage.getItem("orderchoice") == "true") {
        $rootScope.orderingmode = true;
    } else
        $rootScope.orderingmode = false;

    $rootScope.height = (Math.floor((window.innerHeight) * (0.9)) * 0.60);

    if (Math.floor(window.innerHeight) < 600)
        $rootScope.height = 300;
    else if (Math.floor(window.innerHeight) < 800)
        $rootScope.height = 450;
    else if (Math.floor(window.innerHeight) >= 800)
        $rootScope.height = 600;
    // css =  '.tablepopup ion-scroll, .waiterpopup ion-scroll, .popuptablewaiter ion-scroll, .remarkpopup ion-scroll{max-height: '+ $rootScope.height +'px;}',
    css = '.tablepopup ion-scroll, .waiterpopup ion-scroll, .popuptablewaiter ion-scroll, .remarkpopup ion-scroll, .ratings ion-scroll{min-height: ' + $rootScope.height + 'px; max-height: ' + $rootScope.height + 'px;}',

        head = document.head || document.getElementsByTagName('head')[0],
        style = document.createElement('style');

    style.type = 'text/css';
    if (style.styleSheet) {
        style.styleSheet.cssText = css;
    } else {
        style.appendChild(document.createTextNode(css));
    }
    head.appendChild(style);

    $rootScope.languageLabels = [];
    $ionicHistory.clearCache();
    if ((localStorage.getItem("isburrp") == true || localStorage.getItem("isburrp") == "true") && (localStorage.getItem("startorder") == true || localStorage.getItem("startorder") == "true")) {
        $rootScope.sendMessage("Connected");
    }
    ngCart.empty();

    window.localStorage.setItem("cartitems", '');
    $rootScope.initCartDB();
    $rootScope.lastCartId = 0;
    $rootScope.getCartId();
    if (window.localStorage['restusrname'] != undefined && window.localStorage['restaurantcode'] != undefined && window.localStorage['restusrname'] != '' && window.localStorage['restaurantcode'] != '') {
        $rootScope.LoadCart();
    } else
        $rootScope.droprecreate();

    $rootScope.displinks = {
        myorderdisp: false,
        feedbackdisp: false,
        syncdisp: false,
        aboutusdisp: false,
        helpdisp: false
    };
    //$rootScope.SERVER_IMAGE_PATH = 'http://192.168.20.157/imenuconfig/upload/';
    //$rootScope.SERVICE_PATH = 'http://192.168.20.157/eMenu/service/v14/login.php';
    //$rootScope.menu_path = 'http://192.168.20.157/imenuconfig/upload/menugroup/';
    //$rootScope.item_path = 'http://192.168.20.157/imenuconfig/upload/item/';
    //$rootScope.other_path = 'http://192.168.20.157/imenuconfig/upload/banner/';
    //$rootScope.logo_path = 'http://192.168.20.157/imenuconfig/upload/logos/';
    //$rootScope.SERVER_PATH = 'http://192.168.20.157/imenuconfig/imservices/v11/';

    $rootScope.SERVICE_PATH = 'http://imenu9.com/imenu/services/v14/login.php';
    $rootScope.SERVER_IMAGE_PATH = 'http://imenu9.com/v2/upload/';
    $rootScope.SERVER_PATH = 'http://imenu9.com/v2/imservices/v11/';
    $rootScope.menu_path = 'http://imenu9.com/v2/upload/menugroup/';
    $rootScope.item_path = 'http://imenu9.com/v2/upload/item/';
    $rootScope.other_path = 'http://imenu9.com/v2/upload/banner/';
    $rootScope.logo_path = 'http://imenu9.com/v2/upload/logos/';
    $rootScope.total_image = 0;
    $rootScope.counter = 0;

    // <ion-spinner icon="bubbles"></ion-spinner>

    $rootScope.openLoading = function() {
        $rootScope.routingPopup = $ionicPopup.show({
            template: '<img src="img/359.GIF">',
            cssClass: 'routingLoader',
        });
    }

    $rootScope.colorset = function() {
        var theme = (window.localStorage['theme'] == '' || window.localStorage['theme'] == undefined) ? '#3f4392' : window.localStorage['theme'];
        if (window.localStorage['theme'] == undefined) {
            var theme1 = ColorLuminance('#3f4392', -0.4);
        } else {
            var theme1 = ColorLuminance(theme, -0.4);
        }

        var css = '.pickadate-cell .pickadate-active,.button.button-dark,.bar.bar-assertive ,.toggle input:checked + .track ,ion-header-bar.bar-header.bar.bar-stable,.button.button-positive,.button.button-positive.activated,.checkbox input:checked:before, .checkbox input:checked + .checkbox-icon:before, .platform-ios ion-header-bar.bar-header.bar.bar-stable, .platform-ios.platform-cordova:not(.fullscreen) .bar-header:not(.bar-subheader)  { background: ' + theme + ';border-color: ' + theme + '; }',
            css = css + '.menugroupitem .itemmodifier, .menugroupitem .itemunit,.mitemcard .itemprice,.homenav .button i,.themecolor,.custompopup .popup .popup-buttons .button.button-positive, .order_remarks, .lastorder, .orderhistory, .navigation i{ color: ' + theme + '; }',
            css = css + '.button.button-positive.button-outline ,.item-radio .radio-icon, .waiterbill i { color: ' + theme + '; border-color: ' + theme + '; }',
            css = css + '.imenulogin_outer .button.button-positive { background: #3f4392; }',
            css = css + '.imhrtabs a:hover, .imhrtabs a:active, .imhrtabs a:focus, .imhrtabs a.active, .imhrtabs a.activated, .imhrdiv,  .imhrtabs a:hover, .imhrtabs a:active, .imhrtabs a:focus,.searchdivmenuitem,.searchdiv, .imhrtabs,.themebgcolor, .ar .btn_imonitor .connection_problem, .btn_imonitor .connection_problem, .loadspan{  background: ' + theme + '; }',
            css = css + '.themebordercolor, .waiterbill i{border-color: ' + theme + '; }',
            css = css + '.spinner svg{stroke: ' + theme + '; fill: ' + theme + ';}',
            css = css + '.customerloginsignup .popup .active{border-bottom: solid 3px ' + theme + ';}',
            css = css + '.customersignuplogin{color: ' + theme + '; background: #fff; border-color: ' + theme + '}',
            css = css + '.mgcardbox .item .counter{background: ' + theme + '; color: #fff}',

            head = document.head || document.getElementsByTagName('head')[0],
            style = document.createElement('style');

        style.type = 'text/css';
        if (style.styleSheet) {
            style.styleSheet.cssText = css;
        } else {
            style.appendChild(document.createTextNode(css));
        }
        head.appendChild(style);
    }

    function ColorLuminance(hex, lum) {
        // validate hex string
        hex = String(hex).replace(/[^0-9a-f]/gi, '');
        if (hex.length < 6) {
            hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2];
        }
        lum = lum || 0;

        var rgb = "#",
            c, i;
        for (i = 0; i < 3; i++) {
            c = parseInt(hex.substr(i * 2, 2), 16);
            c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
            rgb += ("00" + c).substr(c.length);
        }
        return rgb;
    }

    $rootScope.getConnectionFlag = function() {
        var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
        if (phonegapapp) {
            var flg = $cordovaNetwork.isOnline();
            if (flg)
                return true;
            else {
                var network = $cordovaNetwork.getNetwork();
                if (network == Connection.NONE) {
                    ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg48), 'top', false, $rootScope.messagetimeout, '');
                } else
                    return true;
            }
        } else {
            return true;
        }
    };

    $rootScope.utf8_decode = function(str_data) {
        var tmp_arr = [],
            i = 0,
            ac = 0,
            c1 = 0,
            c2 = 0,
            c3 = 0,
            c4 = 0;

        str_data += '';

        while (i < str_data.length) {
            c1 = str_data.charCodeAt(i);
            if (c1 <= 191) {
                tmp_arr[ac++] = String.fromCharCode(c1);
                i++;
            } else if (c1 <= 223) {
                c2 = str_data.charCodeAt(i + 1);
                tmp_arr[ac++] = String.fromCharCode(((c1 & 31) << 6) | (c2 & 63));
                i += 2;
            } else if (c1 <= 239) {
                // http://en.wikipedia.org/wiki/UTF-8#Codepage_layout
                c2 = str_data.charCodeAt(i + 1);
                c3 = str_data.charCodeAt(i + 2);
                tmp_arr[ac++] = String.fromCharCode(((c1 & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            } else {
                c2 = str_data.charCodeAt(i + 1);
                c3 = str_data.charCodeAt(i + 2);
                c4 = str_data.charCodeAt(i + 3);
                c1 = ((c1 & 7) << 18) | ((c2 & 63) << 12) | ((c3 & 63) << 6) | (c4 & 63);
                c1 -= 0x10000;
                tmp_arr[ac++] = String.fromCharCode(0xD800 | ((c1 >> 10) & 0x3FF));
                tmp_arr[ac++] = String.fromCharCode(0xDC00 | (c1 & 0x3FF));
                i += 4;
            }
        }
        return tmp_arr.join('');
    };

    // $ionicPlatform.ready(function() {

    //     if (window.cordova && window.cordova.plugins.Keyboard) {
    //     cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    //     }
    //     if (window.StatusBar) {}
    // });

    document.addEventListener('deviceready', function() {

        var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
        if (phonegapapp) {
            if (device.platform == 'iOS') {
                localStorage.setItem('registrationid', "");
            }
            $rootScope.d_uuid = device.uuid;
            $rootScope.d_platform = device.platform;
            $rootScope.d_model = device.model;
            $rootScope.d_version = device.version;
        } else {
            $rootScope.d_uuid = "test";
            $rootScope.d_platform = "eZee";
            $rootScope.d_model = "eZee-1234";
            $rootScope.d_version = "1.2.3";
        }

        if (window.localStorage.getItem("restid") != null && window.localStorage.getItem("restid") != 'null') {

            var res = $http.get($rootScope.SERVICE_PATH, {
                params: {
                    "restaurantcode": window.localStorage.getItem("restid"),
                    "usertype": "track",
                    "request": "login",
                    "uuid": $rootScope.d_uuid,
                    "ip": "",
                    "model": $rootScope.d_model,
                    "version": $rootScope.d_version,
                    "platform": $rootScope.d_platform
                }
            });

            res.success(function(data, status, headers, config) {});
            res.error(function(data, status, headers, config) {});
        }

        $rootScope.logo_path = cordova.file.dataDirectory + "eZee_iMenu/Logo/";
        $rootScope.menu_path = cordova.file.dataDirectory + "eZee_iMenu/Menu/";
        $rootScope.item_path = cordova.file.dataDirectory + "eZee_iMenu/Item/";
        $rootScope.other_path = cordova.file.dataDirectory + "eZee_iMenu/Other/";

        $cordovaFile.createDir(cordova.file.dataDirectory, "eZee_iMenu", false)
            .then(function(success) {
                $cordovaFile.createDir(cordova.file.dataDirectory, "eZee_iMenu/Item", false)
                    .then(function(success) {

                    }, function(error) {});

                $cordovaFile.createDir(cordova.file.dataDirectory, "eZee_iMenu/Menu", false)
                    .then(function(success) {


                    }, function(error) {});

                $cordovaFile.createDir(cordova.file.dataDirectory, "eZee_iMenu/Logo", false)
                    .then(function(success) {


                    }, function(error) {});

                $cordovaFile.createDir(cordova.file.dataDirectory, "eZee_iMenu/Other", false)
                    .then(function(success) {


                    }, function(error) {});


            }, function(error) {
                // error
            });

    });

    // if(window.localStorage.getItem("restid") != null && window.localStorage.getItem("restid") != 'null'){
    //     var res = $http.get($rootScope.SERVICE_PATH, {
    //         params: {
    //             "restaurantcode": window.localStorage.getItem("restid"),
    //             "usertype": "track",
    //             "request": "login",
    //             "uuid": $rootScope.d_uuid,
    //             "ip": "",
    //             "model": $rootScope.d_model,
    //             "version": $rootScope.d_version,
    //             "platform": $rootScope.d_platform
    //         }
    //     });

    //     res.success(function(data, status, headers, config) {
    //     });

    //     res.error(function(data, status, headers, config) {
    //     });
    // }
})

.directive('whenScrolled', function($rootScope) {
    return function(scope, elm, attr) {
        var raw = elm[0];
        //var tmp = window.innerHeight;
        //console.log(tmp / 2)
        elm.bind('scroll', function() {
            if (raw.scrollTop + raw.offsetHeight >= raw.scrollHeight || (raw.scrollHeight - 400) < raw.offsetHeight) {
                scope.$apply(attr.whenScrolled);
            }
        });
    };
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $compileProvider) {

    $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|file|blob|cdvfile|content):|data:image\//);
    $ionicConfigProvider.navBar.alignTitle('left');
    $ionicConfigProvider.views.maxCache(1);
    $ionicConfigProvider.views.transition('android');
    $ionicConfigProvider.views.forwardCache(false);
    // ionic.Platform.isFullScreen = true;
    if (ionic.Platform.isAndroid())
        $ionicConfigProvider.scrolling.jsScrolling(false);
    $ionicConfigProvider.views.swipeBackEnabled(false);
    // $ionicConfigProvider.scrolling.jsScrolling(false);
    $stateProvider
        .state('app', {
            url: "/app",
            cache: false,
            abstract: true,
            templateUrl: "templates/menu.html",
            controller: 'AppCtrl'
        })

    .state('app.mainlogin', {
        url: "/mainlogin",
        cache: false,
        views: {
            'menuContent': {
                templateUrl: "templates/mainlogin.html",
                controller: 'MainLogin'
            }
        }
    })

    .state('app.home', {
        cache: false,
        url: "/home",
        views: {
            'menuContent': {
                templateUrl: "templates/home.html",
                controller: 'Home'
            }
        }
    })

    .state('app.menuGroup', {
        cache: false,
        url: "/menuGroup",
        views: {
            'menuContent': {
                templateUrl: "templates/menuGroup.html",
                controller: 'menuGroup'
            }
        }
    })

    .state('app.menuItem', {
        cache: false,
        url: "/menuItem",
        views: {
            'menuContent': {
                templateUrl: "templates/menuItem.html",
                controller: 'menuItem'
            }
        }
    })

    .state('app.menuItem/:menugroupunkid/:index', {
        cache: false,
        url: "/menuItem/:menugroupunkid/:index",
        views: {
            'menuContent': {
                templateUrl: "templates/menuItem.html",
                controller: 'menuItem'
            }
        }
    })

    .state('app.menuItemSearch', {
        cache: true,
        url: "/menuItemSearch",
        views: {
            'menuContent': {
                templateUrl: "templates/menuItemSearch.html",
                controller: 'menuItemSearch'
            }
        }
    })

    .state('app.itemDetail', {
        cache: false,
        url: "/itemDetail",
        views: {
            'menuContent': {
                templateUrl: "templates/itemDetail.html",
                controller: 'itemDetail'
            }
        }
    })

    .state('app.itemDetail/:menuGroupId/:menuItemId/:index/:qty', {
        cache: false,
        url: "/itemDetail/:menuGroupId/:menuItemId/:index/:qty",
        views: {
            'menuContent': {
                templateUrl: "templates/itemDetail.html",
                controller: 'itemDetail'
            }
        }
    })

    .state('app.itemDetail/:menuGroupId/:menuItemId', {
        cache: false,
        url: "/itemDetail/:menuGroupId/:menuItemId",
        views: {
            'menuContent': {
                templateUrl: "templates/itemDetail.html",
                controller: 'itemDetail'
            }
        }
    })


    .state('app.configuration', {
        cache: false,
        url: "/configuration",
        views: {
            'menuContent': {
                templateUrl: "templates/configuration.html",
                controller: 'configuration'
            }
        }
    })

    .state('app.myOrders', {
        cache: false,
        url: "/myOrders",
        views: {
            'menuContent': {
                templateUrl: "templates/myOrders.html",
                controller: 'myOrders'
            }
        }
    })

    .state('app.aboutUs', {
        cache: false,
        url: "/aboutUs",
        views: {
            'menuContent': {
                templateUrl: "templates/aboutUs.html",
                controller: 'aboutUs'
            }
        }
    })

    .state('app.feedback', {
        cache: false,
        url: "/feedback",
        views: {
            'menuContent': {
                templateUrl: "templates/feedback.html",
                controller: 'feedback'
            }
        }
    })

    .state('app.help', {
        cache: false,
        url: "/help",
        views: {
            'menuContent': {
                templateUrl: "templates/help.html",
                controller: 'help'
            }
        }
    })

    .state('app.foodcart', {
        cache: false,
        url: "/foodcart",
        views: {
            'menuContent': {
                templateUrl: "templates/foodcart.html",
                controller: 'foodcart'
            }
        }
    })

    .state('app.iFeedback', {
        cache: false,
        url: "/iFeedback",
        views: {
            'menuContent': {
                templateUrl: "templates/iFeedback.html",
                controller: 'iFeedback'
            }
        }
    })

    .state('app.customerloginsignup', {
        cache: false,
        url: "/customerloginsignup",
        views: {
            'menuContent': {
                templateUrl: "templates/customerloginsignup.html",
                controller: 'customerloginsignup'
            }
        }
    })
    .state('app.notification', {
        cache: false,
        url: "/notification",
        views: {
            'menuContent': {
                templateUrl: "templates/notification.html",
                controller: 'notification'
            }
        }
    })
    .state('app.menuItemDetailViewOnly', {
        cache: false,
        url: "/menuItemDetailViewOnly",
        views: {
            'menuContent': {
                templateUrl: "templates/menuItemDetailViewOnly.html",
                controller: 'menuItemDetailViewOnly'
            }
        }
    })

    .state('app.menuItemDetailViewOnly/:menuGroupId/:menuItemId/:index/:qty', {
        cache: false,
        url: "/menuItemDetailViewOnly/:menuGroupId/:menuItemId/:index/:qty",
        views: {
            'menuContent': {
                templateUrl: "templates/menuItemDetailViewOnly.html",
                controller: 'menuItemDetailViewOnly'
            }
        }
    })

    .state('app.menuItemDetailViewOnly/:menuGroupId/:menuItemId', {
        cache: false,
        url: "/menuItemDetailViewOnly/:menuGroupId/:menuItemId",
        views: {
            'menuContent': {
                templateUrl: "templates/menuItemDetailViewOnly.html",
                controller: 'menuItemDetailViewOnly'
            }
        }
    });

    if (window.localStorage['restusrname'] == undefined && window.localStorage['restaurantcode'] == undefined) {
        $urlRouterProvider.otherwise('/app/mainlogin');
    } else {
        if (window.localStorage['restusrname'] == "" && window.localStorage['restaurantcode'] == "") {
            $urlRouterProvider.otherwise('/app/mainlogin');
        } else {
            $urlRouterProvider.otherwise('/app/home');
        }
    }
});

angular.module('ionic')
    .factory('$ionicNgClick', ['$parse', '$timeout', function($parse, $timeout) {

        return function(scope, element, clickExpr) {
            var clickHandler = angular.isFunction(clickExpr) ? clickExpr : $parse(clickExpr);

            element.on('click', function(event) {
                scope.$apply(function() {
                    if (scope.clicktimer) return; // Second call
                    clickHandler(scope, {
                        $event: (event)
                    });
                    scope.clicktimer = $timeout(function() {
                        delete scope.clicktimer;
                    }, 1, false);
                });
            });

            // Hack for iOS Safari's benefit. It goes searching for onclick handlers and is liable to click
            // something else nearby.
            element.onclick = function(event) {};
        };
    }]);