//By Rajeshwar Patlolla
//https://github.com/rajeshwarpatlolla/ionic-toast
//rajeshwar.patlolla@gmail.com

'use strict';
angular.module('ionic-toast', ['ionic'])

.run(['$templateCache', function ($templateCache) {
  var toastTemplate = '<div class="ionic_toast" ng-class="ionicToast.toastClass" ng-style="ionicToast.toastStyle" ng-click="hide()">' +
  '<span class="ionic_toast_close" ng-click="hide()"><i class="ion-close-round toast_close_icon"></i></span>' +
  '<span ng-bind-html="ionicToast.toastMessage"></span>' +
  '</div>';

  $templateCache.put('ionic-toast/templates/ionic-toast.html', toastTemplate);
}])

.provider('ionicToast', function () {

  this.$get = ['$compile', '$document', '$interval', '$rootScope', '$templateCache', '$timeout',
  function ($compile, $document, $interval, $rootScope, $templateCache, $timeout) {

    var defaultScope = {
      toastClass: '',
      toastMessage: '',
      toastStyle: {
        display: 'block',
        opacity: 0
      }
    };

    var toastTimeout;

    var toastPosition = {
      topmost: 'ionic_toast_topmost',
      top: 'ionic_toast_top',
      topsearch: 'ionic_toast_top_search',
      topdetail: 'ionic_toast_topdetail',
      middle: 'ionic_toast_middle',
      bottom: 'ionic_toast_bottom'
    };

    var toastScope = $rootScope.$new();
    var toastTemplate = $compile($templateCache.get('ionic-toast/templates/ionic-toast.html'))(toastScope);

    toastScope.ionicToast = defaultScope;

    $document.find('body').append(toastTemplate);

    var toggleDisplayOfToast = function (display, opacity, callback) {
      toastScope.ionicToast.toastStyle = {
        // display: display,
        opacity: opacity
      };
      toastScope.ionicToast.toastStyle.opacity = opacity;
      callback();
    };

    toastScope.hide = function () {
      toggleDisplayOfToast('none', 0, function () {
        // console.log('toast hidden');
      });

      $timeout(function(){
        document.querySelector(".ionic_toast").classList.add("hide-toast")
      }, 200)
    };

    return {
      show: function (message, position, closeBtn, duration, float) {
        if (!message || !position || !duration) return;
        $timeout.cancel(toastTimeout);
        // if(duration > 5000) duration = 5000;

        document.querySelector(".ionic_toast").classList.remove("hide-toast")
        if(position == 'top'){
          document.querySelector(".ionic_toast").classList.add("ionic_toast_top");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_topmost");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_top_search");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_topdetail");
        }
        else if(position == 'topmost'){
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_top");
          document.querySelector(".ionic_toast").classList.add("ionic_toast_topmost");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_top_search");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_topdetail");
        }
        else if(position == 'ionic_toast_top_search'){
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_top");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_topmost");
          document.querySelector(".ionic_toast").classList.add("ionic_toast_top_search");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_topdetail");
        }
        else if(position == 'ionic_toast_topdetail'){
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_top");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_topmost");
          // document.querySelector(".ionic_toast").classList.remove("ionic_toast_top_search");
          document.querySelector(".ionic_toast").classList.add("ionic_toast_topdetail");
        }
        else if(position == 'bottom'){
          document.querySelector(".ionic_toast").classList.add("ionic_toast_bottom");
        }

        angular.extend(toastScope.ionicToast, {
          toastClass: toastPosition[position] + ' ' + (closeBtn ? 'ionic_toast_sticky' : '') + ' ' + ((float == 'left') ? 'toast-left' : '') + ' ' + ((float == 'right') ? 'toast-right' : ''),
          toastMessage: message
        });


        $timeout(function(){
          toggleDisplayOfToast('block', 1, function () {
            if (closeBtn)  return;

            toastTimeout = $timeout(function () {
              toastScope.hide();
            }, duration);
          });
        }, 10)
      },

      hide: function () {
        toastScope.hide();
      }
    };

  }
  ];
});



