angular.module('starter.controllers', ['ngCordova', 'ionic.rating', 'pickadate', 'ngCart', 'color.picker', 'ionic-toast', 'ngIOS9UIWebViewPatch', 'ionRadioFix'])

    .filter('reverse', function () {
        return function (items) {
            return items.slice().reverse();
        };
    })

    .filter('addspace', function () {
        return function (remark) {

            var new_remark = ''
            if (remark.length > 0) {

                try {
                    remark = JSON.parse(remark);
                    for (i = 0; i < remark.length; i++) {
                        new_remark += remark[i].name + ',';
                    }
                    new_remark = new_remark.substring(0, new_remark.length - 1).replace(/,/g, ' , ');
                } catch (ex) {
                    new_remark = remark;
                }
            }
            return new_remark;
        }
    })

    .filter('filterItemList', function ($rootScope) {
        return function (items, searchtext, data) {
            $rootScope.cnt = 0;
            var filteredItems = [];
            var search = (searchtext != '' || searchtext != null) ? searchtext : '';
            var flag = 0;

            if (items != undefined) {
                for (i = 0; i < items.length; i++) {
                    flag = 0;
                    if (data.namecode == "itemname") {
                        if (items[i].menugrpitemname.search(new RegExp(search, "i")) >= 0)
                            flag = 1;

                        if (flag == 0 && items[i].menugrpitemdescr != null && items[i].menugrpitemdescr.search(new RegExp(search, "i")) >= 0)
                            flag = 1;
                    } else if (data.namecode == "itemcode") {
                        if (items[i].menugrpitem_code != null && items[i].menugrpitem_code.search(new RegExp(search, "i")) >= 0)
                            flag = 1;
                    }

                    if (flag == 1) {
                        if (data.veg == 'both' && (items[i].menugrpitem_isnonveg == 1 || items[i].menugrpitem_isnonveg == 0))
                            filteredItems.push(items[i]);
                        else if (data.veg == 'veg' && items[i].menugrpitem_isnonveg == 0)
                            filteredItems.push(items[i]);
                        else if (data.veg == 'nonveg' && items[i].menugrpitem_isnonveg == 1)
                            filteredItems.push(items[i]);
                    }
                }
            }

            if (filteredItems.length == 0)
                $rootScope.cnt = 0;
            else
                $rootScope.cnt = 1;
            return filteredItems;
        };
    })

    .filter('utf8_decode', function () {
        return function (str_data) {
            var tmp_arr = [],
                i = 0,
                ac = 0,
                c1 = 0,
                c2 = 0,
                c3 = 0,
                c4 = 0;

            str_data += '';

            while (i < str_data.length) {
                c1 = str_data.charCodeAt(i);
                if (c1 <= 191) {
                    tmp_arr[ac++] = String.fromCharCode(c1);
                    i++;
                } else if (c1 <= 223) {
                    c2 = str_data.charCodeAt(i + 1);
                    tmp_arr[ac++] = String.fromCharCode(((c1 & 31) << 6) | (c2 & 63));
                    i += 2;
                } else if (c1 <= 239) {
                    c2 = str_data.charCodeAt(i + 1);
                    c3 = str_data.charCodeAt(i + 2);
                    tmp_arr[ac++] = String.fromCharCode(((c1 & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                } else {
                    c2 = str_data.charCodeAt(i + 1);
                    c3 = str_data.charCodeAt(i + 2);
                    c4 = str_data.charCodeAt(i + 3);
                    c1 = ((c1 & 7) << 18) | ((c2 & 63) << 12) | ((c3 & 63) << 6) | (c4 & 63);
                    c1 -= 0x10000;
                    tmp_arr[ac++] = String.fromCharCode(0xD800 | ((c1 >> 10) & 0x3FF));
                    tmp_arr[ac++] = String.fromCharCode(0xDC00 | (c1 & 0x3FF));
                    i += 4;
                }
            }
            return tmp_arr.join('');
        };
    })

    .filter('filterTableList', function () {
        return function (tables, searchtext) {
            var filteredTables = [];
            var search = (searchtext != '' || searchtext != null) ? searchtext : '';
            var flag = 0;
            for (i = 0; i < tables.length; i++) {
                if (tables[i].name.search(new RegExp(search, "i")) >= 0)
                    filteredTables.push(tables[i]);
            }

            return filteredTables;
        };
    })

    .filter('filterWaiterList', function () {
        return function (waiters, searchtext) {
            var filteredWaiters = [];
            var search = (searchtext != '' || searchtext != null) ? searchtext : '';
            var flag = 0;
            for (i = 0; i < waiters.length; i++) {
                if (waiters[i].waitername.search(new RegExp(search, "i")) >= 0)
                    filteredWaiters.push(waiters[i]);
            }
            return filteredWaiters;
        };
    })

    .filter('filterRemark', function () {
        return function (remark, searchtext) {
            var filteredRemarks = [];
            var search = (searchtext != '' || searchtext != null) ? searchtext : '';
            var flag = 0;
            if (remark != undefined) {
                for (i = 0; i < remark.length; i++) {
                    if (remark[i].remarkname.search(new RegExp(search, "i")) >= 0)
                        filteredRemarks.push(remark[i]);
                }
            }

            return filteredRemarks;
        };
    })

    .filter('filterItemInItemList', function ($rootScope) {
        return function (items, searchtext, menugroup) {
            $rootScope.cnt = 0;
            var filteredItems = [];
            var search = (searchtext != '' || searchtext != null) ? searchtext : '';
            var flag = 0;
            if (items != undefined) {
                for (i = 0; i < items.length; i++) {
                    if (items[i].menugroupunkid == menugroup) {
                        if (items[i].menugrpitemname.search(new RegExp(search, "i")) >= 0)
                            filteredItems.push(items[i]);
                    }
                }
            }
            $rootScope.cnt = filteredItems.length;
            return filteredItems;
        };
    })

    .filter('digit', function () {
        return function (amount) {
            var vl = parseFloat(amount);
            return vl.toFixed(localStorage.getItem("decimal"));
        };
    })

    .filter('cartTotal', function () {
        return function (carts) {
            var total = 0;
            for (i = 0; i < carts.length; i++) {
                if (carts[i]._data.isordered == 0)
                    total += (carts[i]._price * carts[i]._quantity);
            }
            return total.toFixed(localStorage.getItem("decimal"));
        };
    })

    .filter('orderTotal', function () {
        return function (order, orderid) {
            var total = 0;
            for (i = 0; i < order.length; i++) {
                if (order[i]._data.isordered > 0 && order[i]._data.orderunkid == orderid)
                    total += (order[i]._price * order[i]._quantity);
            }

            return total.toFixed(localStorage.getItem("decimal"));
        };
    })

    .controller('AppCtrl', function ($scope, $ionicModal, $timeout, $http, $state, sharedProperties, $ionicHistory, $rootScope, $cordovaFile, $cordovaNetwork, $sce, $ionicPopup, ngCart, utf8_decodeFilter, $cordovaFileTransfer, $ionicPlatform, ionicToast) {


        if (ionic.Platform.isIPad())
            $rootScope.isbouncy = true;

        $ionicPlatform.registerBackButtonAction(function (event) {
            if ($state.current.name == "app.tmp" || $state.current.name == "app.mainlogin") {
                event.preventDefault();
            } else {
                navigator.app.backHistory();
            }
        }, 100);
        $scope.isburrp = (localStorage.getItem("isburrp") == 'true') ? true : false;
        // $rootScope.DeleteExtraOrderFromCart();
        var feedbacktype = window.localStorage['ifbacktype'];
        if (feedbacktype == 'iFeedback') {
            $rootScope.furl = "#/app/iFeedback"
        } else {
            $rootScope.furl = "#/app/feedback"
        }

        var slang = window.localStorage['selectedlang'];
        if (slang == "ar") {
            $rootScope.langside = "right";
        } else {
            $rootScope.langside = "left";
        }
        
        $rootScope.newNotification = function(string){
            ionicToast.show(string, 'bottom', false, 5000, '');
            var restaurantcode = window.localStorage.getItem("restaurantcode");
            var res = $http.get($rootScope.SERVER_PATH + 'notification.php?action=getNotificationCount',
            {
                params: { "restaurantcode": restaurantcode }
            });
            res.success(function (data) {
                if (data != null || data != "") {
                    $scope.notificationcount = data;
                }
            })
        }

        $rootScope.demo = (window.localStorage.getItem("account") == 'demo') ? true : false;
        $rootScope.restname = window.localStorage.getItem("resname");
        $rootScope.initCartDB();
        $rootScope.colorset();

        $rootScope.Back = function () {
            history.go(-1);
            setTimeout(function () {
                $ionicHistory.clearHistory();
            }, 1000);
        }

        $scope.home = function () {
            $state.go("app.home", {})
        }
        $scope.showsidebar = true;
        $scope.menu = function () {
            $timeout(function () {
                if (document.querySelector('.loadingData') != null)
                    document.querySelector('.loadingData').classList.add('loaded');
            }, 1000);
            $state.go("app.menuGroup", {});
            $rootScope.closeLoader();
        }

        $scope.logout = function () {

            var myPopup = $ionicPopup.show({
                template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg19),
                cssClass: 'logutpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg16),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl122),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl121),
                    type: 'button-positive',
                    onTap: function (e) {
                        $ionicHistory.clearHistory();
                        $timeout(function () {
                            var myPopupexit = $ionicPopup.show({
                                template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg40),
                                cssClass: 'logoutwait custompopup',
                                title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg49)
                            });
                            var regid = window.localStorage.getItem("registrationid");
                            window.localStorage.clear();
                            window.localStorage.setItem("registrationid", regid);
                            ngCart.empty();
                            $rootScope.clearCartItems(0);
                            $rootScope.lastCartId = 1;
                            $timeout(function () {
                                myPopupexit.close();
                                $rootScope.burrpmode = false;
                                document.getElementsByTagName('body')[0].setAttribute("class", 'en');
                                //document.getElementsByTagName('body')[0].className += " platform-ios platform-ipad platform-ios7 platform-cordova";
                                document.getElementsByTagName('html')[0].setAttribute("lang", 'en');
                                $state.go("app.mainlogin");
                            }, 2000);
                        }, 10);
                    }
                },]
            });
            myPopup.then(function (res) { });
        }

        $scope.myOrders = function () {
            flag = 0;
            var ngcrt = ngCart.getItems();
            for (i = 0; i < ngcrt.length; i++) {
                if (ngcrt[i]._data.isordered > 0) {
                    flag = 1;
                    break;
                }
            }

            if (flag == 1) {
                $state.go("app.myOrders", {});
                $rootScope.closeLoader();
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl65), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.configuration = function (ev) {

            $scope.config = {
                password: localStorage.getItem("upd"),
                remember: Boolean(localStorage.getItem("remember"))
            }
            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupConfiguration.html',
                cssClass: 'configpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl62),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {
                        e.preventDefault();

                        if ($scope.config.password == undefined || $scope.config.password == null) { } else if ($scope.config.password.length > 0 && ($scope.config.password == localStorage.getItem("upd"))) {
                            myPopup.close();
                            $state.go("app.configuration", {})
                        } else {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg5), 'top', false, $rootScope.messagetimeout, '');
                        }
                    }
                },]
            });
            myPopup.then(function (res) { });
        };

        $rootScope.loadAllData = function () {

            var alldata = JSON.parse(window.localStorage.getItem("alllangdata"));
            for (i = 0; i < alldata.length; i++) {
                if (alldata[i].langkey == window.localStorage.getItem("selectedlang")) {
                    $rootScope.languageLabels = alldata[i].langdata;
                    if (alldata[i]['langitemsdata']['category'].length > 0) {
                        $rootScope.menus = alldata[i]['langitemsdata']['category'];
                    }

                    if (alldata[i]['langitemsdata']['itemlist'].length > 0) {
                        $rootScope.menuItems = alldata[i]['langitemsdata']['itemlist'];
                    }

                    if (alldata[i]['langitemsdata']['Modimast'].length > 0) {
                        $rootScope.modifiers = alldata[i]['langitemsdata']['Modimast'];
                    }

                    if (alldata[i]['langitemsdata']['itemsunit'].length > 0) {
                        $rootScope.items_unit = alldata[i]['langitemsdata']['itemsunit'];
                    }

                    if (alldata[i]['langdata'] != null) {
                        $rootScope.langitemsdata = alldata[i]['langdata'];
                    }

                    if (alldata[i]['description'] != null) {
                        $rootScope.aboutus = $sce.trustAsHtml(alldata[i]['description']);
                    }

                    $rootScope.remarks = [];
                    if (alldata[i]['langitemsdata']['remarksdetail'].length > 0) {
                        $rootScope.remarks = alldata[i]['langitemsdata']['remarksdetail'];
                    }
                    var obj = new Object();
                    obj.remarkunkid = '0';
                    obj.remarkname = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl40);
                    $rootScope.remarks.push(obj);
                    break;
                }
            }
        };

        var myPopup;
        $scope.sync = function () {
            $ionicHistory.clearCache();
            if ($rootScope.getConnectionFlag()) {
                ngCart.empty();
                $rootScope.clearCartItems(0);
                $rootScope.lastCartId = 1;
                $rootScope.resetWebSQL();
                $rootScope.cartcounter = 0;
                $scope.progressPercent = 0;
                $scope.dloadflag = 0;
                $scope.dloadflag1 = 0;

                $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg13);
                $scope.permsg1 = '';
                var theme = (window.localStorage['theme'] == '' || window.localStorage['theme'] == undefined) ? '#3f4392' : window.localStorage['theme'];
                $rootScope.total_image = 0;
                myPopup = $ionicPopup.show({
                    template: '<div class="dwnld">{{permsg}}</div><div class="progress" ><div class="progressbar"  style="width:{{progressPercent}}%;background-color:' + theme + '">{{permsg1}}</div></div>',
                    //  subTitle: '<div>'+$scope.title+'</div>',
                    cssClass: 'custompopup demowaitPopup',
                    title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg49),
                    scope: $scope,
                });

                $timeout(function () {
                    var res = $http.get($rootScope.SERVICE_PATH, {
                        params: {
                            "username": window.localStorage.getItem("restusrname"),
                            "password": window.localStorage.getItem("upd"),
                            "restaurantcode": window.localStorage.getItem("restaurantcode"),
                            "usertype": "sync",
                            "request": "login",
                            "uuid": $rootScope.d_uuid,
                            "ip": "",
                            "model": $rootScope.d_model,
                            "version": $rootScope.d_version,
                            "platform": $rootScope.d_platform,
                            "oem_index": $rootScope.selected
                        }
                    });

                    res.success(function (data, status, headers, config) {
                        $rootScope.clearCartItems(0);
                        $rootScope.lastCartId = 1;
                        window.localStorage.setItem("orderunkid_array", '');
                        if (data[0].ownerFlag == 0 || data[0].ownerFlag == -1) {
                            myPopup.close();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg6), 'top', false, $rootScope.messagetimeout, '');
                        } else if (data[0].ownerFlag == 1 || data[0].ownerFlag == 2) {
                            $scope.storeDatainLocalStorage(data);
                        }
                    });

                    res.error(function (data, status, headers, config) {
                        $timeout(function () {
                            myPopup.close();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
                        }, 1000);
                    });
                }, 1000);
            }
        };

        $scope.storeDatainLocalStorage = function (alldata) {

            window.localStorage["syncdone"] = 1;
            window.localStorage["startorder"] = false;
            window.localStorage["socketstat"] = 0;
            window.localStorage["bannerimages"] = alldata[19]['slider'];
            tmp = alldata[19]['slider'].split(',');

            if (alldata[19]['slider'] != '') {
                $rootScope.total_image = tmp.length;
            }

            window.localStorage["currencycode"] = alldata[3]['currency'];
            window.localStorage["currencysymbol"] = alldata[4]['symbol'];
            window.localStorage["selectedlangid"] = alldata[7]['langId'];
            window.localStorage["imenusrvselectedlangkey"] = alldata[8]['langKey'];
            window.localStorage["upd"] = alldata[6]['pasd'];
            window.localStorage["selectedlang"] = alldata[15]['defaultlang'];
            document.getElementsByTagName('body')[0].setAttribute("class", alldata[15]['defaultlang']);
            //document.getElementsByTagName('body')[0].className += " platform-ios platform-ipad platform-ios7 platform-cordova";
            document.getElementsByTagName('html')[0].setAttribute("lang", alldata[15]['defaultlang']);
            window.localStorage["restaurantData"] = JSON.stringify(alldata[5]['loaddata']['restaurantData']);
            window.localStorage["POSip"] = alldata[5]['loaddata']['restaurantData'][0]['ip'];
            window.localStorage["ratemode"] = (alldata[5]['loaddata']['restaurantData'][0]['ratemode'] == 1) ? true : false;
            window.localStorage["forcefeedback"] = alldata[5]['loaddata']['restaurantData'][0]['forcefeedback'];
            window.localStorage["POSport"] = alldata[5]['loaddata']['restaurantData'][0]['portnumber'];
            window.localStorage["logo"] = alldata[5]['loaddata']['restaurantData'][0]['restaurantlogo'];
            window.localStorage["image"] = alldata[5]['loaddata']['restaurantData']['restaurantimage'];
            window.localStorage["Outlet"] = alldata[5]['loaddata']['restaurantData'][0]['outletname'];
            window.localStorage["resname"] = alldata[5]['loaddata']['restaurantData'][0]['restaurantname'];
            $rootScope.restname = alldata[5]['loaddata']['restaurantData'][0]['restaurantname'];
            window.localStorage["theme"] = alldata[5]['loaddata']['restaurantData'][0]['theme'];
            window.localStorage["themecolor_tmp"] = alldata[5]['loaddata']['restaurantData'][0]['theme'];
            if (alldata[20]['logo'] != "") {
                $rootScope.total_image = $rootScope.total_image + 1;
            }
            window.localStorage["imenuWaiterlist"] = JSON.stringify(alldata[5]['loaddata']['waitersdetail']);
            window.localStorage["imenuTablelist"] = JSON.stringify(alldata[5]['loaddata']['tabledetail']);
            window.localStorage.setItem('waitertableallocation', alldata[21]['tablewaitermap']);
            if (typeof (alldata[5]['loaddata']['fbQCust1']) == 'object' && alldata[5]['loaddata']['fbQCust1'].length > 0) {
                alldata[5]['loaddata']['fbQCust1'].push({
                    answer_type: 'rate',
                    compulsory: 1,
                    multianswer: 0,
                    question: 'Rate Items',
                    questionunkid: '0'
                });
            }
            window.localStorage["feedbackquestions"] = JSON.stringify(alldata[5]['loaddata']['fbQCust1']);
            window.localStorage["customquestion"] = JSON.stringify(alldata[5]['loaddata']['fbCtans']);
            window.localStorage["alllangdata"] = JSON.stringify(alldata[12]['langlist']);
            window.localStorage["orderunkid_array"] = "";
            window.localStorage["feedbacksubmitted"] = 'false';


            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['category'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['category'] != " ") {
                    if (alldata[12]['langlist'][0]['langitemsdata']['category'][i]['menugrpimage'] != "") {
                        $rootScope.total_image = $rootScope.total_image + 1;
                    }
                }
            }

            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['modifieritemflag'] == 0) {
                    if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['menugrpitemimage'] != "")
                        $rootScope.total_image = $rootScope.total_image + 1;
                }
            }

            $rootScope.counter = $rootScope.total_image;
            $scope.ttlimg = $rootScope.counter;

            if (alldata[11]['ifbkdata'][0]['feedbacktype'] != '' || alldata[11]['ifbkdata'][0]['feedbacktype'] != null) {
                window.localStorage["ifbacktype"] = alldata[11]['ifbkdata'][0]['feedbacktype'];
            }
            if (alldata[11]['ifbkdata'][0]['surveylist'] != '' || alldata[11]['ifbkdata'][0]['surveylist'] != null) {
                window.localStorage["ifeedbacksurvey"] = alldata[11]['ifbkdata'][0]['surveylist'];
            }

            if (alldata[11]['ifbkdata'][0]['surveylist'].companykey != null) {
                window.localStorage["ifbkcompkey"] = JSON.parse(alldata[11]['ifbkdata'][0]['surveylist']['companykey']);
            }

            window.localStorage["restusrname"] = alldata[5]['loaddata']['restaurantData'][0]['imenu_username'];
            window.localStorage["restaurantcode"] = alldata[5]['loaddata']['restaurantData'][0]['restaurantcode'];
            window.localStorage["decimal"] = alldata[16]['decimalpoint'];
            window.localStorage["langavailable"] = alldata[13]['langavailable'];
            window.localStorage["cid"] = '';
            window.localStorage["guestdetailchoice"] = '';
            window.localStorage['logo_src'] = $rootScope.logo_path;
            window.localStorage['main_logo_src'] = $rootScope.logo_path;


            if ($rootScope.counter == 0) {
                $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg57);
                $scope.permsg1 = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg58);
                gologin();
            }

            if (alldata[19]['slider'] != '') {
                for (i = 0; i < tmp.length; i++) {
                    download(tmp[i], 'banner', $rootScope.other_path);
                }
            }

            if (alldata[20]['logo'] != "") {
                download(alldata[20]['logo'], 'logos', $rootScope.logo_path);
                window.localStorage['main_logo'] = alldata[20]['logo'];
            }

            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['category'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['category'] != " ") {
                    if (alldata[12]['langlist'][0]['langitemsdata']['category'][i]['menugrpimage'] != "") {
                        download(alldata[12]['langlist'][0]['langitemsdata']['category'][i]['menugrpimage'], 'menugroup', $rootScope.menu_path);
                    }
                }
            }

            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['modifieritemflag'] == 0) {
                    if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['menugrpitemimage'] != "")
                        download(alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['menugrpitemimage'], 'item', $rootScope.item_path);
                }
            }


        };

        function download(iname, location, path) {
            $scope.ttlimg--;
            /***************   Comment this when building for Android    ******************/
            /*$rootScope.total_image--;
            var per = 100 - (($rootScope.total_image * 100) / $rootScope.counter);
            $scope.progressPercent = Math.round(per);
            $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg57);
            $scope.permsg1 = $scope.progressPercent + " " + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg58);
            if ($rootScope.total_image == 0) {
                gologin();
            }
            /***************   Comment this when building for Android    ******************/
            var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
            if (phonegapapp) {
                var url = $rootScope.SERVER_IMAGE_PATH + location + "/" + iname;
                var targetPath = path + iname;
                var trustHosts = true
                var options = {};
                if ($scope.ttlimg == 0) {
                    chkstop($scope.progressPercent);
                }
                $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(
                    function (result) {

                        $rootScope.total_image--;
                        var per = 100 - (($rootScope.total_image * 100) / $rootScope.counter);
                        $scope.progressPercent = Math.round(per);
                        $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg57);
                        $scope.permsg1 = $scope.progressPercent + " " + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg58);
                        if ($rootScope.total_image == 0) {

                            if ($scope.dloadflag1 == 0) {

                                $scope.dloadflag = 1;
                                $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg59);
                                gologin();
                            }
                        }
                    },
                    function (err) {

                        $rootScope.total_image--;
                        var per = 100 - (($rootScope.total_image * 100) / $rootScope.counter);
                        $scope.progressPercent = Math.round(per);
                        $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg57);
                        $scope.permsg1 = $scope.progressPercent + " " + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg58);

                        if ($rootScope.total_image == 0) {
                            if ($scope.dloadflag1 == 0) {
                                $scope.dloadflag = 1;
                                $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg59);
                                gologin();
                            }
                        }
                    },
                    function (progress) {
                        $timeout(function () {
                            $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                        })
                    }
                );
            }
        }

        function chkstop(per) {
            setTimeout(function () {
                if (per == $scope.progressPercent) {
                    if ($scope.dloadflag == 0) {
                        $scope.dloadflag1 = 1;
                        $scope.permsg1 = $scope.progressPercent + " " + "%";
                        $scope.permsg = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg59);
                        gologin();
                    }
                } else {
                    if ($scope.dloadflag == 0) {
                        chkstop($scope.progressPercent);
                    }
                }
            }, 15000);
        }

        function gologin() {
            $rootScope.colorset();
            setTimeout(function () {
                $scope.loadAllData();
                window.localStorage['logo_src'] = $rootScope.logo_path;
                window.localStorage['main_logo_src'] = $rootScope.logo_path;
                $state.go("app.home", {});
                myPopup.close();
                $scope.progressPercent = 0;
                $rootScope.total_image = 0;
                location.reload();
            }, 2000);
        }

        $scope.bill_waiter = function (req) {

            if (window.localStorage.getItem("waitermode") == 'true' || window.localStorage.getItem("waitermode") == true) {

                $scope.data = {
                    searchtext: ''
                };
                $scope.table = {
                    name: window.localStorage.getItem("TableNumber")
                };
                $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));

                $timeout(function () {
                    if (document.querySelector(".tablescroll") != null) {
                        document.querySelector(".tablepopup ion-scroll").style["min-height"] = (document.querySelector(".tablepopup .popup").offsetHeight - (document.querySelector(".tablepopup .popup-head").offsetHeight + document.querySelector(".tablepopup .popup-buttons").offsetHeight + document.querySelector(".tablepopup .popsearch").offsetHeight + 90)) + 'px';
                        document.querySelector(".tablepopup ion-scroll").style["max-height"] = (document.querySelector(".tablepopup .popup").offsetHeight - (document.querySelector(".tablepopup .popup-head").offsetHeight + document.querySelector(".tablepopup .popup-buttons").offsetHeight + document.querySelector(".tablepopup .popsearch").offsetHeight + 90)) + 'px';
                    }
                }, 100);

                $timeout(function () {
                    var myPopup = $ionicPopup.show({
                        templateUrl: 'templates/popupTableList.html',
                        cssClass: 'tablepopup custompopup',
                        title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl28),
                        scope: $scope,
                        buttons: [{
                            text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                            onTap: function (e) { }
                        }, {
                            text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                            type: 'button-positive',
                            onTap: function (e) {
                                myPopup.close();
                                $timeout(function () {
                                    if ($scope.tableList.length > 0) {
                                        if ($scope.table.name != undefined && $scope.table.name != '') {

                                            if (req == 'bill') {
                                                $rootScope.waiterOrBill(2, $scope.table.name);
                                            } else if (req == 'waiter') {
                                                $rootScope.waiterOrBill(1, $scope.table.name);
                                            }
                                        } else {
                                            ionicToast.show("Please select table to send request.", 'top', false, $rootScope.messagetimeout, '');
                                        }
                                    }
                                }, 100);
                            }
                        },]
                    });
                }, 100);
            } else {
                if (window.localStorage.getItem("TableNumber") == '') {
                    ionicToast.show($rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg22), 'top', false, $rootScope.messagetimeout, '');
                } else {
                    if (req == 'bill') {
                        $rootScope.waiterOrBill(2, window.localStorage.getItem("TableNumber"));
                    } else if (req == 'waiter') {
                        $rootScope.waiterOrBill(1, window.localStorage.getItem("TableNumber"));
                    }
                }
            }
        }

        $scope.resetSearch = function () {
            $scope.data.searchtext = '';
            $scope.search = false;
        }

        var ssn_usrname = window.localStorage["restusrname"];
        var ssn_code = window.localStorage["restaurantcode"];
        if (ssn_usrname != null && ssn_code != null && ssn_usrname.length != 0 && ssn_code.length != 0) {
            document.getElementsByTagName('body')[0].setAttribute("class", window.localStorage.getItem("selectedlang"));
            //document.getElementsByTagName('body')[0].className += " platform-ios platform-ipad platform-ios7 platform-cordova";
            document.getElementsByTagName('html')[0].setAttribute("lang", window.localStorage.getItem("selectedlang"));
            $rootScope.loadAllData();
        }
    })

    .controller('MainLogin', function ($scope, $ionicPopup, $timeout, $http, $state, sharedProperties, $rootScope, $cordovaFileTransfer, $ionicHistory, $sce, $ionicSideMenuDelegate, $cordovaNetwork, $ionicPlatform, $cordovaFile, ionicToast) {

        if ($rootScope.langside == "right") {
            $rootScope.langside = "left";
            $timeout(function () {
                location.reload();
            }, 1000)
        }

        if (document.getElementById("mainloginscreen") != null)
            document.getElementById("mainloginscreen").classList.add('in');

        $ionicSideMenuDelegate.canDragContent(false)
        $scope.showsidebar = false;
        $scope.progressPercent = 0;
        $scope.permsg = 'Authenticating..';
        $scope.permsg1 = '';
        $scope.dloadflag = 0;
        $scope.dloadflag1 = 0;
        $scope.t_data = '';
        var myPopup;
        $scope.loginData = {
            username: '',
            password: '',
            restaurantcode: '',
            passwordtype: 'password'
        };

        $rootScope.synchronization = function () {
            ngCart.empty();
            $rootScope.clearCartItems(0);
            $rootScope.resetWebSQL();
            $rootScope.cartcounter = 0;
            $rootScope.lastCartId = 1;
            $scope.storeDatainLocalStorage();
        }

        $scope.showpassword = function () {
            if (event.target.classList.contains('activated') == false) {
                event.preventDefault();
                if ($scope.loginData['passwordtype'] == 'password')
                    $scope.loginData['passwordtype'] = 'text';
                else if ($scope.loginData['passwordtype'] == 'text')
                    $scope.loginData['passwordtype'] = 'password';
            }
        }

        $scope.loginconncheck = function () {
            var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
            if (phonegapapp) {
                var flg = $cordovaNetwork.isOnline();
                if (flg)
                    return true;
                else {
                    var network = $cordovaNetwork.getNetwork();
                    if (network == Connection.NONE) {
                        ionicToast.show("Please Check Internet Connection", 'topmost', false, $rootScope.messagetimeout, '');
                    } else
                        return true;
                }
            } else {
                return true;
            }
        }

        $scope.doDemo = function () {
            event.preventDefault();
            $ionicHistory.clearCache();
            if ($scope.loginconncheck()) {
                myPopup = $ionicPopup.show({
                    template: '<div class="dwnld">{{permsg}}</div><div class="progress"><div class="progressbar" style="width:{{progressPercent}}%;">{{permsg1}} Complete</div></div>',
                    //  subTitle: '<div>'+$scope.title+'</div>',
                    cssClass: 'custompopup demowaitPopup',
                    title: 'Please Wait',
                    scope: $scope,
                });

                var res = $http.get($rootScope.SERVICE_PATH, {
                    params: {
                        "username": "",
                        "password": "",
                        "restaurantcode": "",
                        "usertype": "demo",
                        "request": "login",
                        "uuid": $rootScope.d_uuid,
                        "ip": "",
                        "model": $rootScope.d_model,
                        "version": $rootScope.d_version,
                        "platform": $rootScope.d_platform,
                        "app_version": $rootScope.version,
                        "oem_index": $rootScope.selected
                    }
                });
                res.success(function (data, status, headers, config) {

                    $scope.t_data = data;
                    $rootScope.demo = true;
                    $rootScope.cartcounter = 0;
                    $scope.storeDatainLocalStorage(data);
                });
                res.error(function (data, status, headers, config) {
                    $timeout(function () {
                        myPopup.close()
                        ionicToast.show("Oops!! Somethig went wrong.", 'middle', false, $rootScope.messagetimeout, '');
                    }, 1000);
                });
            }
        };

        $scope.doLogin = function () {

            $rootScope.cartcounter = 0;
            $ionicHistory.clearCache();
            if ($scope.loginconncheck()) {
                if (JSON.stringify($scope.loginData).length > 2) {
                    if ($scope.loginData["username"] == undefined || $scope.loginData["username"].trim() == '' || $scope.loginData["password"] == undefined || $scope.loginData["password"].trim() == '' || $scope.loginData["restaurantcode"] == undefined || $scope.loginData["restaurantcode"].trim() == '') {
                        ionicToast.show("Please enter details", 'middle', false, $rootScope.messagetimeout, '');
                    } else {
                        myPopup = $ionicPopup.show({
                            template: '<div class="dwnld">{{permsg}}</div><div class="progress"><div class="progressbar" style="width:{{progressPercent}}%;">{{permsg1}} Complete</div></div>',
                            title: 'Please Wait',
                            scope: $scope,
                            cssClass: 'custompopup demowaitPopup'
                        });

                        var res = $http.get($rootScope.SERVICE_PATH, {
                            params: {
                                "username": $scope.loginData["username"].toLowerCase(),
                                "password": $scope.loginData["password"],
                                "restaurantcode": $scope.loginData["restaurantcode"],
                                "usertype": "user",
                                "request": "login",
                                "uuid": $rootScope.d_uuid,
                                "ip": "",
                                "model": $rootScope.d_model,
                                "version": $rootScope.d_version,
                                "platform": $rootScope.d_platform,
                                "app_version": $rootScope.version,
                                "oem_index": $rootScope.selected
                            }
                        });

                        res.success(function (data, status, headers, config) {

                            $rootScope.demo = false;
                            if (data[0].ownerFlag == 0) {
                                myPopup.close();
                                ionicToast.show("Oops!, Invalid credential", 'topmost', false, $rootScope.messagetimeout, '');
                            } else if (data[0].ownerFlag == -1) {
                                myPopup.close();
                                ionicToast.show("Oops!, Your outlet is disabled. Please contact eZee Support", 'middle', false, $rootScope.messagetimeout, '');
                            } else if (data[0].ownerFlag == -2) {
                                myPopup.close();
                                ionicToast.show("Oops!, Your outlet validity has expired. Please contact eZee Support", 'middle', false, $rootScope.messagetimeout, '');
                            } else if (data[0].ownerFlag == 1 || data[0].ownerFlag == 2) {
                                $scope.loginData["username"] = "";
                                $scope.loginData["password"] = "";
                                $scope.loginData["restaurantcode"] = "";
                                $scope.t_data = data;
                                $scope.storeDatainLocalStorage(data);
                            }
                        });

                        res.error(function (data, status, headers, config) {
                            $timeout(function () {
                                myPopup.close()
                                ionicToast.show("Oops!! Somethig went wrong.", 'middle', false, $rootScope.messagetimeout, '');
                            }, 1000);
                        });
                    }
                } else {
                    ionicToast.show("Please enter details", 'middle', false, $rootScope.messagetimeout, '');
                }
            }
        };

        $scope.storeDatainLocalStorage = function (alldata) {


            window.localStorage["syncdone"] = 0;
            window.localStorage["LoadedFirstTime"] = 1;
            window.localStorage["bannerimages"] = alldata[19]['slider'];
            tmp = alldata[19]['slider'].split(',');

            if (alldata[19]['slider'] != '') {
                $rootScope.total_image = tmp.length;
            }

            window.localStorage["remember"] = 0;
            if (alldata[18].requesttype == "demo") {
                window.localStorage["account"] = "demo";
                window.localStorage["remember"] = 1;
            } else if (alldata[18]['requesttype'] == "user")
                window.localStorage["account"] = "user";

            window.localStorage["restid"] = alldata[1]['restid'];
            window.localStorage["currencycode"] = alldata[3]['currency'];
            window.localStorage["currencysymbol"] = alldata[4]['symbol'];
            window.localStorage["selectedlangid"] = alldata[7]['langId'];
            window.localStorage["imenusrvselectedlangkey"] = alldata[8]['langKey'];
            window.localStorage["upd"] = alldata[6]['pasd'];
            window.localStorage["selectedlang"] = alldata[15]['defaultlang'];

            window.localStorage["restaurantData"] = JSON.stringify(alldata[5]['loaddata']['restaurantData']);
            window.localStorage["POSip"] = alldata[5]['loaddata']['restaurantData'][0]['ip'];
            window.localStorage["ratemode"] = (alldata[5]['loaddata']['restaurantData'][0]['ratemode'] == 1) ? true : false;
            window.localStorage["forcefeedback"] = alldata[5]['loaddata']['restaurantData'][0]['forcefeedback'];
            window.localStorage["POSport"] = alldata[5]['loaddata']['restaurantData'][0]['portnumber'];
            window.localStorage["restfolder"] = '';
            window.localStorage["logo"] = alldata[5]['loaddata']['restaurantData'][0]['restaurantlogo'];
            window.localStorage["image"] = alldata[5]['loaddata']['restaurantData']['restaurantimage'];
            window.localStorage["Outlet"] = alldata[5]['loaddata']['restaurantData'][0]['outletname'];
            window.localStorage["resname"] = alldata[5]['loaddata']['restaurantData'][0]['restaurantname'];
            $rootScope.restname = alldata[5]['loaddata']['restaurantData'][0]['restaurantname'];
            window.localStorage["theme"] = alldata[5]['loaddata']['restaurantData'][0]['theme'];
            window.localStorage["themecolor_tmp"] = alldata[5]['loaddata']['restaurantData'][0]['theme'];
            window.localStorage.setItem('waitertableallocation', alldata[21]['tablewaitermap']);

            if (alldata[20]['logo'] != "") {
                $rootScope.total_image = $rootScope.total_image + 1;
            }

            window.localStorage["imenuWaiterlist"] = JSON.stringify(alldata[5]['loaddata']['waitersdetail']);
            window.localStorage["imenuTablelist"] = JSON.stringify(alldata[5]['loaddata']['tabledetail']);
            //console.log(alldata[5]['loaddata']['fbQCust1'].length)
            if (typeof (alldata[5]['loaddata']['fbQCust1']) == 'object' && alldata[5]['loaddata']['fbQCust1'].length > 0) {
                alldata[5]['loaddata']['fbQCust1'].push({
                    answer_type: 'rate',
                    compulsory: 1,
                    multianswer: 0,
                    question: 'Rate Items',
                    questionunkid: '0'
                });
            }
            window.localStorage["feedbackquestions"] = JSON.stringify(alldata[5]['loaddata']['fbQCust1']);
            window.localStorage["customquestion"] = JSON.stringify(alldata[5]['loaddata']['fbCtans']);
            window.localStorage["alllangdata"] = JSON.stringify(alldata[12]['langlist']);
            window.localStorage["orderunkid_array"] = "";
            window.localStorage["feedbacksubmitted"] = 'false';

            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['category'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['category'] != " ") {
                    if (alldata[12]['langlist'][0]['langitemsdata']['category'][i]['menugrpimage'] != "") {
                        $rootScope.total_image = $rootScope.total_image + 1;
                    }
                }
            }

            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['modifieritemflag'] == 0) {
                    if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['menugrpitemimage'] != "")
                        $rootScope.total_image = $rootScope.total_image + 1;
                }
            }

            $rootScope.counter = $rootScope.total_image;
            $scope.ttlimg = $rootScope.total_image;

            if (alldata[11]['ifbkdata'][0]['feedbacktype'] != '') {
                window.localStorage["ifbacktype"] = alldata[11]['ifbkdata'][0]['feedbacktype'];
            }
            if (alldata[11]['ifbkdata'][0]['surveylist'] != '') {
                window.localStorage["ifeedbacksurvey"] = alldata[11]['ifbkdata'][0]['surveylist'];
            }

            if (alldata[11]['ifbkdata'][0]['surveylist'].companykey != null) {
                window.localStorage["ifbkcompkey"] = JSON.parse(alldata[11]['ifbkdata'][0]['surveylist']['companykey']);
            }

            window.localStorage["DisplayArr"] = '[{"myorderdisp":"1"},{"feedbackdisp":"1"},{"syncdisp":"1"},{"aboutusdisp":"1"},{"helpdisp":"1"}]';
            window.localStorage["restusrname"] = alldata[5]['loaddata']['restaurantData'][0]['imenu_username'];
            window.localStorage["restaurantcode"] = alldata[5]['loaddata']['restaurantData'][0]['restaurantcode'];
            window.localStorage["orderno"] = "iMenu_" + window.localStorage["restid"] + "_0_1";

            window.localStorage["decimal"] = alldata[16]['decimalpoint'];
            window.localStorage["langavailable"] = alldata[13]['langavailable'];
            window.localStorage["TableNumber"] = '';
            window.localStorage["currencycode"] = '';
            window.localStorage["ifbkcompkey"] = '';
            window.localStorage["Lastorderno"] = '';
            window.localStorage["srvOrderNo"] = '';
            window.localStorage["waitermode"] = false;
            window.localStorage["cid"] = '';
            window.localStorage["waitertableno"] = '';
            window.localStorage["tmpdrd2"] = '';
            window.localStorage["cmail"] = '';
            window.localStorage["WaiterName"] = '';
            window.localStorage["WaiterId"] = '';
            window.localStorage["WaiterCode"] = '';
            window.localStorage["guestdetailchoice"] = '';
            window.localStorage["orderchoice"] = true;
            window.localStorage["startorder"] = false;
            window.localStorage["socketstat"] = 0;
            window.localStorage["orderpreference"] = 0;
            window.localStorage["ispos"] = false;
            window.localStorage["isburrp"] = false;
            window.localStorage["guestinfo"] = false;
            window.localStorage["serverurl"] = '';
            window.localStorage["propertyid"] = '';
            window.localStorage["userid"] = '';
            window.localStorage["appkey"] = '';
            window.localStorage["shiftno"] = '';
            window.localStorage["guestcomment"] = '';
            window.localStorage["LoadedFirstTime"] = false;
            window.localStorage["tmptableno"] = '';
            window.localStorage['logo_src'] = $rootScope.logo_path;
            window.localStorage['main_logo_src'] = $rootScope.logo_path;
            window.localStorage["tablefix"] = false;
            $rootScope.orderingmode = true;
            //var restaurantcode= window.localStorage["restaurantcode"];
            //    
            //     $scope.res = $http.get($rootScope.SERVICE_PATH);
            //     console.log($scope.res);
           /* window.localStorage.setItem('waitertableallocation', JSON.stringify([
                { name: "Andrew", table: ["MD 1", "MD 10"] },
                { name: "Arnold", table: ["MD 11", "MD 12"] },
                { name: "David", table: ["MD 13", "MD 14"] },
                { name: "Jason", table: ["MD 15", "MD 16"] },
                { name: "John", table: ["MD 17", "MD 18"] },
                { name: "Kelly", table: ["MD 2", "MD 3"] },
                { name: "Martin", table: ["MD 4", "MD 5"] },
                { name: "Ricky", table: ["MD 6", "MD 7"] },
                { name: "Roger", table: ["MD 8"] },
                { name: "Roy", table: ["MD 9"] },
                { name: "Sam", table: ["Table 1"] },
                { name: "Tim", table: ["Table 2"] }]))
                */

            if ($rootScope.counter == 0) {
                $scope.permsg = 'We are downloading Restaurant data ';
                $scope.permsg1 = '100 %';
                gologin();
            }

            if (alldata[19]['slider'] != '') {
                for (i = 0; i < tmp.length; i++) {
                    download(tmp[i], 'banner', $rootScope.other_path);
                }
            }
            if (alldata[20]['logo'] != "") {
                download(alldata[20]['logo'], 'logos', $rootScope.logo_path);
                window.localStorage['main_logo'] = alldata[20]['logo'];
            }
            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['category'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['category'] != " ") {
                    if (alldata[12]['langlist'][0]['langitemsdata']['category'][i]['menugrpimage'] != "") {
                        download(alldata[12]['langlist'][0]['langitemsdata']['category'][i]['menugrpimage'], 'menugroup', $rootScope.menu_path);
                    }
                }
            }
            for (i = 0; i < alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length; i++) {
                if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['modifieritemflag'] == 0) {
                    if (alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['menugrpitemimage'] != "")
                        download(alldata[12]['langlist'][0]['langitemsdata']['itemlist'][i]['menugrpitemimage'], 'item', $rootScope.item_path);
                }
            }


        };


        function download(iname, location, path) {
            $scope.ttlimg--;

            /***************   Comment this when building for Android    ******************/
            /*$rootScope.total_image--;
            var per = 100 - (($rootScope.total_image * 100) / $rootScope.counter);
            $scope.progressPercent = Math.round(per);
            $scope.permsg = "Downloading Restaurant data";
            $scope.permsg1 = $scope.progressPercent + " " + "% ";
            if ($rootScope.total_image == 0) {
                gologin();
            }
            /***************   Comment this when building for Android    ******************/
            var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
            if (phonegapapp) {
                var url = $rootScope.SERVER_IMAGE_PATH + location + "/" + iname;
                var targetPath = path + iname;
                var trustHosts = true
                var options = {};
                if ($scope.ttlimg == 0) {
                    chkstop($scope.progressPercent);
                }

                $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(
                    function (result) {
                        $rootScope.total_image--;
                        var per = 100 - (($rootScope.total_image * 100) / $rootScope.counter);
                        $scope.progressPercent = Math.round(per);
                        $scope.permsg = "Downloading Restaurant data";
                        $scope.permsg1 = $scope.progressPercent + " " + "%";
                        if ($rootScope.total_image == 0) {
                            if ($scope.dloadflag1 == 0) {
                                $scope.dloadflag = 1;
                                $scope.permsg = "Redirecting";
                                gologin();
                            }
                        }
                        // Success!
                    },
                    function (err) {
                        $rootScope.total_image--;
                        var per = 100 - (($rootScope.total_image * 100) / $rootScope.counter);
                        $scope.progressPercent = Math.round(per);
                        $scope.permsg = "Downloading Restaurant data";
                        $scope.permsg1 = $scope.progressPercent + " " + "%";
                        if ($rootScope.total_image == 0) {
                            if ($scope.dloadflag1 == 0) {
                                $scope.dloadflag = 1;
                                $scope.permsg = "Redirecting";
                                gologin();
                            }

                        }
                    },
                    function (progress) {
                        $timeout(function () {
                            $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                        })
                    }
                );
            }
        }

        function chkstop(per) {
            setTimeout(function () {
                if (per == $scope.progressPercent) {
                    if ($scope.dloadflag == 0) {

                        $scope.dloadflag1 = 1;
                        $scope.permsg1 = $scope.progressPercent + " " + "%";
                        $scope.permsg = "Redirecting";
                        $rootScope.alldata = $scope.t_data;
                        gologin();
                        setTimeout(function () {
                            redownload();
                        }, 3000);

                    }
                } else {
                    if ($scope.dloadflag == 0) {
                        chkstop($scope.progressPercent);
                    }
                }
            }, 15000);
        }

        function redownload() {
            if ($rootScope.alldata[19]['slider'] != '') {
                tmp = $rootScope.alldata[19]['slider'].split(',');
                i = 0;
                otherdl();

                function otherdl() {
                    $cordovaFile.checkFile($rootScope.other_path, tmp[i])
                        .then(function (success) {
                            i++;
                            if (i < tmp.length) {
                                otherdl()
                            }
                        }, function (error) {
                            $rootScope.download1(tmp[i], 'banner', $rootScope.other_path);
                            i++;
                            if (i < tmp.length) {
                                otherdl()
                            }
                        });
                }
            }

            if ($rootScope.alldata[20]['logo'] != "") {
                $cordovaFile.checkFile($rootScope.logo_path, $rootScope.alldata[20]['logo'])
                    .then(function (success) {

                    }, function (error) {
                        $rootScope.download1($rootScope.alldata[20]['logo'], 'logos', $rootScope.logo_path);
                    });

            }
            j = 0;
            if (j < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'].length) {
                ctgrdl();
            }

            function ctgrdl() {
                if ($rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'] != " ") {
                    if ($rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'][j]['menugrpimage'] != "") {
                        $cordovaFile.checkFile($rootScope.menu_path, $rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'][j]['menugrpimage'])
                            .then(function (success) {
                                j++;
                                if (j < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'].length) {
                                    ctgrdl()
                                }
                            }, function (error) {
                                $rootScope.download1($rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'][j]['menugrpimage'], 'menugroup', $rootScope.menu_path);
                                j++;
                                if (j < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'].length) {
                                    ctgrdl()
                                }
                            });
                    } else {
                        j++;
                        if (j < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['category'].length) {
                            ctgrdl()
                        }
                    }
                }
            }


            k = 0;
            if (k < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length) {
                itemdl();
            }

            function itemdl() {
                if ($rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'] != ' ') {
                    if ($rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'][k]['modifieritemflag'] == 0) {
                        if ($rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'][k]['menugrpitemimage'] != "") {
                            var temp = $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'][k]['menugrpitemimage'];
                            $cordovaFile.checkFile($rootScope.item_path, $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'][k]['menugrpitemimage'])
                                .then(function (success) {
                                    k++;
                                    if (k < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length) {
                                        itemdl()
                                    }
                                }, function (error) {
                                    $rootScope.download1(temp, 'item', $rootScope.item_path);
                                    k++;
                                    if (k < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length) {
                                        itemdl()
                                    }
                                });
                        } else {
                            k++;
                            if (k < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length) {
                                itemdl()
                            }
                        }

                    } else {
                        k++;
                        if (k < $rootScope.alldata[12]['langlist'][0]['langitemsdata']['itemlist'].length) {
                            itemdl()
                        }
                    }
                }
            }
        }

        $rootScope.download1 = function (iname, location, path) {
            var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;

            if (phonegapapp) {
                var url = $rootScope.SERVER_IMAGE_PATH + location + "/" + iname;
                var targetPath = path + iname;
                var trustHosts = true
                var options = {};
                $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(
                    function (result) {

                    },
                    function (err) {

                    },
                    function (progress) {
                        $timeout(function () {
                            $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                        })
                    }
                );
            }
        }

        function gologin() {
            $rootScope.colorset();
            setTimeout(function () {
                $rootScope.loadAllData();
                window.localStorage['logo_src'] = $rootScope.logo_path;
                window.localStorage['main_logo_src'] = $rootScope.logo_path;
                myPopup.close();
                $scope.progressPercent = 0;
                $scope.permsg = 'Authenticating..';
                $scope.permsg1 = '';
                if (window.localStorage.getItem("selectedlang") == 'ar') {
                    location.reload();
                } else {
                    $state.go("app.home", {});
                }
            }, 2000);
        }
    })

    .controller('Home', function ($scope, sharedProperties, $state, $rootScope, ngCart, $timeout, $ionicPopup, $http, utf8_decodeFilter, ionicToast) {
        $rootScope.notificationcount = 0;
        var restaurantcode = window.localStorage.getItem("restaurantcode");
        var res = $http.get($rootScope.SERVER_PATH + 'notification.php?action=getNotificationCount',
        {
            params: { "restaurantcode": restaurantcode }
        });
        res.success(function (data) {
            if (data != null || data != "") {
                $rootScope.notificationcount = data;
            }
        })
        
        $rootScope.notification = function () {
            //ionicToast.show(utf8_decodeFilter("This is Notification"), 'top', false, $rootScope.messagetimeout, '');
            //var notifymsg = "This is Notification";
            //var title = "New Notification";
            //var restaurantcode = window.localStorage.getItem("restaurantcode");
            //var res = $http.get($rootScope.SERVER_PATH + "notification.php?action=addNotification", {
            //    params: { /*"notifymsg": notifymsg, "title": title,*/ "restaurantcode": restaurantcode }
            //});
            //$scope.notificationlist = [];
            //res.success(function (data) {
            //    if (data != null || data != "") {
            //        $scope.notificationlist = data;
            //    }
            //})
            $state.go('app.notification');        
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
            $scope.isburrp = (localStorage.getItem("isburrp") == 'true') ? true : false;
            $scope.table = localStorage.getItem("TableNumber");
            $rootScope.hidebutton = "";
            $scope.waitermode = (window.localStorage.getItem("waitermode") == true || window.localStorage.getItem("waitermode") == "true") ? false : true;
            $scope.custologinlink = '';
            $scope.signvisi = false;

            if ($scope.waitermode == true && $rootScope.orderingmode == true)
                $scope.signvisi = true;

            if (JSON.parse(localStorage.getItem("DisplayArr"))[0].myorderdisp == 1) {
                $rootScope.displinks["myorderdisp"] = true;
            }

            if (JSON.parse(localStorage.getItem("DisplayArr"))[1].feedbackdisp == 1) {
                $rootScope.displinks["feedbackdisp"] = true;
            }

            if (JSON.parse(localStorage.getItem("DisplayArr"))[2].syncdisp == 1) {
                $rootScope.displinks["syncdisp"] = true;
            }

            if (JSON.parse(localStorage.getItem("DisplayArr"))[3].aboutusdisp == 1) {
                $rootScope.displinks["aboutusdisp"] = true;
            }

            if (JSON.parse(localStorage.getItem("DisplayArr"))[4].helpdisp == 1) {
                $rootScope.displinks["helpdisp"] = true;
            }

            if (window.localStorage['startorder'] == "false") {
                $rootScope.startordermsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl36);
                $scope.orderstatus = false;
            } else {
                $rootScope.startordermsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl37);
                $scope.orderstatus = true;
            }

            if (document.querySelector(".routingLoader") != undefined) {
                $timeout(function () {
                    $rootScope.routingPopup.close();
                }, 500)
            }
        });

        if (window.localStorage['syncdone'] == 1) {
            $timeout(function () {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg14), 'top', false, $rootScope.messagetimeout * 3, '');
            }, 3500);
            window.localStorage['syncdone'] = 0;
        }

        $scope.myOrders = function () {

            flag = 0;
            var ngcrt = ngCart.getItems();
            for (i = 0; i < ngcrt.length; i++) {
                if (ngcrt[i]._data.isordered > 0) {
                    flag = 1;
                    break;
                }
            }

            if (flag == 1) {
                $state.go("app.myOrders", {});
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl65), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $rootScope.menuclick = function () {
            if (window.localStorage['orderchoice'] == "true") {

                if (window.localStorage['startorder'] == "true") {
                    $state.go("app.menuGroup", {});
                } else {
                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg20), 'top', false, $rootScope.messagetimeout, '');
                }
            } else {

                $timeout(function () {
                    if (document.querySelector('.loadingData') != null)
                        document.querySelector('.loadingData').classList.add('loaded');
                }, 1000);
                $state.go("app.menuGroup", {});
                $rootScope.closeLoader();
            }
        }

        $scope.startorderclick = function () {
            if (window.localStorage['startorder'] == "false") {
                $scope.startordermsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl37);
                $scope.orderstatus = true;
                window.localStorage['startorder'] = true;
                if (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true") {
                    $rootScope.sendMessage("Connected");
                }

                $timeout(function () {
                    if (document.querySelector('.loadingData') != null)
                        document.querySelector('.loadingData').classList.add('loaded');
                }, 1000);
                window.localStorage["feedbacksubmitted"] = 'false';
                $state.go("app.menuGroup", {});
                $rootScope.closeLoader();
            } else {
                var itemcartordr = 0;
                var ngcrt = ngCart.getItems();
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered >= 0) {
                        itemcartordr = 1;
                        break;
                    }
                }

                var flag = 1;
                if (window.localStorage.getItem('waitermode') == 'false' && window.localStorage.getItem("feedbacksubmitted") == 'false' && window.localStorage.getItem("forcefeedback") == 'true') {
                    flag = 0;
                }
                if (flag == 1) {

                    if (itemcartordr == 1) {

                        var myPopup = $ionicPopup.show({
                            template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg12),
                            cssClass: 'custompopup completeordr',
                            title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl37),
                            scope: $scope,
                            buttons: [{
                                text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl122),
                                onTap: function (e) { }
                            }, {
                                text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl121),
                                type: 'button-positive',
                                onTap: function (e) {
                                    $scope.startordermsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl36);
                                    window.localStorage['startorder'] = false;
                                    if (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true") {
                                        $rootScope.sendMessage("Close");
                                    }
                                    $scope.orderstatus = false;

                                    if (window.localStorage['cmail'] == "" || window.localStorage['cmail'] == undefined) {

                                        ngCart.empty();
                                        $rootScope.clearCartItems(0);
                                        $rootScope.cartcounter = 0;
                                    } else {

                                        $scope.itemsInCart = ngCart.getItems();
                                        for (i = $scope.itemsInCart.length - 1; i >= 0; i--) {
                                            if ($scope.itemsInCart[i]._data.isordered == 0) {
                                                ngCart.removeItem(i);
                                            }

                                            if (i == 0) {
                                                $rootScope.clearCartItems(1);
                                                $rootScope.cartcounter = 0;
                                            }
                                        }
                                    }
                                }
                            },]
                        });
                    } else {
                        $scope.startordermsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl36);
                        window.localStorage['startorder'] = false;
                        if (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true") {
                            $rootScope.sendMessage("Close");
                        }
                        $scope.orderstatus = false;

                        if (window.localStorage['cmail'] == "" || window.localStorage['cmail'] == undefined) {

                            ngCart.empty();
                            $rootScope.clearCartItems(0);
                            $rootScope.cartcounter = 0;
                        } else {

                            $scope.itemsInCart = ngCart.getItems();
                            for (i = $scope.itemsInCart.length - 1; i >= 0; i--) {
                                if ($scope.itemsInCart[i]._data.isordered == 0) {
                                    ngCart.removeItem(i);
                                }

                                if (i == 0) {
                                    $rootScope.clearCartItems(1);
                                    $rootScope.cartcounter = 0;
                                }
                            }
                        }
                    }
                } else {
                    flag = 0;
                    var ngcrt = ngCart.getItems();
                    for (i = 0; i < ngcrt.length; i++) {
                        if (ngcrt[i]._data.isordered > 0) {
                            flag = 1;
                            break;
                        }
                    }

                    if (flag == 1) {
                        var myPopup = $ionicPopup.show({
                            template: 'Order can not be completed without feedback.',
                            cssClass: 'custompopup completeordr',
                            title: 'Alert',
                            scope: $scope,
                            buttons: [{
                                text: 'Got It',
                                onTap: function (e) { }
                            }]
                        });
                    } else {
                        $scope.startordermsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl36);
                        window.localStorage['startorder'] = false;
                        if (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true") {
                            $rootScope.sendMessage("Close");
                        }
                        $scope.orderstatus = false;

                        if (window.localStorage['cmail'] == "" || window.localStorage['cmail'] == undefined) {

                            ngCart.empty();
                            $rootScope.clearCartItems(0);
                            $rootScope.cartcounter = 0;
                        } else {

                            $scope.itemsInCart = ngCart.getItems();
                            for (i = $scope.itemsInCart.length - 1; i >= 0; i--) {
                                if ($scope.itemsInCart[i]._data.isordered == 0) {
                                    ngCart.removeItem(i);
                                }

                                if (i == 0) {
                                    $rootScope.clearCartItems(1);
                                    $rootScope.cartcounter = 0;
                                }
                            }
                        }
                    }
                }
            }
        }

        $scope.ldata = {};
        $scope.msg = '';
        var userdata = [];

        if (window.localStorage['cmail'] == "" || window.localStorage['cmail'] == undefined) {
            $scope.signinmthd = "signin";
            $scope.classn = "fa fa-sign-in icns";
        } else {
            $scope.signinmthd = "signout";
            $scope.classn = "fa fa-sign-out icns";
        }

        $scope.signout = function () {
            var myPopup = $ionicPopup.show({
                template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg27),
                cssClass: 'configpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl3),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl122),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl121),
                    type: 'button-positive',
                    onTap: function (e) {
                        $scope.signinmthd = "signin";
                        $scope.classn = "fa fa-sign-in icns";
                        window.localStorage['cid'] = "";
                        window.localStorage['cmail'] = "";
                        $rootScope.clearCartItems(0);
                        $rootScope.lastCartId = 1;
                        window.localStorage.setItem("orderunkid_array", '');
                        ngCart.empty();
                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg87), 'top', false, $rootScope.messagetimeout, '');
                    }
                },]
            });
        }

        $scope.active = {
            activetab: "signin"
        };

        $scope.changeDisp = function (activetab) {
            $scope.msg = '';
            if (activetab == 1)
                $scope.active['activetab'] = "signin";
            else
                $scope.active['activetab'] = "signup";
        }

        $scope.signin = function () {
            $state.go("app.customerloginsignup", {})
        }

        if (window.localStorage['logo_src'] == null || window.localStorage['logo_src'] == 'null') {
            window.localStorage['logo_src'] = '';
        }

        logo = window.localStorage['logo'];
        $scope.error = '';

        if (logo == '' || logo == "undefined" || logo == 'null' || logo == null) {
            $rootScope.htitle = '<div align="left" ng-click="configuration()">' + window.localStorage["resname"] + '</div>';
        } else {
            $rootScope.htitle = "<div align=left class='restlogodiv' ng-click='configuration()'><img src=" + window.localStorage['logo_src'] + window.localStorage['logo'] + "></div>";
        }

        var feedbacktype = window.localStorage['ifbacktype'];
        if (feedbacktype == 'iFeedback') {
            $scope.furl = "#/app/iFeedback"
        } else {
            $scope.furl = "#/app/feedback"
        }

        logo = window.localStorage['logo'];
        $scope.bannerImages = [];
        var tmp = window.localStorage["bannerimages"];
        if (tmp != undefined) {
            tmp = tmp.split(',');
            for (i = 0; i < tmp.length; i++) {
                $scope.bannerImages.push(tmp[i]);
            }
        }

        $rootScope.itemSearch = function () {
            $scope.menuItemAvailable = 1;
            if ($rootScope.menuItems[0].menugrpitemname == undefined)
                $scope.menuItemAvailable = 0;
            else {
                for (i = 0; i < $rootScope.menuItems.length; i++) {
                    $scope.menuItemAvailable = 1;
                    if ($rootScope.menuItems[i].modifieritemflag == 0) {
                        break;
                    } else
                        $scope.menuItemAvailable = 0;
                }
            }

            if ($scope.menuItemAvailable == 0) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg21), 'top', false, $rootScope.messagetimeout, '');
            } else {

                if (window.localStorage['orderchoice'] == "true") {

                    if (window.localStorage['startorder'] == "true") {

                        $state.go("app.menuItemSearch", {})
                    } else {
                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg20), 'top', false, $rootScope.messagetimeout, '');
                    }
                } else {
                    $state.go("app.menuItemSearch", {})
                }
            }
        }



        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.configuration = function () {
            if (localStorage.getItem("account") == 'demo')
                $scope.config = {
                    password: localStorage.getItem("upd"),
                    remember: Boolean(localStorage.getItem("remember"))
                };
            else {
                if (localStorage.getItem("remember") == 1)
                    $scope.config = {
                        password: localStorage.getItem("upd"),
                        remember: Boolean(localStorage.getItem("remember"))
                    };
                else
                    $scope.config = {
                        password: '',
                        remember: false
                    };
            }
            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupConfiguration.html',
                cssClass: 'configpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl62),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {
                        e.preventDefault();

                        if ($scope.config.password == undefined) { } else if ($scope.config.password.length > 0 && ($scope.config.password == localStorage.getItem("upd"))) {
                            if ($scope.config.remember == false)
                                window.localStorage.setItem('remember', 0);
                            else if ($scope.config.remember == true)
                                window.localStorage.setItem('remember', 1);
                            myPopup.close();
                            $state.go("app.configuration", {})
                        } else {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg5), 'top', false, $rootScope.messagetimeout, '');
                        }
                    }
                },]
            });
            myPopup.then(function (res) { });
        };
    })

    .controller('menuGroup', function ($rootScope, $scope, sharedProperties, ngCart, $timeout, $state, utf8_decodeFilter, $ionicPopup, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.$on('$ionicView.enter', function () {
            setTimeout(function () {
                if (document.querySelector('.loadingData') != null)
                    document.querySelector('.loadingData').classList.add('loaded');
            }, 1000);
            $scope.scopemenus = $rootScope.menus;
            $scope.menuavailable = 1;
            $scope.imagepath = $rootScope.get_server_path() + "upload/menugroup/";
            if ($scope.scopemenus[0].menugroupname == undefined)
                $scope.menuavailable = 0;
        });

        $scope.BackToHome = function () {
            $state.go("app.home", {});
        }

        $scope.reload = function () {
            event.preventDefault();
        }

        $scope.groupToItemList = function (menugroupunkids, indexs) {
            $state.go("app.menuItem/:menugroupunkid/:index", {
                menugroupunkid: menugroupunkids,
                index: indexs
            })
        }

        $scope.foodcart = function () {
            var flag = 0;
            var ngcrt = ngCart.getItems();

            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '')
            }
        }
    })

    .controller('menuItem', function ($rootScope, $scope, sharedProperties, $stateParams, ngCart, $timeout, $ionicScrollDelegate, $state, utf8_decodeFilter, $ionicPopup, $ionicSlideBoxDelegate, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();

            setTimeout(function () {
                if (document.querySelector('.loadingData') != null)
                    document.querySelector('.loadingData').classList.add('loaded');
            }, 1000)
        });

        $scope.anim = false;
        $scope.scopeMenuItems = [];
        $scope.scopeMenus = [];
        $scope.norate = '0';
        $scope.slide = [parseInt($stateParams.menugroupunkid), '', ''];
        $scope.ratemode = (localStorage.getItem("ratemode") == 'true') ? true : false;
        $scope.limit = [10, 10, 10];

        $scope.$on('$ionicView.enter', function () {

            $scope.scopeMenuItems = $rootScope.menuItems;
            $scope.scopeMenus = $rootScope.menus;
            $scope.name = {
                searchtext: ''
            };
            $scope.search = false;
            $scope.selectedMenuId = 0;
            $scope.numberOfItems = 0;
            $scope.selectedMenuIndex = 0;
            $scope.oldIndex = 0;
            $scope.selectedMenuId = $stateParams.menugroupunkid;
            $scope.selectedMenuIndex = $stateParams.index;
            $scope.currencysymbol = window.localStorage.getItem("currencysymbol");

            document.querySelectorAll('ion-slide')[0].style['height'] = window.innerHeight - 63 - document.querySelector('ion-header-bar').style['height'] + 'px';
            document.querySelectorAll('ion-slide')[1].style['height'] = window.innerHeight - 63 - document.querySelector('ion-header-bar').style['height'] + 'px';
            document.querySelectorAll('ion-slide')[2].style['height'] = window.innerHeight - 63 - document.querySelector('ion-header-bar').style['height'] + 'px';

            for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                $scope.scopeMenuItems[i].qty = 1;
            }

            if ($scope.selectedMenuId == '' || $scope.selectedMenuId == undefined) {
                $scope.selectedMenuId = $rootScope.menus[0].menugroupunkid;
            }

            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('menuGrpHorizontal').scrollBy(document.querySelector(".activetab").getBoundingClientRect().left - 40, 0, true);
            }, 50);
        });

        $scope.updateQTY = function (menugrpitemunkid, number, index) {

            for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                if ($scope.scopeMenuItems[i].menugrpitemunkid == menugrpitemunkid) {
                    if (number == -1 && ($scope.scopeMenuItems[i].qty != 1 || $scope.scopeMenuItems[i].qty != "1")) {
                        $scope.scopeMenuItems[i].qty = parseInt($scope.scopeMenuItems[i].qty) - 1;
                    } else if (number == 1) {
                        $scope.scopeMenuItems[i].qty = parseInt($scope.scopeMenuItems[i].qty) + 1;
                    }
                    break;
                }
            }
        }

        $scope.scrollItemTop = function () {
            $ionicScrollDelegate.$getByHandle('menuitemlist').scrollTop(true);
        }

        $scope.backToMenu = function () {
            $timeout(function () {
                if (document.querySelector('.loadingData') != null)
                    document.querySelector('.loadingData').classList.add('loaded');
            }, 1000);
            $state.go("app.menuGroup", {});
            $rootScope.closeLoader();
        }

        $scope.itemDetail = function (menugroupunkid, menugrpitemunkid) {

            if (event.target.classList.contains('cartbtn') == false && event.target.classList.contains('fa-plus') == false && event.target.classList.contains('fa-minus') == false) {
                for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                    if ($scope.scopeMenuItems[i].menugrpitemunkid == menugrpitemunkid) {
                        if (window.localStorage.getItem("orderchoice") == true || window.localStorage.getItem("orderchoice") == "true") {
                            $state.go("app.itemDetail/:menuGroupId/:menuItemId/:index/:qty", {
                                menuGroupId: menugroupunkid,
                                menuItemId: menugrpitemunkid,
                                index: $scope.selectedMenuIndex,
                                qty: $scope.scopeMenuItems[i].qty
                            })
                        } else {
                            $state.go("app.menuItemDetailViewOnly/:menuGroupId/:menuItemId/:index/:qty", {
                                menuGroupId: menugroupunkid,
                                menuItemId: menugrpitemunkid,
                                index: $scope.selectedMenuIndex
                            })
                        }
                        break;
                    }
                }
                var a = document.querySelectorAll(".activetab");
                for (i = 0; i < a.length; i++)
                    a[i].classList.remove("activetab")
            }
        }

        $scope.displayMenuItem = function (menuid, numberOfItems, index) {

            $ionicScrollDelegate.$getByHandle('menuitemlist').scrollTop(true);
            $scope.selectedMenuId = menuid;
            $scope.numberOfItems = numberOfItems;
            $scope.selectedMenuIndex = index;
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('menuGrpHorizontal').scrollBy(document.querySelector(".activetab").getBoundingClientRect().left - 40, 0, true);
            }, 50);
            if ($ionicSlideBoxDelegate.currentIndex() == 0) {
                $scope.slide[0] = parseInt(menuid);
                if (index == 0) {
                    $scope.slide[2] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 1].menugroupunkid);
                    $scope.slide[1] = parseInt($scope.scopeMenus[1].menugroupunkid);
                } else if (index == $scope.scopeMenus.length - 1) {
                    $scope.slide[2] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 2].menugroupunkid);
                    $scope.slide[1] = parseInt($scope.scopeMenus[0].menugroupunkid);
                } else {
                    $scope.slide[2] = parseInt($scope.scopeMenus[index - 1].menugroupunkid);
                    $scope.slide[1] = parseInt($scope.scopeMenus[index + 1].menugroupunkid);
                }
            } else if ($ionicSlideBoxDelegate.currentIndex() == 1) {
                $scope.slide[1] = parseInt(menuid);
                if (index == 0) {
                    $scope.slide[0] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 1].menugroupunkid);
                    $scope.slide[2] = parseInt($scope.scopeMenus[1].menugroupunkid);
                } else if (index == $scope.scopeMenus.length - 1) {
                    $scope.slide[0] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 2].menugroupunkid);
                    $scope.slide[2] = parseInt($scope.scopeMenus[0].menugroupunkid);
                } else {
                    $scope.slide[0] = parseInt($scope.scopeMenus[index - 1].menugroupunkid);
                    $scope.slide[2] = parseInt($scope.scopeMenus[index + 1].menugroupunkid);
                }
            } else if ($ionicSlideBoxDelegate.currentIndex() == 2) {
                $scope.slide[2] = parseInt(menuid);
                if (index == 0) {
                    $scope.slide[1] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 1].menugroupunkid);
                    $scope.slide[0] = parseInt($scope.scopeMenus[1].menugroupunkid);
                } else if (index == $scope.scopeMenus.length - 1) {
                    $scope.slide[1] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 2].menugroupunkid);
                    $scope.slide[0] = parseInt($scope.scopeMenus[0].menugroupunkid);
                } else {
                    $scope.slide[1] = parseInt($scope.scopeMenus[index - 1].menugroupunkid);
                    $scope.slide[0] = parseInt($scope.scopeMenus[index + 1].menugroupunkid);
                }
            }
        }

        $scope.slideHasChanged = function () {

            $scope.limit[0] = 10;
            $scope.limit[1] = 10;
            $scope.limit[2] = 10;
            $ionicScrollDelegate.$getByHandle('menuitemlist').scrollTop(true);
            var index = $ionicSlideBoxDelegate.currentIndex();
            if (index == 0) {
                if ($scope.oldIndex == 2) {
                    $scope.selectedMenuIndex++;
                } else if ($scope.oldIndex == 1) {
                    $scope.selectedMenuIndex--;
                }
            } else if (index == 1) {
                if ($scope.oldIndex == 0) {
                    $scope.selectedMenuIndex++;
                } else if ($scope.oldIndex == 2) {
                    $scope.selectedMenuIndex--;
                }
            } else if (index == 2) {
                if ($scope.oldIndex == 1) {
                    $scope.selectedMenuIndex++;
                } else if ($scope.oldIndex == 0) {
                    $scope.selectedMenuIndex--;
                }
            }

            if ($scope.selectedMenuIndex < 0)
                $scope.selectedMenuIndex = $scope.scopeMenus.length - 1;
            else if ($scope.selectedMenuIndex == $scope.scopeMenus.length)
                $scope.selectedMenuIndex = 0;

            $scope.oldIndex = index;
            $scope.slide[index] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex].menugroupunkid);
            $scope.selectedMenuId = $scope.scopeMenus[$scope.selectedMenuIndex].menugroupunkid;
            $scope.name = {
                searchtext: ''
            };

            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('menuGrpHorizontal').scrollBy(document.querySelector(".activetab").getBoundingClientRect().left - 40, 0, true);

                if (index == 0) {
                    if ($scope.selectedMenuIndex == 0) {
                        $scope.slide[2] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 1].menugroupunkid);
                        $scope.slide[1] = parseInt($scope.scopeMenus[1].menugroupunkid);
                    } else if ($scope.selectedMenuIndex == $scope.scopeMenus.length - 1) {
                        $scope.slide[2] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 2].menugroupunkid);
                        $scope.slide[1] = parseInt($scope.scopeMenus[0].menugroupunkid);
                    } else {
                        $scope.slide[2] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex - 1].menugroupunkid);
                        $scope.slide[1] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex + 1].menugroupunkid);
                    }
                } else if (index == 1) {
                    if ($scope.selectedMenuIndex == 0) {
                        $scope.slide[0] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 1].menugroupunkid);
                        $scope.slide[2] = parseInt($scope.scopeMenus[1].menugroupunkid);
                    } else if ($scope.selectedMenuIndex == $scope.scopeMenus.length - 1) {
                        $scope.slide[0] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 2].menugroupunkid);
                        $scope.slide[2] = parseInt($scope.scopeMenus[0].menugroupunkid);
                    } else {
                        $scope.slide[0] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex - 1].menugroupunkid);
                        $scope.slide[2] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex + 1].menugroupunkid);
                    }
                } else if (index == 2) {
                    if ($scope.selectedMenuIndex == 0) {
                        $scope.slide[1] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 1].menugroupunkid);
                        $scope.slide[0] = parseInt($scope.scopeMenus[1].menugroupunkid);
                    } else if ($scope.selectedMenuIndex == $scope.scopeMenus.length - 1) {
                        $scope.slide[1] = parseInt($scope.scopeMenus[$scope.scopeMenus.length - 2].menugroupunkid);
                        $scope.slide[0] = parseInt($scope.scopeMenus[0].menugroupunkid);
                    } else {
                        $scope.slide[1] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex - 1].menugroupunkid);
                        $scope.slide[0] = parseInt($scope.scopeMenus[$scope.selectedMenuIndex + 1].menugroupunkid);
                    }
                }
            }, 50)
        }

        $scope.slideRight = function () {
            $ionicScrollDelegate.$getByHandle('menuGrpHorizontal').scrollBy(300, 0, 10000);
        }

        $scope.slideLeft = function () {
            $ionicScrollDelegate.$getByHandle('menuGrpHorizontal').scrollBy(-300, 0, 10000);
        }

        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'topdetail', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.increaseLimit = function (index) {
            //if ($scope.) {
            //    //code
            //}
            //document.querySelector('.loadMoreItems').style['bottom'] = '20px'
            $scope.limit[index] += 10;
            //$timeout(function(){
            //    document.querySelector('.loadMoreItems').style['bottom'] = '-100px'
            //}, 1000);
        }

        $scope.searchItem = function () {
            if ($scope.search == false) {
                document.querySelector(".searchdivmenuitem").style['display'] = 'block';
                $scope.search = true;
                $scope.anim = true;
                $scope.name.searchtext = '';
            } else {
                $timeout(function () {
                    document.querySelector(".searchdivmenuitem").style['display'] = 'none';
                }, 400);
                $scope.name.searchtext = '';
                $scope.search = false;
                $scope.anim = false;
            }
        }

        $scope.resetSearch = function () {
            $scope.name.searchtext = '';
            $scope.search = false;
        }

        $scope.addtocart = function (index, menugroupunkid, menugrpitemunkid) {
            // var a = event.target;
            // if(!a.classList.contains("diable_addtocart_btn")){
            // a.classList.add("diable_addtocart_btn");
            // $timeout(function(){
            // a.classList.remove("diable_addtocart_btn");
            // }, 2000)

            var added = false;

            for (ii = 0; ii < $scope.scopeMenuItems.length; ii++) {
                if ($scope.scopeMenuItems[ii].menugrpitemunkid == menugrpitemunkid) {
                    if ($scope.scopeMenuItems[ii].modifierunkid == 0 && JSON.parse($scope.scopeMenuItems[ii].price).length == 1) {
                        $scope.data = [];
                        $scope.data.cartid = $rootScope.lastCartId;
                        $scope.data.iscustomremark = '';
                        $scope.data.isordered = 0;
                        $scope.data.itemid = $scope.scopeMenuItems[ii].menugrpitemunkid;
                        $scope.data.menugroupcode = $scope.scopeMenuItems[ii].menugrpitem_code;
                        $scope.data.menuitemcode = '';
                        $scope.data.menuitemremark = '';
                        $scope.data.menuitemtype = '';
                        $scope.data.modifierunkid = [];
                        $scope.data.orderSeq = (ngCart.getItems().length) + 1;
                        $scope.data.unit = JSON.parse($scope.scopeMenuItems[ii].price)[0].unitname;
                        $scope.data.unitid = JSON.parse($scope.scopeMenuItems[ii].price)[0].unitid;
                        $scope.data.rating = 1;
                        $rootScope.foodcart = 2;
                        flag = 1;
                        var ngcrt = ngCart.getItems();
                        for (i = 0; i < ngcrt.length; i++) {
                            if (ngcrt[i]._data.isordered == 0 && ngcrt[i]._data.itemid == $scope.scopeMenuItems[ii].menugrpitemunkid) {
                                flag = 0;
                                document.querySelector('.cartanim').classList.add('cartanimation');
                                var qty = parseInt(ngcrt[i]._quantity + parseInt($scope.scopeMenuItems[ii].qty));
                                ngcrt[i]._quantity = qty;
                                $rootScope.incrementCartRowItem(ngcrt[i]._data.cartid, qty);
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl139) + " " + $scope.scopeMenuItems[ii].menugrpitemname + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl140), 'topdetail', false, $rootScope.messagetimeout, '');
                                $timeout(function () {
                                    document.querySelector('.cartanim').classList.remove('cartanimation');
                                }, 320);
                                added = true;
                                break;
                            }
                        }

                        if (flag == 1) {
                            document.querySelector('.cartanim').classList.add('cartanimation');
                            ionicToast.show($scope.scopeMenuItems[ii].menugrpitemname + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl136), 'topdetail', false, $rootScope.messagetimeout, '');
                            if (ngCart.getItems().length > 0)
                                id = (ngCart.getItems()[ngCart.getItems().length - 1]._id) + 1;
                            else
                                id = 1;
                            $rootScope.cartcounter++;
                            $timeout(function () {
                                document.querySelector('.cartanim').classList.remove('cartanimation');
                            }, 320);
                            ngCart.addItem(id, $scope.scopeMenuItems[ii].menugrpitemname, JSON.parse($scope.scopeMenuItems[ii].price)[0].unitprice, parseInt($scope.scopeMenuItems[ii].qty), $scope.data);
                            added = true;
                            $rootScope.addToCart($scope.data.itemid, $scope.scopeMenuItems[ii].menugrpitemname, JSON.parse($scope.scopeMenuItems[ii].price)[0].unitprice, $scope.data.menugroupcode, $scope.data.menuitemcode, $scope.data.menuitemtype, $scope.data.unitid, $scope.data.unit, JSON.parse($rootScope.menuItems[ii].price)[0].unitprice, $scope.data.modifierunkid, id, $scope.data.menuitemremark, '', parseInt($scope.scopeMenuItems[ii].qty));
                            $rootScope.getCartId();
                        }
                    }

                    if (added == false) {
                        for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                            if ($scope.scopeMenuItems[i].menugrpitemunkid == menugrpitemunkid) {
                                if (window.localStorage.getItem("orderchoice") == true || window.localStorage.getItem("orderchoice") == "true") {
                                    $state.go("app.itemDetail/:menuGroupId/:menuItemId/:index/:qty", {
                                        menuGroupId: menugroupunkid,
                                        menuItemId: menugrpitemunkid,
                                        index: $scope.selectedMenuIndex,
                                        qty: $scope.scopeMenuItems[i].qty
                                    })
                                } else {
                                    $state.go("app.menuItemDetailViewOnly/:menuGroupId/:menuItemId/:index/:qty", {
                                        menuGroupId: menugroupunkid,
                                        menuItemId: menugrpitemunkid,
                                        index: $scope.selectedMenuIndex
                                    })
                                }
                                break;
                            }
                        }
                    }
                    break;
                }
            }
            // }
        }
    })

    .controller('menuItemDetailViewOnly', function ($rootScope, $scope, sharedProperties, $stateParams, $timeout, $ionicLoading, $state, ngCart, utf8_decodeFilter, $ionicPopup, $ionicScrollDelegate, $ionicHistory, $ionicSlideBoxDelegate, $http, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.title = '';
        $scope.menuItemsDetail = [];
        $scope.selectedGroupId = $stateParams.menuGroupId;
        $scope.selectedItemId = $stateParams.menuItemId;
        $scope.active = 0;
        var jj = 0;
        $scope.ratemode = (localStorage.getItem("ratemode") == 'true') ? true : false;
        $scope.imagepath = $rootScope.get_server_path() + "upload/item/";
        $scope.currencysymbol = localStorage.getItem("currencysymbol");
        $scope.oldIndex = 0;
        $scope.slide = [{
            id: -1,
            unkid: 0
        }, {
            id: -1,
            unkid: 0
        }, {
            id: -1,
            unkid: 0
        }];

        var obj = new Object;
        var obj_mod_item = new Object;

        for (i = 0; i < $rootScope.menuItems.length; i++) {
            if ($rootScope.menuItems[i].menugroupunkid == $scope.selectedGroupId) {
                obj = [];

                if ($scope.slide[0].id == -1) {
                    $scope.slide[0].id = jj;
                    $scope.slide[0].unkid = parseInt($rootScope.menuItems[i].menugrpitemunkid);
                } else if ($scope.slide[1].id == -1) {
                    $scope.slide[1].id = jj;
                    $scope.slide[1].unkid = parseInt($rootScope.menuItems[i].menugrpitemunkid);
                } else if ($scope.slide[2].id == -1) {
                    $scope.slide[2].id = jj;
                    $scope.slide[2].unkid = parseInt($rootScope.menuItems[i].menugrpitemunkid);
                }
                jj++;
                if ($rootScope.menuItems[i].menugrpitemunkid == $scope.selectedItemId) {
                    $scope.title = $rootScope.menuItems[i].menugrpitemname;
                    $scope.active = jj;
                }

                if ($rootScope.menuItems[i].modifierunkid != '') {
                    var itemModifier = $rootScope.menuItems[i].modifierunkid.split(",");
                    for (m = 0; m < itemModifier.length; m++) {
                        for (j = 0; j < $rootScope.modifiers.length; j++) {
                            if ($rootScope.modifiers[j].modifiergrpunkid == itemModifier[m]) {
                                var modif = new Object;
                                modif.modifiername = $rootScope.modifiers[j].modifiername;
                                modif.checkedmodifieritems = $rootScope.modifiers[j].checkedmodifieritems;
                                modif.isforced = $rootScope.modifiers[j].isforced;
                                modif.modifiermaxqty = $rootScope.modifiers[j].modifiermaxqty;
                                modif.modifierminqty = $rootScope.modifiers[j].modifierminqty;
                                modif.usedasmodifier = $rootScope.modifiers[j].usedasmodifier;
                                modif.modifiergrpunkid = $rootScope.modifiers[j].modifiergrpunkid;
                                modif.modifierItems = [];

                                if ($rootScope.modifiers[j].menugrpitemunkid.length > 4) {
                                    for (l = 0; l < JSON.parse($rootScope.modifiers[j].menugrpitemunkid).length; l++) {
                                        for (k = 0; k < $rootScope.menuItems.length; k++) {
                                            if ($rootScope.menuItems[k].modifieritemflag == 1 && JSON.parse($rootScope.modifiers[j].menugrpitemunkid)[l] == $rootScope.menuItems[k].menugrpitemunkid) {
                                                obj_mod_item = [];
                                                obj_mod_item.defaultunit = $rootScope.menuItems[k].defaultunit;
                                                obj_mod_item.menugrpitem_code = $rootScope.menuItems[k].menugrpitem_code;
                                                obj_mod_item.menugrpitemname = $rootScope.menuItems[k].menugrpitemname;
                                                obj_mod_item.menugrpitemprice = $rootScope.menuItems[k].menugrpitemprice;
                                                obj_mod_item.price = JSON.parse($rootScope.menuItems[k].price);
                                                obj_mod_item.isopenprice = $rootScope.menuItems[k].isopenprice;
                                                obj_mod_item.menugrpitemunkid = $rootScope.menuItems[k].menugrpitemunkid;
                                                modif.modifierItems.push(obj_mod_item);
                                                break;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        obj.push(modif)
                    }
                }

                var obj_item = new Object;
                obj_item.defaultunit = $rootScope.menuItems[i].defaultunit;
                obj_item.menugroupunkid = $rootScope.menuItems[i].menugroupunkid;
                obj_item.menugrpitem_code = $rootScope.menuItems[i].menugrpitem_code;
                obj_item.menugrpitem_isnonveg = $rootScope.menuItems[i].menugrpitem_isnonveg;
                obj_item.menugrpitem_isspicy = $rootScope.menuItems[i].menugrpitem_isspicy;
                obj_item.menugrpitem_type = $rootScope.menuItems[i].menugrpitem_type;
                obj_item.menugrpitemdescr = $rootScope.menuItems[i].menugrpitemdescr;
                obj_item.menugrpitemimage = $rootScope.menuItems[i].menugrpitemimage;
                obj_item.menugrpitemmodifier = $rootScope.menuItems[i].menugrpitemmodifier;
                obj_item.menugrpitemname = $rootScope.menuItems[i].menugrpitemname;
                obj_item.menugrpitemprice = $rootScope.menuItems[i].menugrpitemprice;
                obj_item.menugrpitemunkid = $rootScope.menuItems[i].menugrpitemunkid;
                obj_item.modifieritemflag = $rootScope.menuItems[i].modifieritemflag;
                obj_item.modifierunkid = $rootScope.menuItems[i].modifierunkid;
                obj_item.price = JSON.parse($rootScope.menuItems[i].price);
                if ($rootScope.menuItems[i].menugrpitemunkid == $scope.selectedItemId) {
                    obj_item.qty = parseInt($stateParams.qty);
                } else
                    obj_item.qty = $rootScope.menuItems[i].qty;

                obj_item.rating = ($rootScope.menuItems[i].rating == null) ? '0' : $rootScope.menuItems[i].rating;
                obj_item.selectedunit = $rootScope.menuItems[i].selectedunit;
                obj_item.servingunit = $rootScope.menuItems[i].servingunit;
                obj_item.total = $rootScope.menuItems[i].total;
                obj_item.modifiers = obj;
                $scope.menuItemsDetail.push(obj_item)
            }

            if (i == $rootScope.menuItems.length - 1) {

                if ($scope.active > 3) {

                    $scope.slide[2]['id'] = $scope.active - 2;
                    $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[$scope.active - 2].menugrpitemunkid);

                    $scope.slide[0]['id'] = $scope.active - 1;
                    $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[$scope.active - 1].menugrpitemunkid);

                    if ($scope.active == $scope.menuItemsDetail.length) {
                        $scope.slide[1]['id'] = 0;
                        $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[0].menugrpitemunkid);
                    } else {
                        $scope.slide[1]['id'] = $scope.active;
                        $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[$scope.active].menugrpitemunkid);
                    }
                } else {

                    if ($scope.slide[1]['id'] != -1 && $scope.slide[2]['id'] == -1) {
                        $scope.slide[2]['id'] = $scope.slide[0]['id'];
                        $scope.slide[2]['unkid'] = $scope.slide[0]['unkid'];
                    }
                }
            }
        }
        if ($scope.active > 3) {
            $scope.activeSlide = 0;
        } else {
            $scope.activeSlide = $scope.active - 1;
        }
        $scope.active--;

        $scope.slideHasChanged = function (index) {
            $scope.currentSlide = $ionicSlideBoxDelegate.currentIndex();
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('menuitemdetail').scrollTop(true);
            }, 500)

            $scope.title = $scope.menuItemsDetail[$scope.slide[$scope.currentSlide]['id']].menugrpitemname;

            if ($scope.currentSlide == 0) {

                if ($scope.oldIndex == 2) {
                    $scope.active++;
                } else if ($scope.oldIndex == 1) {
                    $scope.active--;
                }
            } else if ($scope.currentSlide == 1) {

                if ($scope.oldIndex == 0) {
                    $scope.active++;
                } else if ($scope.oldIndex == 2) {
                    $scope.active--;
                }
            } else if ($scope.currentSlide == 2) {

                if ($scope.oldIndex == 1) {
                    $scope.active++;
                } else if ($scope.oldIndex == 0) {
                    $scope.active--;
                }
            }

            $scope.updateSlide();
            $scope.oldIndex = $scope.currentSlide;
        }

        $scope.updateSlide = function () {

            var prev = 0;
            var current = 0;
            var next = 0;
            if ($scope.active == $scope.menuItemsDetail.length - 1 || $scope.active == -1) {
                prev = $scope.menuItemsDetail.length - 2;
                current = $scope.menuItemsDetail.length - 1;
                next = 0;
            } else if ($scope.active == 0 || $scope.active == $scope.menuItemsDetail.length) {
                prev = $scope.menuItemsDetail.length - 1;
                current = 0;
                next = 1;
            } else {
                prev = $scope.active - 1;
                current = $scope.active;
                next = $scope.active + 1;
            }
            $scope.active = current;

            if ($scope.currentSlide == 0) {

                $scope.slide[2]['id'] = prev;
                $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[prev].menugrpitemunkid);

                $scope.slide[0]['id'] = current;
                $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[current].menugrpitemunkid);

                $scope.slide[1]['id'] = next;
                $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[next].menugrpitemunkid);
            } else if ($scope.currentSlide == 1) {

                $scope.slide[0]['id'] = prev;
                $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[prev].menugrpitemunkid);

                $scope.slide[1]['id'] = current;
                $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[current].menugrpitemunkid);

                $scope.slide[2]['id'] = next;
                $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[next].menugrpitemunkid);
            } else if ($scope.currentSlide == 2) {

                $scope.slide[1]['id'] = prev;
                $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[prev].menugrpitemunkid);

                $scope.slide[2]['id'] = current;
                $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[current].menugrpitemunkid);

                $scope.slide[0]['id'] = next;
                $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[next].menugrpitemunkid);
            }
        }

        $scope.foodcart = function () {
            $scope.carterror = '';
            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.nextSlide = function () {
            $ionicSlideBoxDelegate.next();
        }

        $scope.previousSlide = function () {
            $ionicSlideBoxDelegate.previous();
        }

        $scope.cancel = function () {

            if ($stateParams.index == -1) {

                $state.go("app.menuItemSearch", {});
            } else {

                $state.go("app.menuItem/:menugroupunkid/:index", {
                    menugroupunkid: $scope.selectedGroupId,
                    index: $stateParams.index
                })
            }
        }

        $scope.displayModifierUnits = function (modifierid, index) {
            for (i = 0; i < $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers.length; i++) {
                if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifiergrpunkid == modifierid) {
                    if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[index].isopenprice == false)
                        $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[index].isopenprice = true;
                    else
                        $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[index].isopenprice = false;
                    break;
                }
            }
        }
    })

    .controller('itemDetail', function ($rootScope, $scope, sharedProperties, $stateParams, $timeout, $ionicLoading, $state, ngCart, utf8_decodeFilter, $ionicPopup, $ionicScrollDelegate, $ionicHistory, $ionicSlideBoxDelegate, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.oldIndex = 0;
        $scope.slide = [{
            id: -1,
            unkid: 0,
            name: ''
        }, {
            id: -1,
            unkid: 0,
            name: ''
        }, {
            id: -1,
            unkid: 0,
            name: ''
        }];
        $scope.title = '';
        $scope.menuItemsDetail = [];
        $scope.selectedGroupId = $stateParams.menuGroupId;
        $scope.selectedItemId = $stateParams.menuItemId;
        $scope.active = 0;
        var jj = 0;
        $scope.imagepath = $rootScope.get_server_path() + "upload/item/";
        $scope.currencysymbol = localStorage.getItem("currencysymbol");
        $scope.ratemode = (localStorage.getItem("ratemode") == 'true') ? true : false;

        var obj = new Object;
        var obj_mod_item = new Object;
        for (i = 0; i < $rootScope.menuItems.length; i++) {
            if ($rootScope.menuItems[i].menugroupunkid == $scope.selectedGroupId) {
                obj = [];
                if ($scope.slide[0].id == -1) {
                    $scope.slide[0].id = jj;
                    $scope.slide[0].unkid = parseInt($rootScope.menuItems[i].menugrpitemunkid);
                    $scope.slide[0].name = $rootScope.menuItems[i].menugrpitemname;
                } else if ($scope.slide[1].id == -1) {
                    $scope.slide[1].id = jj;
                    $scope.slide[1].unkid = parseInt($rootScope.menuItems[i].menugrpitemunkid);
                    $scope.slide[1].name = $rootScope.menuItems[i].menugrpitemname;
                } else if ($scope.slide[2].id == -1) {
                    $scope.slide[2].id = jj;
                    $scope.slide[2].unkid = parseInt($rootScope.menuItems[i].menugrpitemunkid);
                    $scope.slide[2].name = $rootScope.menuItems[i].menugrpitemname;
                }

                jj++;
                if ($rootScope.menuItems[i].menugrpitemunkid == $scope.selectedItemId) {
                    $scope.title = $rootScope.menuItems[i].menugrpitemname;
                    $scope.active = jj;
                }

                if ($rootScope.menuItems[i].modifierunkid != '') {
                    var itemModifier = $rootScope.menuItems[i].modifierunkid.split(",");
                    for (m = 0; m < itemModifier.length; m++) {
                        for (j = 0; j < $rootScope.modifiers.length; j++) {
                            if ($rootScope.modifiers[j].modifiergrpunkid == itemModifier[m]) {
                                var modif = new Object;
                                modif.modifiername = $rootScope.modifiers[j].modifiername;
                                modif.checkedmodifieritems = $rootScope.modifiers[j].checkedmodifieritems;
                                modif.isforced = $rootScope.modifiers[j].isforced;
                                modif.modifiermaxqty = $rootScope.modifiers[j].modifiermaxqty;
                                modif.modifierminqty = $rootScope.modifiers[j].modifierminqty;
                                modif.usedasmodifier = $rootScope.modifiers[j].usedasmodifier;
                                modif.modifiergrpunkid = $rootScope.modifiers[j].modifiergrpunkid;
                                modif.modifierItems = [];

                                if ($rootScope.modifiers[j].menugrpitemunkid.length > 4) {
                                    for (l = 0; l < JSON.parse($rootScope.modifiers[j].menugrpitemunkid).length; l++) {
                                        for (k = 0; k < $rootScope.menuItems.length; k++) {
                                            if ($rootScope.menuItems[k].modifieritemflag == 1 && JSON.parse($rootScope.modifiers[j].menugrpitemunkid)[l] == $rootScope.menuItems[k].menugrpitemunkid) {
                                                obj_mod_item = [];
                                                obj_mod_item.defaultunit = $rootScope.menuItems[k].defaultunit;
                                                obj_mod_item.menugrpitem_code = $rootScope.menuItems[k].menugrpitem_code;
                                                obj_mod_item.menugrpitemname = $rootScope.menuItems[k].menugrpitemname;
                                                obj_mod_item.menugrpitemprice = $rootScope.menuItems[k].menugrpitemprice;
                                                obj_mod_item.price = JSON.parse($rootScope.menuItems[k].price);
                                                obj_mod_item.isopenprice = $rootScope.menuItems[k].isopenprice;
                                                obj_mod_item.menugrpitemunkid = $rootScope.menuItems[k].menugrpitemunkid;
                                                modif.modifierItems.push(obj_mod_item);
                                                break;
                                            }
                                        }
                                    }
                                }
                                break;
                            }
                        }
                        obj.push(modif);
                        modif = [];
                    }
                }

                var obj_item = new Object;
                obj_item.defaultunit = $rootScope.menuItems[i].defaultunit;
                obj_item.menugroupunkid = $rootScope.menuItems[i].menugroupunkid;
                obj_item.menugrpitem_code = $rootScope.menuItems[i].menugrpitem_code;
                obj_item.menugrpitem_isnonveg = $rootScope.menuItems[i].menugrpitem_isnonveg;
                obj_item.menugrpitem_isspicy = $rootScope.menuItems[i].menugrpitem_isspicy;
                obj_item.menugrpitem_type = $rootScope.menuItems[i].menugrpitem_type;
                obj_item.menugrpitemdescr = $rootScope.menuItems[i].menugrpitemdescr;
                obj_item.menugrpitemimage = $rootScope.menuItems[i].menugrpitemimage;
                obj_item.menugrpitemmodifier = $rootScope.menuItems[i].menugrpitemmodifier;
                obj_item.menugrpitemname = $rootScope.menuItems[i].menugrpitemname;
                obj_item.menugrpitemprice = $rootScope.menuItems[i].menugrpitemprice;
                obj_item.menugrpitemunkid = $rootScope.menuItems[i].menugrpitemunkid;
                obj_item.modifieritemflag = $rootScope.menuItems[i].modifieritemflag;
                obj_item.modifierunkid = $rootScope.menuItems[i].modifierunkid;
                obj_item.price = JSON.parse($rootScope.menuItems[i].price);
                if ($rootScope.menuItems[i].menugrpitemunkid == $scope.selectedItemId) {
                    obj_item.qty = parseInt($stateParams.qty);
                } else
                    obj_item.qty = $rootScope.menuItems[i].qty;

                obj_item.rating = $rootScope.menuItems[i].rating;
                obj_item.selectedunit = $rootScope.menuItems[i].selectedunit;
                obj_item.servingunit = $rootScope.menuItems[i].servingunit;
                obj_item.total = $rootScope.menuItems[i].total;
                obj_item.modifiers = obj;
                $scope.menuItemsDetail.push(obj_item)
            }

            if (i == $rootScope.menuItems.length - 1) {
                if ($scope.active > 3) {

                    $scope.slide[2]['id'] = $scope.active - 2;
                    $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[$scope.active - 2].menugrpitemunkid);
                    $scope.slide[2]['name'] = $scope.menuItemsDetail[$scope.active - 2].menugrpitemname;

                    $scope.slide[0]['id'] = $scope.active - 1;
                    $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[$scope.active - 1].menugrpitemunkid);
                    $scope.slide[0]['name'] = $scope.menuItemsDetail[$scope.active - 1].menugrpitemname;

                    if ($scope.active == $scope.menuItemsDetail.length) {
                        $scope.slide[1]['id'] = 0;
                        $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[0].menugrpitemunkid);
                        $scope.slide[1]['name'] = $scope.menuItemsDetail[0].menugrpitemname;
                    } else {
                        $scope.slide[1]['id'] = $scope.active;
                        $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[$scope.active].menugrpitemunkid);
                        $scope.slide[1]['name'] = $scope.menuItemsDetail[$scope.active].menugrpitemname;
                    }
                } else {

                    if ($scope.slide[1]['id'] != -1 && $scope.slide[2]['id'] == -1) {
                        $scope.slide[2]['id'] = $scope.slide[0]['id'];
                        $scope.slide[2]['unkid'] = $scope.slide[0]['unkid'];
                        $scope.slide[2]['name'] = $scope.slide[0]['name'];
                    }
                }
            }
        }


        if ($scope.active > 3) {
            $scope.activeSlide = 0;
        } else {
            $scope.activeSlide = $scope.active - 1;
        }
        $scope.oldIndex = $scope.activeSlide;
        $scope.active--;

        $scope.updateQTY = function (menugrpitemunkid, number, index) {

            // for(var i=0; i<$scope.menuItemsDetail.length; i++){

            // if($scope.menuItemsDetail[index].menugrpitemunkid == menugrpitemunkid)
            // {
            if (number == -1 && ($scope.menuItemsDetail[index].qty != 1 || $scope.menuItemsDetail[index].qty != "1")) {
                $scope.menuItemsDetail[index].qty = parseInt($scope.menuItemsDetail[index].qty) - 1;
            } else if (number == 1) {
                $scope.menuItemsDetail[index].qty = parseInt($scope.menuItemsDetail[index].qty) + 1;
            }
            // break;
            // }
            // }
        }

        $scope.nextSlide = function () {
            $ionicSlideBoxDelegate.next();
        }

        $scope.previousSlide = function () {
            $ionicSlideBoxDelegate.previous();
        }

        $scope.slideHasChanged = function () {

            $scope.currentSlide = $ionicSlideBoxDelegate.currentIndex();
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('menuitemdetail').scrollTop(true);
            }, 500)

            $scope.title = $scope.menuItemsDetail[$scope.slide[$scope.currentSlide]['id']].menugrpitemname;

            if ($scope.currentSlide == 0) {

                if ($scope.oldIndex == 2) {
                    $scope.active++;
                } else if ($scope.oldIndex == 1) {
                    $scope.active--;
                }
            } else if ($scope.currentSlide == 1) {

                if ($scope.oldIndex == 0) {
                    $scope.active++;
                } else if ($scope.oldIndex == 2) {
                    $scope.active--;
                }
            } else if ($scope.currentSlide == 2) {

                if ($scope.oldIndex == 1) {
                    $scope.active++;
                } else if ($scope.oldIndex == 0) {
                    $scope.active--;
                }
            }

            $scope.updateSlide();
            $scope.oldIndex = $scope.currentSlide;
        }


        $scope.updateSlide = function () {

            var prev = 0;
            var current = 0;
            var next = 0;
            if ($scope.active == $scope.menuItemsDetail.length - 1 || $scope.active == -1) {
                prev = $scope.menuItemsDetail.length - 2;
                current = $scope.menuItemsDetail.length - 1;
                next = 0;
            } else if ($scope.active == 0 || $scope.active == $scope.menuItemsDetail.length) {
                prev = $scope.menuItemsDetail.length - 1;
                current = 0;
                next = 1;
            } else {
                prev = $scope.active - 1;
                current = $scope.active;
                next = $scope.active + 1;
            }
            $scope.active = current;

            if ($scope.currentSlide == 0) {

                $scope.slide[2]['id'] = prev;
                $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[prev].menugrpitemunkid);
                $scope.slide[2]['name'] = $scope.menuItemsDetail[prev].menugrpitemname;

                $scope.slide[0]['id'] = current;
                $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[current].menugrpitemunkid);
                $scope.slide[0]['name'] = $scope.menuItemsDetail[current].menugrpitemname;

                $scope.slide[1]['id'] = next;
                $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[next].menugrpitemunkid);
                $scope.slide[1]['name'] = $scope.menuItemsDetail[current].menugrpitemname;
            } else if ($scope.currentSlide == 1) {

                $scope.slide[0]['id'] = prev;
                $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[prev].menugrpitemunkid);
                $scope.slide[0]['name'] = $scope.menuItemsDetail[prev].menugrpitemname;

                $scope.slide[1]['id'] = current;
                $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[current].menugrpitemunkid);
                $scope.slide[1]['name'] = $scope.menuItemsDetail[current].menugrpitemname;

                $scope.slide[2]['id'] = next;
                $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[next].menugrpitemunkid);
                $scope.slide[2]['name'] = $scope.menuItemsDetail[next].menugrpitemname;
            } else if ($scope.currentSlide == 2) {

                $scope.slide[1]['id'] = prev;
                $scope.slide[1]['unkid'] = parseInt($scope.menuItemsDetail[prev].menugrpitemunkid);
                $scope.slide[1]['name'] = $scope.menuItemsDetail[prev].menugrpitemname;

                $scope.slide[2]['id'] = current;
                $scope.slide[2]['unkid'] = parseInt($scope.menuItemsDetail[current].menugrpitemunkid);
                $scope.slide[2]['name'] = $scope.menuItemsDetail[current].menugrpitemname;

                $scope.slide[0]['id'] = next;
                $scope.slide[0]['unkid'] = parseInt($scope.menuItemsDetail[next].menugrpitemunkid);
                $scope.slide[0]['name'] = $scope.menuItemsDetail[next].menugrpitemname;
            }
        }

        $scope.error = [];
        $scope.unit = '';

        $scope.addtoCart = function () {

            var a = event.target;

            $scope.item = [];
            $scope.data = {};
            $scope.error = [];
            $scope.unit = 0;
            $scope.itemname = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].menugrpitemname;
            var newId = 0;
            $scope.errormsg = '';
            if (ngCart.getItems().length > 0) {
                $scope.data.cartid = $rootScope.lastCartId;
                $scope.item.id = (ngCart.getItems()[ngCart.getItems().length - 1]._id) + 1;
            } else {
                $scope.data.cartid = $rootScope.lastCartId;
                $scope.item.id = 1;
            }

            $scope.data.itemid = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].menugrpitemunkid;
            $scope.item.name = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].menugrpitemname;
            $scope.data.unitid = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].selectedunit;
            $scope.item.quantity = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].qty;
            $scope.data.menugroupcode = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].menugroupunkid;
            $scope.data.menuitemcode = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].menugrpitem_code;
            $scope.data.menuitemtype = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].menugrpitem_type;
            $scope.data.orderSeq = (ngCart.getItems().length) + 1;
            $scope.data.menuitemremark = '';
            $scope.data.iscustomremark = '';
            $scope.data.isordered = 0;
            $scope.data.rating = 1;

            var total = 0;
            var modif = [];

            if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers != null && $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers.length > 0) {
                for (i = 0; i < $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers.length; i++) {
                    var tmp = 0;
                    for (j = 0; j < $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems.length; j++) {
                        if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].isopenprice == true) // Do not go with name openprise, Here it shows Checked or not
                        {
                            tmp++;
                            var unitname = '';
                            var unitprice = '';
                            for (k = 0; k < $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].price.length; k++) {
                                if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].price[k].unitid == $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].defaultunit) {
                                    unitname = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].price[k].unitname;
                                    unitprice = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].price[k].unitprice;
                                    total += parseFloat(unitprice);
                                }
                            }

                            modif.push({
                                cartid: 1,
                                modifieritemunkid: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].menugrpitemunkid,
                                unitid: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].defaultunit,
                                unitname: unitname,
                                modifieritemname: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].menugrpitemname,
                                modifieritemprice: unitprice,
                                modifiertype: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].isopenprice,
                                modifiergrpunkid: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifiergrpunkid,
                                modifieritem_code: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierItems[j].menugrpitem_code
                            });
                        }
                    }

                    if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifiermaxqty != 0 && $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierminqty != 0) {
                        if (tmp < $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierminqty || tmp > $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifiermaxqty) {
                            $scope.error.push({
                                name: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifiername,
                                min: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifierminqty,
                                max: $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].modifiers[i].modifiermaxqty,
                                checked: ""
                            });
                        }
                    }
                }
            }

            var tmp = 0;
            $scope.data.modifierunkid = modif;
            if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price != null && $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price.length > 1) {
                for (k = 0; k < $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price.length; k++) {
                    if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[k].unitid == $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].selectedunit) {
                        $scope.data.unit = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[k].unitname;
                        $scope.data.unitid = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[k].unitid;
                        total += parseFloat($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[k].unitprice);
                        tmp = parseFloat($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[k].unitprice);
                        break;
                    }
                }
            } else {
                $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].selectedunit = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[0].unitid;
                $scope.data.unit = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[0].unitname;
                $scope.data.unitid = $scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[0].unitid;
                total += parseFloat($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[0].unitprice);
                tmp = parseFloat($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].price[0].unitprice);
            }

            $scope.item.price = total;
            if ($scope.menuItemsDetail[$scope.slide[$ionicSlideBoxDelegate.currentIndex()]['id']].selectedunit == "0") {
                $scope.unit = 1;
            }

            var errormsg_and = '';
            var timeout = $rootScope.messagetimeout;
            if ($scope.error.length > 0) {
                timeout *= 2;
                errormsg_and += utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl133) + "<br>";
                for (var error_i = 0; error_i < $scope.error.length; error_i++) {
                    errormsg_and += "&nbsp;&nbsp;&nbsp;&nbsp; - " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl134) + " " + $scope.error[error_i].min + " " + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg30) + $scope.error[error_i].max + " " + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg31) + " " + $scope.error[error_i].name + " " + $scope.error[error_i].checked + "<br>";
                }
            }

            if ($scope.menuItemsDetail[$scope.active].selectedunit == "0") {
                if (errormsg_and.length > 0)
                    errormsg_and += "&nbsp;&nbsp;&nbsp;&nbsp; - " + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg32);
                else {
                    errormsg_and = "<div class='unitmessage'>" + utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg32) + "</div>";
                    $ionicScrollDelegate.$getByHandle('menuitemdetail').scrollBottom(true);
                }
            }

            if (window.localStorage.getItem("selectedlang") != null && window.localStorage.getItem("selectedlang") == 'ar') {
                ionicToast.show(errormsg_and, 'top', false, timeout * 2, 'right');
            } else {
                ionicToast.show(errormsg_and, 'top', false, timeout * 2, 'left');
            }


            if ($scope.menuItemsDetail[$scope.active].selectedunit != 0 && $scope.error.length == 0) {
                var flg = 0;
                var ngcrt = ngCart.getItems();
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.itemid == $scope.data.itemid && ngcrt[i]._data.unitid == $scope.data.unitid && ngcrt[i]._data.isordered == 0) {
                        if ($scope.data.modifierunkid.length == 0) {

                            if (!a.classList.contains("diable_addtocart_btn")) {
                                a.classList.add("diable_addtocart_btn");
                                $timeout(function () {
                                    a.classList.remove("diable_addtocart_btn");
                                }, 1000)

                                flg = 1;

                                document.querySelector('.cartanimdetail').classList.add('cartanimation');
                                $timeout(function () {
                                    document.querySelector('.cartanimdetail').classList.remove('cartanimation');
                                }, 320);

                                ngcrt[i]._quantity = parseInt(ngcrt[i]._quantity + $scope.item.quantity);
                                $rootScope.incrementCartRowItem(ngcrt[i]._data.cartid, ngcrt[i]._quantity);
                                $scope.errormsg = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl139) + " " + ngcrt[i]._name + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl140);
                                $scope.added = 1;
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl139) + " " + ngcrt[i]._name + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl140), 'top', false, $rootScope.messagetimeout, '');
                            }
                            break;
                        } else {
                            var flagmodifier = 0;
                            if ($scope.data.modifierunkid.length != ngcrt[i]._data.modifierunkid.length) {
                                flg = 0;
                            } else {
                                for (j = 0; j < $scope.data.modifierunkid.length; j++) {
                                    flagmodifier = 0;
                                    for (k = 0; k < ngcrt[i]._data.modifierunkid.length; k++) {
                                        if (ngcrt[i]._data.modifierunkid[k].modifieritemunkid == $scope.data.modifierunkid[j].modifieritemunkid && ngcrt[i]._data.modifierunkid[k].unitid == $scope.data.modifierunkid[j].unitid) {
                                            flagmodifier = 1;
                                            break;
                                        }
                                    }

                                    if (flagmodifier == 0) {
                                        flg = 0;
                                        break;
                                    }
                                }

                                if (flagmodifier == 1) {
                                    if (!a.classList.contains("diable_addtocart_btn")) {
                                        a.classList.add("diable_addtocart_btn");
                                        $timeout(function () {
                                            a.classList.remove("diable_addtocart_btn");
                                        }, 1000);

                                        document.querySelector('.cartanimdetail').classList.add('cartanimation');
                                        ngcrt[i]._quantity = parseInt(ngcrt[i]._quantity + $scope.item.quantity);
                                        $rootScope.incrementCartRowItem(ngcrt[i]._data.cartid, ngcrt[i]._quantity);
                                        $scope.added = 1;
                                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl139) + " " + ngcrt[i]._name + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl140), 'top', false, $rootScope.messagetimeout, '');
                                        flg = 1;
                                        $timeout(function () {
                                            document.querySelector('.cartanimdetail').classList.remove('cartanimation');
                                        }, 320);
                                    }
                                }
                            }
                        }
                        break;
                    }
                }

                if (flg == 0) {

                    if (!a.classList.contains("diable_addtocart_btn")) {
                        a.classList.add("diable_addtocart_btn");
                        $timeout(function () {
                            a.classList.remove("diable_addtocart_btn");
                        }, 1000);

                        document.querySelector('.cartanimdetail').classList.add('cartanimation');

                        ngCart.addItem($scope.item.id, $scope.item.name, $scope.item.price, $scope.item.quantity, $scope.data);
                        $rootScope.cartcounter++;
                        $rootScope.addToCart($scope.data.itemid, $scope.item.name, tmp, $scope.data.menugroupcode, $scope.data.menuitemcode, $scope.data.menuitemtype, $scope.data.unitid, $scope.data.unit, $scope.item.price, $scope.data.modifierunkid, $scope.item.id, $scope.data.menuitemremark, "", $scope.item.quantity);
                        $rootScope.getCartId();
                        $scope.added = 1;
                        $scope.errormsg = $scope.item.name + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl136);
                        ionicToast.show($scope.errormsg, 'top', false, $rootScope.messagetimeout, '');
                        $timeout(function () {
                            document.querySelector('.cartanimdetail').classList.remove('cartanimation');
                        }, 320);
                        $rootScope.cartTotal++;
                    }
                } else if (flg == 1) { }

                $timeout(function () {
                    $scope.add = 0;
                    $scope.errormsg = '';
                    $scope.error = [];
                    $scope.unit = 0;
                    $scope.added = 0;
                }, 5000)
            }
        }

        $scope.foodcart = function () {
            $scope.carterror = '';
            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.cancel = function () {
            $scope.slide = [{
                id: -1,
                unkid: 0,
                name: ''
            }, {
                id: -1,
                unkid: 0,
                name: ''
            }, {
                id: -1,
                unkid: 0,
                name: ''
            }];
            if ($stateParams.index == -1) {
                $state.go("app.menuItemSearch", {});
            } else {
                $state.go("app.menuItem/:menugroupunkid/:index", {
                    menugroupunkid: $scope.selectedGroupId,
                    index: $stateParams.index
                });
            }
        }
    })

    .controller('myOrders', function ($rootScope, $scope, sharedProperties, $state, ngCart, $timeout, $ionicPopup, $http, utf8_decodeFilter, ionicToast, $ionicScrollDelegate, $ionicModal, $ionicPlatform) {

        $ionicPlatform.registerBackButtonAction(function (event) {
            $state.go("app.home", {});
        }, 100);

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.lastorderno = (window.localStorage.getItem("Lastorderid") != null) ? window.localStorage.getItem("Lastorderid") : '';
        $scope.isburrp = (localStorage.getItem("isburrp") == 'true') ? true : false;
        $scope.itemsInCart = ngCart.getItems();
        $scope.currencySymbol = localStorage.getItem("currencysymbol")
        $scope.total = 0;
        $scope.orderunkids = '';

        $ionicModal.fromTemplateUrl('templates/orderratemodel.html',
            function (modal) {
                $scope.orderratemodal = modal;
            }, {
                scope: $scope,
                animation: 'slide-in-up'
            }
        );

        $scope.orderunkids = [];
        if (window.localStorage.getItem("orderunkid_array") != null && window.localStorage.getItem("orderunkid_array") != 'null' && window.localStorage.getItem("orderunkid_array").length > 0)
            $scope.orderunkids = JSON.parse(window.localStorage.getItem("orderunkid_array"));

        $scope.customerloggedin = false;
        $scope.foodcart = function () {
            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.repeatORder = function (orderno) {

            if (window.localStorage.getItem("startorder") == false || window.localStorage.getItem("startorder") == "false")
                window.localStorage.setItem("startorder", true);

            if ($rootScope.cartcounter > 0) {

                var myPopup = $ionicPopup.show({
                    template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg89),
                    cssClass: 'tablepopup custompopup',
                    title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl165),
                    scope: $scope,
                    buttons: [{
                        text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                        onTap: function (e) { }
                    }, {
                        text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                        type: 'button-positive',
                        onTap: function (e) {
                            var items = ngCart.getItems();
                            for (i = items.length - 1; i >= 0; i--) {
                                if (items[i]._data.isordered == 0) {
                                    ngCart.removeItem(i);
                                }

                                if (i == 0) {
                                    $rootScope.clearCartItems(1);
                                    $rootScope.cartcounter = 0;
                                    $rootScope.duplicateOrder(orderno, 0);
                                }
                            }
                        }
                    },]
                });
            } else {
                $rootScope.cartcounter = 0;
                $rootScope.duplicateOrder(orderno, 0);
            }
        }

        $scope.backToMenu = function () {
            $state.go("app.home", {});
        }

        $scope.rateOrder = function (orderunkid, isRated) {

            $ionicScrollDelegate.$getByHandle('ratingdetailscroll').scrollTop(true);
            $scope.orderunkid = orderunkid;
            $scope.isRated = isRated;
            $scope.orderratemodal.show();

            $timeout(function () {
                if (isRated == 0) {
                    if (window.localStorage.getItem("cmail") == null || window.localStorage.getItem("cmail") == 'null' || window.localStorage.getItem("cmail").length == 0) {
                        document.querySelectorAll('.modal .scroll')[0].style['max-height'] = window.innerHeight - (document.querySelector('.modal header').offsetHeight + document.querySelector('.ratefooter').offsetHeight + 10) + 'px';
                        document.querySelectorAll('.modal .scroll')[1].style['max-height'] = window.innerHeight - (document.querySelector('.modal header').offsetHeight + document.querySelector('.ratefooter').offsetHeight + 10) + 'px';
                    } else {
                        document.querySelectorAll('.modal .scroll')[0].style['max-height'] = window.innerHeight - ((document.querySelector('.modal header').offsetHeight * 3) + 45) + 'px';
                        document.querySelectorAll('.modal .scroll')[1].style['max-height'] = window.innerHeight - ((document.querySelector('.modal header').offsetHeight * 3) + 45) + 'px';
                    }
                } else {

                    document.querySelectorAll('.modal .scroll')[0].style['max-height'] = window.innerHeight - ((document.querySelector('.modal header').offsetHeight * 3) + 45) + 'px';
                    document.querySelectorAll('.modal .scroll')[1].style['max-height'] = window.innerHeight - ((document.querySelector('.modal header').offsetHeight * 3) + 45) + 'px';
                }
            }, 100);
            if (isRated == 1) {
                var res = $http.get($rootScope.SERVER_PATH + 'socialsharing.php', {
                    params: {
                        "data": orderunkid
                    }
                });
                res.success(function (data, status, headers, config) {
                    $scope.image = data;
                });

                res.error(function (data, status, headers, config) {
                    $timeout(function () {
                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg69), 'top', false, $rootScope.messagetimeout, '');
                    }, 1000);
                });
            } else {
                $scope.customerloggedin = true;
                if (window.localStorage.getItem("cmail") == null || window.localStorage.getItem("cmail") == 'null' || window.localStorage.getItem("cmail").length == 0) {
                    $scope.customerloggedin = false;
                }

                $scope.rate_error = '';
                $scope.itemrating = [];
                $scope.isRated = isRated;

                var ngcrt = ngCart.getItems();
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.orderunkid == orderunkid) {
                        $scope.itemrating.push({
                            orderunkid: orderunkid,
                            itemunkid: ngcrt[i]._data.itemid,
                            itemname: ngcrt[i]._name + " (" + ngcrt[i]._data.unit + ")",
                            itemname_only: ngcrt[i]._name,
                            unitid: ngcrt[i]._data.unitid,
                            rating: ngcrt[i]._data.rating
                        });
                    }
                }

                var cmail = '';
                if (window.localStorage.getItem("cmail") != null || window.localStorage.getItem("cmail") != 'null')
                    cmail = window.localStorage.getItem("cmail");
                $scope.orderRating = {
                    restname: window.localStorage.getItem("resname"),
                    name: '',
                    email: cmail,
                    orderno: orderunkid,
                    restaurantcode: window.localStorage.getItem("restaurantcode"),
                    itemrating: $scope.itemrating,
                    theme: window.localStorage.getItem("theme")
                };
            }
        }

        $scope.submitRate = function () {

            if ($scope.orderRating.email == '') {
                $ionicScrollDelegate.$getByHandle('ratingdetailscroll').scrollBottom(true);
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg9), 'top', false, $rootScope.messagetimeout, '');
                event.preventDefault();
            } else {
                if ($scope.orderRating.email == '') {
                    $ionicScrollDelegate.$getByHandle('ratingdetailscroll').scrollBottom(true);
                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg9), 'top', false, $rootScope.messagetimeout, '');
                    event.preventDefault();
                } else {
                    if ($rootScope.getConnectionFlag()) {
                        var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;

                        if (re.test($scope.orderRating.email)) {
                            var res = $http.get($rootScope.SERVER_PATH + 'itemrating.php', {
                                params: {
                                    "data": JSON.stringify($scope.orderRating)
                                }
                            });
                            res.success(function (data, status, headers, config) {

                                $scope.image = data;
                                $scope.isRated = 1;
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg69), 'top', false, $rootScope.messagetimeout, '');

                                $timeout(function () {
                                    $scope.orderunkids = JSON.parse(window.localStorage.getItem("orderunkid_array"));
                                    for (j = 0; j < $scope.orderunkids.length; j++) {
                                        if ($scope.orderunkid == $scope.orderunkids[j].orderunkid) {
                                            $scope.orderunkids[j].israted = 1;
                                            window.localStorage.setItem("orderunkid_array", JSON.stringify($scope.orderunkids))
                                            break;
                                        }
                                    }

                                    for (i = 0; i < $scope.orderRating.itemrating.length; i++) {
                                        $rootScope.updateRating($scope.orderRating.itemrating[i].orderunkid, $scope.orderRating.itemrating[i].itemunkid, $scope.orderRating.itemrating[i].rating, $scope.orderRating.itemrating[i].unitid)
                                    }

                                    var ngcrts = ngCart.getItems();
                                    for (j = 0; j < ngcrts.length; j++) {
                                        if (ngcrts[j]._data.orderunkid == $scope.orderunkid) {
                                            for (k = 0; k < $scope.orderRating.itemrating.length; k++) {
                                                if (ngcrts[j]._data.itemid == $scope.orderRating.itemrating[k].itemunkid && ngCart.getItems()[j]._data.unitid == $scope.orderRating.itemrating[k].unitid) {
                                                    ngcrts[j]._data.rating = $scope.orderRating.itemrating[k].rating;
                                                    break;
                                                }
                                            }
                                        }
                                    }
                                }, 10);
                            });

                            res.error(function (data, status, headers, config) {
                                $timeout(function () {
                                    myPopup.close()
                                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg69), 'top', false, $rootScope.messagetimeout, '');
                                }, 1000);
                            });
                        } else {
                            $ionicScrollDelegate.$getByHandle('ratingdetailscroll').scrollBottom(true);
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl111), 'top', false, $rootScope.messagetimeout, '');
                            event.preventDefault();
                        }
                    }
                }
            }
        }

        $scope.shareRate = function () {

            $timeout(function () {
                var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
                if (phonegapapp) {
                    window.plugins.socialsharing.share(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg91) + " " + window.localStorage.getItem('resname'), utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl168), $scope.image, '', function () { },
                        function () {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg92), 'top', false, $rootScope.messagetimeout, '');
                        });
                }
            }, 10)
        }

        $scope.cancelRate = function () {
            $scope.orderratemodal.hide();
        }
    })

    .controller('foodcart', function ($rootScope, $scope, sharedProperties, $state, ngCart, $ionicPopup, $timeout, utf8_decodeFilter, $ionicScrollDelegate, ionicToast) {

        $scope.itemremarks = $rootScope.remarks;
        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.$on('$ionicView.enter', function () {
            if ($rootScope.burrpConnection == 0 && (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true"))
                document.querySelector(".connection_problem").classList.remove("hideSearch");
        });

        if (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true") {
            $scope.burrp = true;
        } else
            $scope.burrp = false;

        $scope.requesting_iMonitor = 0;
        $scope.search = {
            searchWaiter: '',
            searchTable: '',
            remark: ''
        };
        $scope.cart = {
            tablename: '',
            waitername: ''
        };
        $scope.guest = {
            name: '',
            phone: '',
            email: '',
            adult: '',
            child: '',
            comment: window.localStorage.getItem('guestcomment')
        };
        if (localStorage.getItem("guestdetailchoice") != '' && localStorage.getItem("guestdetailchoice") != null) {
            obj = JSON.parse(localStorage.getItem("guestdetailchoice"))
            $scope.guest = {
                name: obj.name,
                phone: obj.phone,
                email: obj.email,
                adult: obj.adult,
                child: obj.child,
                comment: localStorage.getItem("guestcomment")
            };
        }

        $scope.isburrp = (localStorage.getItem("isburrp") == 'true') ? true : false;
        $scope.isguestinfo = (localStorage.getItem("guestinfo") == 'true') ? true : false;
        $scope.remrk = {
            remark: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl41),
            custom: ''
        };
        $scope.itemsInCart = ngCart.getItems();
        $scope.currencySymbol = localStorage.getItem("currencysymbol");
        $scope.total = 0;

        $scope.backToMenu = function () {

            $state.go("app.home", {});
        }

        $scope.update = function (cartid, opr, index) {
            var a = event.target;
            if (!a.classList.contains("diable_addtocart_btn")) {
                a.classList.add("diable_addtocart_btn");
                $timeout(function () {
                    a.classList.remove("diable_addtocart_btn");
                }, 250)

                ngCart.getItems()[index].setQuantity(opr, true);
                if (opr == 1)
                    $rootScope.incrementCartRowItem(ngCart.getItems()[index]._data.cartid, parseInt(ngCart.getItems()[index]._quantity))
                else if (opr == -1)
                    $rootScope.incrementCartRowItem(ngCart.getItems()[index]._data.cartid, parseInt(ngCart.getItems()[index]._quantity))
            }
        }

        $scope.resizeScroll = function () {
            document.querySelector(".fcart").classList.add('resizeFoodcart');
        }

        $scope.delete = function (index) {

            var items = ngCart.getItems();
            for (var i = 0; i < items.length; i++) {
                if (items[i]._data.cartid == index && items[i]._data.isordered == 0) {
                    $rootScope.cartcounter--;
                    if (items[i]._data.cartid.length > 10)
                        $rootScope.clearCartRowItemFromOrder(items[i]._data.cartid);
                    else
                        $rootScope.clearCartRowItem(items[i]._data.cartid);
                    ngCart.removeItem(i);

                    if ($rootScope.cartcounter == 0) {
                        $timeout(function () {
                            if (document.querySelector('.loadingData') != null)
                                document.querySelector('.loadingData').classList.add('loaded');
                        }, 1000);
                        $state.go("app.menuGroup", {});
                        $rootScope.closeLoader();
                    }
                    break;
                }
            }
        }

        $scope.continue_order = function () {
            $timeout(function () {
                if (document.querySelector('.loadingData') != null)
                    document.querySelector('.loadingData').classList.add('loaded');
            }, 1000);
            $state.go("app.menuGroup", {});
            $rootScope.closeLoader();
        }

        $scope.clearCart = function () {
            var myPopup = $ionicPopup.show({
                template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg24),
                cssClass: 'custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl58),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl122),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl121),
                    type: 'button-positive',
                    onTap: function (e) {

                        $timeout(function () {
                            for (i = $scope.itemsInCart.length - 1; i >= 0; i--) {
                                if ($scope.itemsInCart[i]._data.isordered == 0) {
                                    ngCart.removeItem(i);
                                }

                                if (i == 0) {
                                    $rootScope.clearCartItems(1);
                                    $timeout(function () {
                                        if (document.querySelector('.loadingData') != null)
                                            document.querySelector('.loadingData').classList.add('loaded');
                                    }, 1000);
                                    $state.go("app.menuGroup", {});
                                    $rootScope.closeLoader();
                                    $rootScope.cartcounter = 0;
                                }
                            }
                        }, 10);
                    }
                },]
            });
            myPopup.then(function (res) { });
        }

        $scope.scrollRemarkTop = function () {
            $ionicScrollDelegate.$getByHandle('handle_remarklist').scrollTop(true);
        }

        $scope.enterRemark = function (val, checked) {
            if (val == '0' && checked == true) {
                $timeout(function () {
                    document.querySelector(".customremark").focus();
                }, 100)
            }
        }

        $scope.remark = function (id) {

            $scope.search = {
                searchWaiter: '',
                searchTable: '',
                remark: ''
            };
            $scope.itemid = id;
            $scope.tmpi = 0;
            $scope.cartitems = ngCart.getItems();
            $scope.remrk = {
                custom: ''
            };

            for (jj = 0; jj < $rootScope.remarks.length; jj++) {

                $rootScope.remarks[jj].checked = false;
            }

            for (i = 0; i < $scope.cartitems.length; i++) {
                if ($scope.cartitems[i]._data.cartid == id) {
                    $scope.tmpi = i;

                    if ($rootScope.remarks.length > 1) {

                        var item_remark = ($scope.cartitems[i]._data.menuitemremark.length > 0) ? JSON.parse($scope.cartitems[i]._data.menuitemremark) : '';

                        for (j = 0; j < item_remark.length; j++) {

                            for (index = 0; index < $rootScope.remarks.length; index++) {

                                if (item_remark[j].code == $rootScope.remarks[index].remarkunkid) {

                                    if (item_remark[j].code == 0 || item_remark[j].code == '0') {
                                        $scope.remrk.custom = item_remark[j].name;
                                    }

                                    $rootScope.remarks[index].checked = true;
                                    break;
                                }
                            }
                        }
                    } else
                        $scope.remrk.custom = $scope.cartitems[i]._data.menuitemremark;
                    break;
                }
            }

            $timeout(function () {
                if (document.querySelector(".remarkscroll") != null) {
                    document.querySelector(".remarkpopup ion-scroll").style["min-height"] = (document.querySelector(".remarkpopup .popup").offsetHeight - (document.querySelector(".remarkpopup .popup-head").offsetHeight + document.querySelector(".remarkpopup .popup-buttons").offsetHeight + document.querySelector(".remarkpopup .popsearch").offsetHeight + 80)) + 'px';
                    document.querySelector(".remarkpopup ion-scroll").style["max-height"] = (document.querySelector(".remarkpopup .popup").offsetHeight - (document.querySelector(".remarkpopup .popup-head").offsetHeight + document.querySelector(".remarkpopup .popup-buttons").offsetHeight + document.querySelector(".remarkpopup .popsearch").offsetHeight + 80)) + 'px';
                }
            }, 100);

            if ($rootScope.remarks.length == 1) {
                var myPopup = $ionicPopup.show({
                    templateUrl: 'templates/enterremark.html',
                    cssClass: 'remarkpopup custompopup',
                    title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl109),
                    scope: $scope,
                    buttons: [{
                        text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                        onTap: function (e) {
                            $scope.remrk = {
                                remark: $scope.cartitems[$scope.tmpi]._data.menuitemremark,
                                custom: $scope.cartitems[$scope.tmpi]._data.iscustomremark
                            };
                        }
                    }, {
                        text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                        type: 'button-positive',
                        onTap: function (e) {
                            if ($scope.remrk.custom != undefined && $scope.remrk.custom.length > 0) {
                                for (ii = 0; ii < $scope.cartitems.length; ii++) {
                                    if ($scope.cartitems[ii]._data.cartid == $scope.itemid) {
                                        // $scope.remrk.remark = "Other";
                                        $scope.cartitems[ii]._data.menuitemremark = $scope.remrk.custom;
                                        $scope.cartitems[ii]._data.iscustomremark = '';
                                        $rootScope.updateRemark($scope.cartitems[ii]._data.cartid, $scope.remrk.custom, $scope.remrk.custom);
                                        // document.querySelector(".remark-"+ $scope.itemid).innerHTML = $scope.remrk.custom;
                                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl162), 'top', false, $rootScope.messagetimeout, '');
                                        break;
                                    }
                                }
                            } else {
                                for (ii = 0; ii < $scope.cartitems.length; ii++) {
                                    if ($scope.cartitems[ii]._data.cartid == $scope.itemid) {
                                        $scope.cartitems[ii]._data.menuitemremark = "";
                                        $scope.cartitems[ii]._data.iscustomremark = "";
                                        $rootScope.updateRemark($scope.cartitems[ii]._data.cartid, "", "");
                                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl161), 'top', false, $rootScope.messagetimeout, '');
                                        break;
                                    }
                                }
                            }
                        }
                    },]
                });
            } else {
                $timeout(function () {
                    if (document.querySelector(".remarkscroll") != null) {
                        document.querySelector(".remarkpopup ion-scroll").style["min-height"] = (document.querySelector(".popup").offsetHeight - (document.querySelector(".popup-head").offsetHeight + document.querySelector(".popup-buttons").offsetHeight + document.querySelector(".popsearch").offsetHeight + 90)) + 'px';
                        document.querySelector(".remarkpopup ion-scroll").style["max-height"] = (document.querySelector(".popup").offsetHeight - (document.querySelector(".popup-head").offsetHeight + document.querySelector(".popup-buttons").offsetHeight + document.querySelector(".popsearch").offsetHeight + 90)) + 'px';
                    }
                }, 100)

                var myPopup = $ionicPopup.show({
                    templateUrl: 'templates/popupRemarkList.html',
                    cssClass: 'remarkpopup custompopup',
                    title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl108),
                    scope: $scope,
                    buttons: [{
                        text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                        onTap: function (e) {
                            $scope.remrk = {
                                remark: $scope.cartitems[$scope.tmpi]._data.menuitemremark,
                                custom: $scope.cartitems[$scope.tmpi]._data.iscustomremark
                            };
                        }
                    }, {
                        text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                        type: 'button-positive',
                        onTap: function (e) {

                            var choosen_remarks = [];
                            for (index = 0; index < $rootScope.remarks.length; index++) {

                                if ($rootScope.remarks[index].checked == true) {

                                    if ($rootScope.remarks[index].remarkunkid == 0 && $scope.remrk.custom != undefined && $scope.remrk.custom.length > 0)
                                        choosen_remarks.push({
                                            'name': $scope.remrk.custom,
                                            'code': 0
                                        });
                                    else if ($rootScope.remarks[index].remarkunkid != 0)
                                        choosen_remarks.push({
                                            'name': $rootScope.remarks[index].remarkname,
                                            'code': $rootScope.remarks[index].remarkunkid
                                        });
                                }
                            }

                            for (ii = 0; ii < $scope.cartitems.length; ii++) {

                                if ($scope.cartitems[ii]._data.cartid == $scope.itemid) {

                                    $scope.cartitems[ii]._data.menuitemremark = (choosen_remarks.length > 0) ? JSON.stringify(choosen_remarks) : '';
                                    $scope.cartitems[ii]._data.iscustomremark = '';
                                    $rootScope.updateRemark($scope.cartitems[ii]._data.cartid, (choosen_remarks.length > 0) ? JSON.stringify(choosen_remarks) : '', '');
                                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl162), 'top', false, $rootScope.messagetimeout, '');
                                    break;
                                }
                            }
                        }
                    },]
                });
            }
        }

        $scope.connect_iMonitor = function () {
            if ($rootScope.burrpConnection == 0) {
                var imonitor_button = event.target;
                if (!imonitor_button.classList.contains("disable_imonitor")) {
                    imonitor_button.classList.add("disable_imonitor");
                }

                document.querySelector(".imonitor_wifi").classList.add("hideSearch");
                document.querySelector(".connection_problem").classList.add("hideSearch");
                document.querySelector(".imonitor_spinner").classList.remove("hideSearch");

                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg85), 'top', false, $rootScope.messagetimeout, '');

                $timeout(function () {
                    $rootScope.ReconnectWithiMonitor(0);

                    $timeout(function () {
                        if ($rootScope.burrpConnection == 1) {
                            document.querySelector(".imonitor_wifi").classList.remove("hideSearch");
                            document.querySelector(".imonitor_spinner").classList.add("hideSearch");
                            document.querySelector(".connection_problem").classList.add("hideSearch");
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl163), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            document.querySelector(".imonitor_wifi").classList.remove("hideSearch");
                            document.querySelector(".connection_problem").classList.remove("hideSearch");
                            document.querySelector(".imonitor_spinner").classList.add("hideSearch");
                            $rootScope.burrpConnection = 0;
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl164), 'top', false, $rootScope.messagetimeout, '');
                        }
                        imonitor_button.classList.remove("disable_imonitor");
                    }, 5000);
                }, 1000);
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg86), 'top', false, $rootScope.messagetimeout, '');
            }
        }
        
        $scope.sendOrder = function() {

            localStorage.setItem("guestcomment", $scope.guest.comment);
            var waitertableallocation = JSON.parse(window.localStorage["waitertableallocation"]);
            if (waitertableallocation.length > 0) {
                var l = [];
                var waiter = localStorage.getItem("WaiterId");
                for(var i=0;i<waitertableallocation.length;i++){
                    if (waitertableallocation[i][0] == waiter) {
                        for(var j=0;j<waitertableallocation[i][2].length;j++){
                            var tablelist = waitertableallocation[i][2][j].tname;                                 
                            var list = { "name": tablelist }
                            l.push(list)
                        }
                    }
                }
                $scope.tableList = l;
            }
            else
                $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
            
            $scope.waiterList = JSON.parse(localStorage.getItem("imenuWaiterlist"))
    
            if ($scope.isburrp == true) {
                flag = 0;
                if (window.localStorage.getItem("orderpreference") == 0) {
                    var adlt = "0";
                    var chld = "0";
                    flag = 0;
                    var flaga = 0;
                    var flagc = 0;
                    if (window.localStorage.getItem("guestinfo") == "true" || window.localStorage.getItem("guestinfo") == true) {
                        var numbers = /^[0-9]+$/;
                        if ($scope.guest.adult != "") {
                            if ($scope.guest.adult.match(numbers)) {
                                adlt = $scope.guest.adult;
                                flaga = 1;
                            }
                        } else
                            flaga = 1;
    
                        if ($scope.guest.child != "") {
                            if ($scope.guest.child.match(numbers)) {
                                chld = $scope.guest.child;
                                flagc = 1;
                            }
                        } else
                            flagc = 1;
    
    
                        if (flaga == 0 && flagc == 0) {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg71), 'top', false, $rootScope.messagetimeout, '');
                        } else if (flaga == 0) {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg72), 'top', false, $rootScope.messagetimeout, '');
                        } else if (flagc == 0) {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg73), 'top', false, $rootScope.messagetimeout, '');
                        } else
                            flag = 1;
                    } else
                        flag = 1;
    
                    if (flag == 1) {
                        if (window.localStorage.getItem("waitermode") == "false" || window.localStorage.getItem("waitermode") == false) {
                            if (window.localStorage.getItem("TableNumber") == 0 || window.localStorage.getItem("TableNumber") == 'None' || window.localStorage.getItem("TableNumber") == '' || window.localStorage.getItem("TableNumber") == null || window.localStorage.getItem("TableNumber") == "null") {
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg75), 'top', false, $rootScope.messagetimeout, '');
                            } else {
                                flag = 1;
                                var obj = new Object;
                                obj.name = $scope.guest.name;
                                obj.phone = $scope.guest.phone;
                                obj.email = $scope.guest.email;
                                obj.adult = adlt;
                                obj.child = chld;
                                localStorage.setItem("guestdetailchoice", JSON.stringify(obj));
                                localStorage.setItem("guestcomment", $scope.guest.comment);
                                $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                                $scope.sendingOrder();
                                $rootScope.confirmOrder();
                            }
                        } else if (window.localStorage.getItem("waitermode") == 'true' || window.localStorage.getItem("waitermode") == true) {
                            var obj = new Object;
                            obj.name = $scope.guest.name;
                            obj.phone = $scope.guest.phone;
                            obj.email = $scope.guest.email;
                            obj.adult = adlt;
                            obj.child = chld;
                            localStorage.setItem("guestdetailchoice", JSON.stringify(obj));
                            localStorage.setItem("guestcomment", $scope.guest.comment);
                            $scope.search = {
                                searchWaiter: '',
                                searchTable: '',
                                remark: ''
                            };
                            $scope.tableWaiterPopup();
                        }
                    }
                } else if (window.localStorage.getItem("orderpreference") == 1) {
                    var adlt = "0";
                    var chld = "0";
                    flag = 0;
                    var flaga = 0;
                    var flagc = 0;
                    if (window.localStorage.getItem("guestinfo") == "true" || window.localStorage.getItem("guestinfo") == true) {
                        var numbers = /^[0-9]+$/;
                        if ($scope.guest.adult != "") {
                            if ($scope.guest.adult.match(numbers)) {
                                adlt = $scope.guest.adult;
                                flaga = 1;
                            }
                        } else
                            flaga = 1;
    
                        if ($scope.guest.child != "") {
                            if ($scope.guest.child.match(numbers)) {
                                chld = $scope.guest.child;
                                flagc = 1;
                            }
                        } else
                            flagc = 1;
    
    
                        if (flaga == 0 && flagc == 0) {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg71), 'top', false, $rootScope.messagetimeout, '');
                        } else if (flaga == 0) {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg72), 'top', false, $rootScope.messagetimeout, '');
                        } else if (flagc == 0) {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg73), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            var obj = new Object;
                            obj.name = $scope.guest.name;
                            obj.phone = $scope.guest.phone;
                            obj.email = $scope.guest.email;
                            obj.adult = adlt;
                            obj.child = chld;
                            localStorage.setItem("guestdetailchoice", JSON.stringify(obj));
                            localStorage.setItem("guestcomment", $scope.guest.comment);
                            flag = 1;
                        }
                    } else
                        flag = 1;
    
    
                    if (flag == 1) {
                        $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                        $scope.sendingOrder();
                        $rootScope.confirmOrder();
                    }
                }
            } else {
                if ($rootScope.getConnectionFlag()) {
                    if (window.localStorage.getItem("orderpreference") == 0) {
                        flag = 0;
                        if (window.localStorage.getItem("waitermode") == "false" || window.localStorage.getItem("waitermode") == false) {
                            if (window.localStorage.getItem("TableNumber") == 0 || window.localStorage.getItem("TableNumber") == 'None' || window.localStorage.getItem("TableNumber") == '' || window.localStorage.getItem("TableNumber") == null || window.localStorage.getItem("TableNumber") == "null") {
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg75), 'top', false, $rootScope.messagetimeout, '');
                            } else {
                                flag = 1;
                                $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                                $scope.sendingOrder();
                                $rootScope.confirmOrder();
                            }
                        } else if (window.localStorage.getItem("waitermode") == "true" || window.localStorage.getItem("waitermode") == true) {
    
                            if (window.localStorage.getItem("TableNumber") == 'None' || window.localStorage.getItem("WaiterName") == '' || window.localStorage.getItem("TableNumber") == '' || window.localStorage.getItem("TableNumber") == null || window.localStorage.getItem("TableNumber") == "null" || window.localStorage.getItem("WaiterName") == null || window.localStorage.getItem("WaiterName") == "null") {
    
                                if ($scope.tableList.length == 0 && $scope.waiterList.length == 0) {
                                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg70), 'top', false, $rootScope.messagetimeout, '');
                                } else if ($scope.tableList.length == 0) {
                                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg22), 'top', false, $rootScope.messagetimeout, '');
                                } else if ($scope.waiterList.length == 0) {
                                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg46), 'top', false, $rootScope.messagetimeout, '');
                                }
    
                                if ($scope.waiterList.length > 0 && $scope.tableList.length > 0) {
                                    $scope.search = {
                                        searchWaiter: '',
                                        searchTable: '',
                                        remark: ''
                                    };
                                    $scope.tableWaiterPopup();
                                }
                            } else {
                                localStorage.setItem("guestcomment", $scope.guest.comment);
                                if (waitertableallocation.length > 0 && (localStorage.getItem("tablefix") == false || localStorage.getItem("tablefix") == "false")) {
                                    $scope.tableWaiterPopup();
                                }
                                else if (waitertableallocation.length > 0 && (localStorage.getItem("tablefix") == true || localStorage.getItem("tablefix") == "true")) {
                                    $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                                    $scope.sendingOrder();
                                    $rootScope.confirmOrder();
                                }
                                else{
                                    flag = 1;
                                    $scope.tableWaiterPopup();
                                }
                            }
                        }
                    } else {
                        $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                        $scope.sendingOrder();
                        $rootScope.confirmOrder();
                    }
                } else {
                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg48), 'top', false, $rootScope.messagetimeout, '');
                }
            }
        }

        $scope.alertMessage = function (message) {
            var myPopup = $ionicPopup.show({
                template: message,
                cssClass: 'custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg16),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl146),
                    onTap: function (e) { }
                }]
            });
        }

        $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
        $scope.sendingOrder = function () {
            $rootScope.sendingOrderPopup = $ionicPopup.show({
                template: '<div>{{orderSendingMesssage}}</div>',
                cssClass: 'custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg49),
                scope: $scope,
                buttons: []
            });
            $rootScope.sendingOrderPopup.then(function (res) { });
        }

        $scope.scrollTableTop = function () {
            $ionicScrollDelegate.$getByHandle('handle_tablelist').scrollTop(true);
        }

        $scope.scrollWaiterTop = function () {
            $ionicScrollDelegate.$getByHandle('handle_waiterlist').scrollTop(true);
        }

        $scope.tableWaiterPopup = function () {
            var waitertableallocation = JSON.parse(window.localStorage["waitertableallocation"]);
            $scope.search = {
                searchWaiter: '',
                searchTable: '',
                remark: ''
            };
            $scope.cart = {
                tablename: localStorage.getItem("TableNumber"),
                waitername: localStorage.getItem("WaiterName")
            };
            
            if ((localStorage.getItem('tablefix')==false || localStorage.getItem('tablefix')=="false") && waitertableallocation.length > 0) {
                var label = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl141);
            }
            else
                var label = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl141) + " / " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl142)

            $scope.changeTable = function (selectedWaiter) {
                var table = []
                var waiter = selectedWaiter;
                var waitertableallocation = JSON.parse(window.localStorage["waitertableallocation"]);
                var l = []
                if (waiter) {
                    for (i in waitertableallocation) {
                        if (waitertableallocation[i].name == waiter) {
                            for (var j in waitertableallocation[i].table) {
                                var tablelist = waitertableallocation[i].table[j];
                                var t = tablelist;
                                var list = { "name": t }
                                l.push(list)
                            }
                        }
                    }
                    $scope.tableList = l
                }
            }

            if (localStorage.getItem("waitermode") == 'false') {
                var label = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl141) + " / " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl142)
                $scope.waiterList = JSON.parse(window.localStorage.getItem("imenuWaiterlist"));
                $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
            }
            else {
                $scope.waiterList = JSON.parse(window.localStorage.getItem("imenuWaiterlist"));
                $scope.tableList = [];
                //$scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
                if (waitertableallocation.length > 0) {
                    var l = [];
                    var waiter = localStorage.getItem("WaiterId");
                    for(var i=0;i<waitertableallocation.length;i++){
                        if (waitertableallocation[i][0] == waiter) {
                            for(var j=0;j<waitertableallocation[i][2].length;j++){
                                var tablelist = waitertableallocation[i][2][j].tname;                                 
                                var list = { "name": tablelist }
                                l.push(list)
                            }
                        }
                    }
                    $scope.tableList = l;
                    $scope.waiterList = [];
                }
                else
                    $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
            }

            //if (localStorage.getItem("tablefix") == 'true') {
            //    var label = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl142);
            //    $scope.waiterList = JSON.parse(window.localStorage.getItem("imenuWaiterlist"));
            //    $scope.tableList = [];
            //}

            var fixtable = (localStorage.getItem("tablefix") == true || localStorage.getItem("tablefix") == 'true') ? true : false;
            $timeout(function () {

                if (waitertableallocation.length > 0 && fixtable==false) {
                    var a = (document.querySelector(".popup").offsetHeight - (document.querySelector(".popup-head").offsetHeight + document.querySelector(".popup-buttons").offsetHeight + document.querySelector(".popsearch").offsetHeight + ((document.querySelector(".lbltable") != null) ? document.querySelector(".lbltable").offsetHeight : 0) + 90));
                }
                else
                    var b = (document.querySelector(".popup").offsetHeight - (document.querySelector(".popup-head").offsetHeight + document.querySelector(".popup-buttons").offsetHeight + document.querySelector(".popsearch").offsetHeight + document.querySelector(".lblwaiter").offsetHeight + 90));

                if (a > b) {
                    document.querySelector(".tablescroll").style["min-height"] = a + 'px';
                    document.querySelector(".tablescroll").style["max-height"] = a + 'px';
                    if(waitertableallocation.length == 0){
                        document.querySelector(".waiterscroll").style["min-height"] = a + 'px';
                        document.querySelector(".waiterscroll").style["max-height"] = a + 'px';
                    }
                } else {
                    document.querySelector(".tablescroll").style["min-height"] = a + 'px';
                    document.querySelector(".tablescroll").style["max-height"] = b + 'px';

                    if(waitertableallocation.length == 0){
                        document.querySelector(".waiterscroll").style["min-height"] = b + 'px';
                        document.querySelector(".waiterscroll").style["max-height"] = b + 'px';
                    }
                }
            }, 100);

            if (window.localStorage.getItem("TableNumber") == '' || window.localStorage.getItem("TableNumber") == null || window.localStorage.getItem("TableNumber") == 'null') {
                if (window.localStorage.getItem("tablefix") == 'false' || window.localStorage.getItem("tablefix") == false) {
                    $scope.fixtable = 'true';
                }
                else {
                    $scope.fixtable = 'false';
                }
            }
            else if (window.localStorage.getItem("TableNumber") != '' || window.localStorage.getItem("TableNumber") != null || window.localStorage.getItem("TableNumber") != 'null') {
                if (window.localStorage.getItem("tablefix") == 'false' || window.localStorage.getItem("tablefix") == false) {
                    $scope.fixtable = 'true';
                }
                else {
                    $scope.fixtable = 'false';
                }
            }

            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupTableWaiter.html',
                cssClass: 'custompopup popuptablewaiter',
                title: label,
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) {
                        $timeout(function () {
                            myPopup.close();
                        }, 100);
                    }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {
                        localStorage.setItem("TableNumber", $scope.cart.tablename);

                        if ($scope.cart.waitername != '') {
                            for (i = 0; i < $scope.waiterList.length; i++) {
                                if ($scope.waiterList[i].waitername == $scope.cart.waitername) {
                                    localStorage.setItem("WaiterName", $scope.waiterList[i].waitername)
                                    localStorage.setItem("WaiterCode", $scope.waiterList[i].waitercode)
                                    localStorage.setItem("WaiterId", $scope.waiterList[i].waiterunkid)
                                    break;
                                }
                            }
                        }

                        if ($scope.cart.waitername == '' && $scope.cart.tablename == '') {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg68), 'top', false, $rootScope.messagetimeout, '');
                        } else if ($scope.cart.waitername == '') {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg67), 'top', false, $rootScope.messagetimeout, '');
                        } else if ($scope.cart.tablename == '') {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg66), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            if (window.localStorage.getItem("TableNumber") != '' && window.localStorage.getItem("WaiterName") != '') {
                                myPopup.close();
                                $timeout(function () {
                                    if ($scope.isburrp == true) {
                                        $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                                        $scope.sendingOrder();
                                        $rootScope.confirmOrder();
                                    } else {
                                        $rootScope.orderSendingMesssage = utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg53);
                                        $scope.sendingOrder();
                                        $rootScope.confirmOrder();
                                    }
                                }, 100);
                            }
                        }
                    }
                },]
            });
        }

        $scope.resetSearchTable = function () {
            $scope.search.searchTable = '';
        }

        $scope.resetSearchWaiter = function () {
            $scope.search.searchWaiter = '';
        }

        $scope.resetSearch = function () {
            $scope.search.remark = '';
        }
    })

    .controller('feedback', function ($scope, $parse, $ionicModal, $ionicSlideBoxDelegate, $http, $rootScope, ngCart, $timeout, $state, $ionicPopup, utf8_decodeFilter, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        var finalarray = [];
        var sendarray = [];
        $scope.course = [];
        $scope.dtlarray = [];
        $scope.email = '';
        $scope.phone = '';
        $scope.rsn = [];
        $scope.Answers = "";
        $scope.data = 3;
        $scope.max = 0;
        $scope.rating = 0;
        $scope.dtlarray['username'] = '';
        $scope.dtlarray['email'] = window.localStorage.getItem("cmail");
        $scope.dtlarray['phone'] = '';

        if (window.localStorage['feedbackquestions'].length < 5) {
            $scope.flag = false;
        } else {
            $scope.flag = true;
            var temp = window.localStorage['feedbackquestions'];

            var temp1 = window.localStorage['customquestion'];
            var temp = JSON.parse(temp);
            $rootScope.itemsForFeedback = [];
            $rootScope.getItemForFeedback();
            var temp1 = JSON.parse(temp1);

            //$timeout(function(){
            //    if ($rootScope.itemsForFeedback.length > 0){
            //        temp.push({answer_type: 'rate', compulsory: 1, multianswer: 0, question: 'Rate Items', questionunkid: '0'})
            //    }
            //},1000)
            //temp.push({answer_type: 'rate', compulsory: 1, multianswer: 0, question: 'Rate Items', questionunkid: '0'})

            for (i = 0; i < temp.length; i++) {
                if (temp[i]['answer_type'] == 'Rating')
                    $scope.course[temp[i]['questionunkid']] = 1;
            }

            $scope.samples = temp;
            $scope.answer = temp1;
            $scope.fld = "";
            $scope.nextflag = {
                flag: false,
                flag1: false
            };
            $scope.class = "disabled";
            $scope.currentSlide = 0;
        }

        $scope.slideHasChanged = function (index) {

            if (index == 0)
                $scope.class = "disabled";
            else
                $scope.class = "";

            if (index == temp.length) {
                $scope.nextflag.flag = true;
            } else {
                $scope.nextflag.flag = false;
            }

            if ((index > $scope.currentSlide) && temp[$scope.currentSlide].compulsory == '1') {
                if ($scope.course[temp[$scope.currentSlide]['questionunkid']] != undefined) {
                    if (temp[$scope.currentSlide]['multianswer'] == 1) {
                        var varray = $scope.course[temp[$scope.currentSlide]['questionunkid']];
                        var rarray = $scope.rsn[temp[$scope.currentSlide]['questionunkid']];

                        var ansarr = "";
                        var rsnarr = "";
                        for (j = 0; j < temp1.length; j++) {
                            var str = temp1[j]['custom_answer'];
                            if (varray[str] != undefined && varray[str] == true) {
                                ansarr += str + ",";
                                if ($scope.rsn[temp[$scope.currentSlide]['questionunkid']] != undefined) {
                                    if (rarray[str] != undefined) {
                                        rsnarr += str + "-" + rarray[str] + "^";
                                    }
                                }
                            }
                        }

                        rsnarr = rsnarr.substring(0, rsnarr.length - 1);
                        if (rsnarr.length == 0) {

                            $ionicSlideBoxDelegate.previous();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            $scope.currentSlide = index;
                        }
                    } else {
                        value = $scope.course[temp[$scope.currentSlide]['questionunkid']];
                        if (value.length == 0) {
                            $ionicSlideBoxDelegate.previous();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            $scope.currentSlide = index;
                        }
                    }
                } else {
                    if (temp[$scope.currentSlide].answer_type == 'rate') {

                        if ($rootScope.itemsForFeedback.length == 0) {
                            $scope.currentSlide = index;
                        } else {
                            flag = 1;
                            for (i = 0; i < $rootScope.itemsForFeedback.length; i++) {
                                if ($rootScope.itemsForFeedback[i].rate == 0) {
                                    flag = 0;
                                    break;
                                }
                            }
                            if (flag == 1)
                                $scope.currentSlide = index;
                            else {
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                                $ionicSlideBoxDelegate.previous();
                            }
                        }
                    } else {
                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                        $ionicSlideBoxDelegate.previous();
                    }
                }
            } else
                $scope.currentSlide = index;
        }

        $ionicModal.fromTemplateUrl('templates/datemodal.html',
            function (modal) {
                $scope.datemodal = modal;
            }, {
                scope: $scope,
                animation: 'slide-in-up'
            }
        );

        $scope.opendateModal = function (fld) {
            $scope.fld = fld;
            $scope.datemodal.show();
        };
        $scope.closedateModal = function (modal) {
            $scope.datemodal.hide();
            $scope.course[$scope.fld] = modal;
        };

        $scope.slidePrevious = function () {
            $ionicSlideBoxDelegate.previous();
        }

        $scope.slideNext = function () {
            $ionicSlideBoxDelegate.next();
        }
        $scope.submit = function () {

            finalarray = [];
            finalarray.length = 0;

            if ($rootScope.getConnectionFlag()) {
                var submitflag = 1;
                var flag = 0;
                var uname = $scope.dtlarray['username'];

                for (i = 0; i < temp.length; i++) {
                    if ($scope.course[temp[i]['questionunkid']] != undefined) {
                        if (temp[i]['multianswer'] == 1) {
                            var varray = $scope.course[temp[i]['questionunkid']];
                            var rarray = $scope.rsn[temp[i]['questionunkid']];

                            var ansarr = "";
                            var rsnarr = "";
                            for (j = 0; j < temp1.length; j++) {
                                var str = temp1[j]['custom_answer'];
                                if (varray[str] != undefined && varray[str] == true) {
                                    ansarr += str + ",";
                                    if ($scope.rsn[temp[i]['questionunkid']] != undefined) {
                                        if (rarray[str] != undefined) {
                                            rsnarr += str + "-" + rarray[str] + "^";
                                        }
                                    }
                                }
                            }

                            rsnarr = rsnarr.substring(0, rsnarr.length - 1);
                            ansarr = ansarr.substring(0, ansarr.length - 1);

                            if ((temp[i]['compulsory'] == 1 || temp[i]['compulsory'] == '1') && rsnarr.length == 0) {

                                $ionicSlideBoxDelegate.slide(i);
                                submitflag = 0;
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                                break;
                            } else {
                                finalarray.push({
                                    qunkid: temp[i]['questionunkid'],
                                    question: temp[i]['question'],
                                    ans: ansarr,
                                    reason: rsnarr,
                                })
                            }
                        } else {
                            var reason = '';
                            value = $scope.course[temp[i]['questionunkid']];
                            if ($scope.rsn[temp[i]['questionunkid']] != undefined) {
                                var tt = $scope.rsn[temp[i]['questionunkid']];
                                if (tt[value] != undefined) {
                                    reason = tt[value];
                                }
                            }

                            if ((temp[i]['compulsory'] == 1 || temp[i]['compulsory'] == '1') && value.length == 0) {
                                $ionicSlideBoxDelegate.slide(i);
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                                submitflag = 0;
                                break;
                            } else {
                                finalarray.push({
                                    qunkid: temp[i]['questionunkid'],
                                    question: temp[i]['question'],
                                    ans: value,
                                    reason: reason,
                                })
                            }
                        }
                    } else {
                        if ((temp[i]['compulsory'] == 1 || temp[i]['compulsory'] == '1') && temp[i]['answer_type'] != 'rate') {
                            $ionicSlideBoxDelegate.slide(i);
                            submitflag = 0;
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg90), 'top', false, $rootScope.messagetimeout, '');
                            break;
                        } else {
                            if (temp[i]['answer_type'] == 'rate') {
                                finalarray.push({
                                    qunkid: temp[i]['questionunkid'],
                                    question: temp[i]['question'],
                                    ans: $rootScope.itemsForFeedback,
                                    reason: '',
                                });
                            } else
                                finalarray.push({
                                    qunkid: temp[i]['questionunkid'],
                                    question: temp[i]['question'],
                                    ans: '',
                                    reason: '',
                                });
                        }
                    }
                }

                if (submitflag == 1) {

                    if (uname == undefined || uname == "") {
                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg33), 'top', false, $rootScope.messagetimeout, '');
                    } else {
                        var email = $scope.dtlarray['email'];
                        var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;

                        if (re.test(email)) {
                            flag = 1;
                        } else {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl111), 'top', false, $rootScope.messagetimeout, '');
                        }
                    }

                    if (flag == 1) {
                        var myPopup1 = $ionicPopup.show({
                            template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg54),
                            cssClass: 'custompopup',
                            title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg49),
                            scope: $scope,
                        });

                        sendarray.push({
                            restaurantcode: window.localStorage['restaurantcode'],
                            cname: $scope.dtlarray['username'],
                            email: $scope.dtlarray['email'],
                            phone: $scope.dtlarray['phone'],
                            feedback: finalarray
                        })
                        var data = JSON.stringify(sendarray);
                        var res = $http.get($rootScope.SERVER_PATH + 'savefeedback.php', {
                            params: {
                                "data": data
                            }
                        });
                        res.success(function (data, status, headers, config) {
                            myPopup1.close();
                            if (data == "Success") {
                                window.localStorage.setItem('feedbacksubmitted', 'true');
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl69), 'top', false, $rootScope.messagetimeout, '');
                            } else {
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg55), 'top', false, $rootScope.messagetimeout, '');
                            }

                            $state.go("app.home", {});
                        });

                        res.error(function (data, status, headers, config) {
                            $timeout(function () {
                                myPopup1.close()
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
                            }, 1000);
                        });
                    }
                }
            }

        }

        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout);
            }
        }
    })

    .controller('configuration', function ($rootScope, $scope, $state, $timeout, $ionicPopup, $cordovaCamera, sharedProperties, $ionicHistory, ngCart, utf8_decodeFilter, $ionicSideMenuDelegate, $ionicScrollDelegate, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $ionicSideMenuDelegate.canDragContent(false)
        $rootScope.hidebutton = "hidebutton";

        if (window.localStorage['logo_src'] == null || window.localStorage['logo_src'] == 'null') {
            window.localStorage['logo_src'] = '';
        }

        var logo1 = window.localStorage['logo'];
        $scope.data = {
            searchtext: ''
        };
        $scope.logo = logo1;
        $scope.logo_src = window.localStorage['logo_src'];
        $scope.getLogo = function () {

            $ionicHistory.clearCache();
            var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
            if (phonegapapp) {
                var options = {
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                };
                $cordovaCamera.getPicture(options).then(function (imageURI) {

                    window.localStorage['logo_src'] = '';
                    window.localStorage['logo'] = imageURI;
                    $scope.logo = imageURI;
                    $scope.logo_src = '';
                }, function (err) { });
            }
        };

        $scope.removeLogo = function () {
            $ionicHistory.clearCache();
            var phonegapapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
            if (phonegapapp) {
                if (window.localStorage['main_logo'] != "undefined") {
                    window.localStorage['logo'] = window.localStorage['main_logo'];
                    window.localStorage['logo_src'] = window.localStorage['main_logo_src'];
                    $scope.logo = window.localStorage['logo'];
                    $scope.logo_src = window.localStorage['logo_src'];
                } else {
                    $scope.logo = "";
                    $scope.logo_src = "";

                }
            }
        };

        $scope.logout = function () {

            var myPopup = $ionicPopup.show({
                template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg19),
                cssClass: 'logutpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl22),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl122),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl121),
                    type: 'button-positive',
                    onTap: function (e) {
                        $rootScope.cartcounter = 0;
                        $timeout(function () {
                            var myPopupexit = $ionicPopup.show({
                                template: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg40),
                                cssClass: 'logoutwait custompopup',
                                title: utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg49)
                            });

                            var regid = window.localStorage.getItem("registrationid");
                            window.localStorage.clear();
                            window.localStorage.setItem("registrationid", regid);
                            ngCart.empty();
                            $rootScope.clearCartItems();
                            $rootScope.lastCartId = 1;
                            $timeout(function () {
                                myPopupexit.close();
                                $rootScope.burrpmode = false;
                                document.getElementsByTagName('body')[0].setAttribute("class", 'en');
                                //document.getElementsByTagName('body')[0].className += " platform-ios platform-ipad platform-ios7 platform-cordova";
                                document.getElementsByTagName('html')[0].setAttribute("lang", 'en');
                                $state.go("app.mainlogin");
                            }, 2000);
                        }, 10);
                    }
                },]
            });
            myPopup.then(function (res) { });
        }

        $scope.hexPicker = {
            color: '#000'
        };

        $scope.rgbPicker = {
            color: ''
        };

        $scope.rgbaPicker = {
            color: ''
        };

        $scope.nonInput = {
            color: ''
        };

        $scope.resetColor = function () {
            $scope.hexPicker = {
                color: '#ff0000'
            };
        };

        $scope.resetRBGColor = function () {
            $scope.rgbPicker = {
                color: 'rgb(255,255,255)'
            };
        };

        $scope.resetRBGAColor = function () {
            $scope.rgbaPicker = {
                color: 'rgb(255,255,255, 0.25)'
            };
        };

        $scope.resetNonInputColor = function () {
            $scope.nonInput = {
                color: '#ffffff'
            };
        };

        $scope.config = {};
        $scope.config["isburrp"] = (localStorage.getItem("isburrp") == 'true') ? true : false;
        $scope.config["POSip"] = localStorage.getItem("POSip");
        $scope.config["POSport"] = localStorage.getItem("POSport");
        $scope.config["guestinfo"] = (localStorage.getItem("guestinfo") == 'true') ? true : false;
        $scope.config["tablename"] = '';
        $scope.config["Outlet"] = localStorage.getItem("Outlet");
        $scope.config["orderchoice"] = (localStorage.getItem("orderchoice") == 'true') ? true : false;
        $scope.config["waitermode"] = (localStorage.getItem("waitermode") == 'true') ? true : false;
        $scope.config["WaiterCode"] = localStorage.getItem("WaiterCode");
        $scope.config["WaiterId"] = localStorage.getItem("WaiterId");
        $scope.config["WaiterName"] = localStorage.getItem("WaiterName");
        $scope.config["orderpreference"] = localStorage.getItem("orderpreference"); /*0 => Dine In & 1 => Take Away */
        $scope.config["selectedlang"] = localStorage.getItem("selectedlang");
        $scope.config["ratemode"] = (localStorage.getItem("ratemode") == 'true') ? true : false;
        //$scope.config["forcefeedback"] = (localStorage.getItem("forcefeedback") == 'true') ? true : false;
        $scope.config['tablefix'] = (localStorage.getItem('tablefix') == 'true') ? true : false;
        $rootScope.settable = $scope.config["tablefix"];
        var sl = $scope.config["selectedlang"];
        $scope.tablelist = [];
        $scope.waiterlist = [];
        $scope.langs = [];

        var links = JSON.parse(localStorage.getItem("DisplayArr"));
        $scope.config["myorderdisp"] = false;
        $scope.config["feedbackdisp"] = false;
        $scope.config["syncdisp"] = false;
        $scope.config["aboutusdisp"] = false;
        $scope.config["helpdisp"] = false;
        $rootScope.displinks = {
            myorderdisp: false,
            feedbackdisp: false,
            syncdisp: false,
            aboutusdisp: false,
            helpdisp: false
        };

        if (JSON.parse(localStorage.getItem("DisplayArr"))[0].myorderdisp == 1) {
            $scope.config["myorderdisp"] = true;
            $rootScope.displinks.myorderdisp = true;
        }

        if (JSON.parse(localStorage.getItem("DisplayArr"))[1].feedbackdisp == 1) {
            $scope.config["feedbackdisp"] = true;
            $rootScope.displinks.feedbackdisp = true;
        }

        if (JSON.parse(localStorage.getItem("DisplayArr"))[2].syncdisp == 1) {
            $scope.config["syncdisp"] = true;
            $rootScope.displinks.syncdisp = true;
        }

        if (JSON.parse(localStorage.getItem("DisplayArr"))[3].aboutusdisp == 1) {
            $scope.config["aboutusdisp"] = true;
            $rootScope.displinks.aboutusdisp = true;
        }

        if (JSON.parse(localStorage.getItem("DisplayArr"))[4].helpdisp == 1) {
            $scope.config["helpdisp"] = true;
            $rootScope.displinks.helpdisp = true;
        }

        $scope.config["colortmp"] = localStorage.getItem("theme");
        $scope.config["bgcolor"] = localStorage.getItem("theme");
        $scope.config["tablename"] = localStorage.getItem("TableNumber");

        $scope.scrollTableTop = function () {
            $ionicScrollDelegate.$getByHandle('handle_tablelist').scrollTop(true);
        }

        $scope.selectTable = function (ev) {
            $scope.data = {
                searchtext: ''
            };
            $scope.table = {
                name: $scope.config["tablename"]
            };
            
            var waitertableallocation = JSON.parse(window.localStorage["waitertableallocation"]);
            var waiter = $scope.config.waiter.waiterunkid;
            var l = []

            if ($scope.config.waiter.waiterunkid!=null) {
                if ($scope.config['waitermode'] == true || localStorage.getItem('waitermode') == 'true') {
                    $scope.config["tablename"] = '';
                    var l = [];
                    for(var i=0;i<waitertableallocation.length;i++){
                        if (waitertableallocation[i][0] == waiter) {
                            for(var j=0;j<waitertableallocation[i][2].length;j++){
                                var tablelist = waitertableallocation[i][2][j].tname;                                 
                                var list = { "name": tablelist }
                                l.push(list)
                            }
                        }
                    }
                    if (waitertableallocation.length == 0) {
                        $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
                    }
                    else{
                        $scope.tableList = l;
                        window.localStorage.setItem("WaiterTable", JSON.stringify($scope.tableList));
                    }
                }
                else {
                    $scope.table.name = ''
                    $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
                }
            }
            else {
                $scope.table.name = '';
                $scope.tableList = JSON.parse(localStorage.getItem("imenuTablelist"));
            }

            $timeout(function () {
                if (document.querySelector(".tablescroll") != null) {
                    document.querySelector(".tablepopup ion-scroll").style["min-height"] = (document.querySelector(".tablepopup .popup").offsetHeight - (document.querySelector(".tablepopup .popup-head").offsetHeight + document.querySelector(".tablepopup .popup-buttons").offsetHeight + document.querySelector(".tablepopup .popsearch").offsetHeight + 90)) + 'px';
                    document.querySelector(".tablepopup ion-scroll").style["max-height"] = (document.querySelector(".tablepopup .popup").offsetHeight - (document.querySelector(".tablepopup .popup-head").offsetHeight + document.querySelector(".tablepopup .popup-buttons").offsetHeight + document.querySelector(".tablepopup .popsearch").offsetHeight + 90)) + 'px';
                }
            }, 100);

            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupTableList.html',
                cssClass: 'tablepopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl28),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) { }
                }, {

                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {
                        if ($scope.tableList.length > 0) {
                            if ($scope.table.name != undefined)
                                $scope.config["tablename"] = $scope.table.name;
                        }
                    }
                },]
            });
        }

        $scope.scrollWaiterTop = function () {
            $ionicScrollDelegate.$getByHandle('handle_waiterlist').scrollTop(true);
        }

        $scope.config.waiter = {
            waitercode: localStorage.getItem("WaiterCode"),
            waitername: localStorage.getItem("WaiterName"),
            waiterunkid: localStorage.getItem("WaiterId")
        };
        $scope.selectWaiter = function (evt) {
            $scope.data = {
                searchtext: ''
            };
            $scope.config["tablename"] = '';
            $scope.waiterList = JSON.parse(window.localStorage.getItem("imenuWaiterlist"));
            $timeout(function () {
                if (document.querySelector(".waiterscroll") != null) {
                    //     document.querySelector(".waiterscroll").style['height'] = $rootScope.height + 'px';
                    document.querySelector(".waiterpopup ion-scroll").style["min-height"] = (document.querySelector(".waiterpopup .popup").offsetHeight - (document.querySelector(".waiterpopup .popup-head").offsetHeight + document.querySelector(".waiterpopup .popup-buttons").offsetHeight + document.querySelector(".waiterpopup .popsearch").offsetHeight + 90)) + 'px';
                    document.querySelector(".waiterpopup ion-scroll").style["max-height"] = (document.querySelector(".waiterpopup .popup").offsetHeight - (document.querySelector(".waiterpopup .popup-head").offsetHeight + document.querySelector(".waiterpopup .popup-buttons").offsetHeight + document.querySelector(".waiterpopup .popsearch").offsetHeight + 90)) + 'px';
                }
            }, 100);
            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupWaiterList.html',
                cssClass: 'waiterpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl53),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {
                        
                        

                        if ($scope.waiterList.length > 0) {
                            for (i = 0; i < $scope.waiterList.length; i++) {
                                if ($scope.waiterList[i].waiterunkid == $scope.config.waiter.waiterunkid) {
                                    $scope.config.waiter["waitercode"] = $scope.waiterList[i].waitercode;
                                    $scope.config.waiter["waitername"] = $scope.waiterList[i].waitername;
                                    $scope.config.waiter["waiterunkid"] = $scope.waiterList[i].waiterunkid;
                                    break;
                                }
                            }
                        }
                    }
                },]
            });

        }

        $scope.config["language"] = [];
        alldata = JSON.parse(window.localStorage.getItem("alllangdata"));
        for (i = 0; i < alldata.length; i++) {
            if (alldata[i].langkey == window.localStorage.getItem("selectedlang")) {
                $scope.config["language"] = {
                    'langkey': alldata[i].langkey,
                    'langname': alldata[i].langname
                };
                $scope.language = {
                    'langkey': alldata[i].langkey,
                    'langname': alldata[i].langname
                };
                break;
            }
        }
        //    alldata = null;



        $scope.selectLanguage = function (ev) {

            $scope.languageList = [];
            for (i = 0; i < alldata.length; i++) {
                $scope.languageList.push({
                    "langkey": alldata[i].langkey,
                    "langname": alldata[i].langname
                });
            }

            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupLanguageList.html',
                cssClass: 'languagepopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl87),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {
                        if ($scope.language != undefined) {
                            $scope.config["language"].langkey = $scope.language.langkey;
                            for (i = 0; i < $scope.languageList.length; i++) {
                                if ($scope.languageList[i].langkey == $scope.config["language"].langkey) {
                                    $scope.config["language"].langname = $scope.languageList[i].langname;
                                    break;
                                }
                            }
                        }
                    }
                },]
            });
        }

        $scope.colorpicker = function () {
            document.querySelector(".colorpicker-position-top").style["background-color"] = "#efefef";
        }

        $scope.save = function () {

            if ($scope.config['waitermode'] == true) {
                if ($scope.config.waiter['waitername'] == '') {
                    $timeout(function () {
                        ionicToast.show("Please Select Waiter ...", 'top', false, $rootScope.messagetimeout, '');
                    }, 1000);
                }
                else if ($scope.config["tablefix"] == true) {
                    if ($scope.config["tablename"] == '') {
                        $timeout(function () {
                            ionicToast.show("Please Select Table ...", 'top', false, $rootScope.messagetimeout, '');
                        }, 1000);

                    }
                    else {
                        saveconfigData();
                    }
                }
                else {
                    saveconfigData();

                }
            }
            else {
                saveconfigData();
            }
        }
        function saveconfigData() {
            var flag = 1;

            if ($scope.config["isburrp"] == true || $scope.config["isburrp"] == "true") {
                $rootScope.burrpmode = true;
                var ip_tmp = window.localStorage.getItem("POSip");
                var port_tmp = window.localStorage.getItem("POSport");

                var flaga = 0,
                    flagb = 0;
                var numbers = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
                var numbersport = /^[0-9]+$/;

                if ($scope.config["POSip"] == '' || $scope.config["POSip"] == null || $scope.config["POSip"] == undefined || $scope.config["POSip"] == "undefined") {
                    flag = 0;
                    flaga = 0;
                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg11), 'top', false, $rootScope.messagetimeout, '');
                } else {
                    if ($scope.config["POSip"].match(numbers)) {
                        flaga = 1;
                    } else {
                        flag = 0;
                        ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg77), 'top', false, $rootScope.messagetimeout, '');
                    }
                }

                if (flaga == 1) {
                    if ($scope.config["POSport"] == '' || $scope.config["POSport"] == null || $scope.config["POSport"] == undefined || $scope.config["POSport"] == "undefined") {
                        flag = 0;
                        document.querySelector(".ionic_toast").classList.add("ionic_toast_top");

                        $timeout(function () {
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg10), 'top', false, $rootScope.messagetimeout, '');
                        }, 200);
                    } else {
                        if ($scope.config["POSport"].match(numbersport)) {
                            flagb = 1;
                        } else {
                            flag = 0;
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg78), 'top', false, $rootScope.messagetimeout, '');
                        }
                    }
                }

                if (flaga == 1 && flagb == 1) {
                    flag = 1;
                } else
                    flag = 0;
            } else {
                $rootScope.burrpmode = false;
                if (localStorage.getItem("isburrp") == true) {
                    $rootScope.burrpConnection = 0;
                }
            }

            if (flag == 1) {
                $ionicHistory.clearCache();
                localStorage.setItem("isburrp", $scope.config["isburrp"]);
                localStorage.setItem("POSip", $scope.config["POSip"]);
                localStorage.setItem("POSport", $scope.config["POSport"]);
                localStorage.setItem("guestinfo", $scope.config["guestinfo"]);
                localStorage.setItem("TableNumber", $scope.config["tablename"]);
                localStorage.setItem("Outlet", $scope.config["Outlet"]);
                localStorage.setItem("orderchoice", $scope.config["orderchoice"]);
                localStorage.setItem("waitermode", $scope.config["waitermode"]);
                localStorage.setItem("theme", $scope.config["bgcolor"]);
                localStorage.setItem("ratemode", $scope.config["ratemode"]);

                if ((window.localStorage.getItem("startorder") == true || window.localStorage.getItem("startorder") == "true") && (ip_tmp != $scope.config["POSip"] || port_tmp != $scope.config["POSport"]) && (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true")) {
                    $rootScope.sendMessage("Reconnect");
                } else if ((window.localStorage.getItem("startorder") == true || window.localStorage.getItem("startorder") == "true") && (window.localStorage.getItem("isburrp") == true || window.localStorage.getItem("isburrp") == "true")) {
                    $rootScope.sendMessage("Connected");
                }

                $rootScope.orderingmode = $scope.config["orderchoice"];
                $rootScope.ratemode = $scope.config["ratemode"];

                if ($scope.config.waiter != undefined) {
                    localStorage.setItem("WaiterCode", $scope.config.waiter["waitercode"]);
                    localStorage.setItem("WaiterId", $scope.config.waiter["waiterunkid"]);
                    localStorage.setItem("WaiterName", $scope.config.waiter["waitername"]);
                    localStorage.setItem("tablefix", $scope.config["tablefix"]);
                }
                localStorage.setItem("orderpreference", $scope.config["orderpreference"]);

                if ($scope.config.language["langkey"] != localStorage.getItem("selectedlang")) {
                    document.getElementsByTagName('body')[0].setAttribute("class", $scope.config.language["langkey"]);
                    //document.getElementsByTagName('body')[0].className += " platform-ios platform-ipad platform-ios7 platform-cordova";
                    document.getElementsByTagName('html')[0].setAttribute("lang", $scope.config.language["langkey"]);
                    localStorage.setItem("selectedlang", $scope.config.language["langkey"]);
                    if ($scope.config.language["langkey"] == "ar") {
                        $rootScope.langside = "right";
                    } else {
                        $rootScope.langside = "left";
                    }
                    $rootScope.loadAllData();
                }

                var arr = [];
                arr.push({
                    "myorderdisp": $scope.config["myorderdisp"]
                });
                arr.push({
                    "feedbackdisp": $scope.config["feedbackdisp"]
                });
                arr.push({
                    "syncdisp": $scope.config["syncdisp"]
                });
                arr.push({
                    "aboutusdisp": $scope.config["aboutusdisp"]
                });
                arr.push({
                    "helpdisp": $scope.config["helpdisp"]
                });

                $rootScope.displinks.myorderdisp = $scope.config["myorderdisp"];
                $rootScope.displinks.feedbackdisp = $scope.config["feedbackdisp"];
                $rootScope.displinks.syncdisp = $scope.config["syncdisp"];
                $rootScope.displinks.aboutusdisp = $scope.config["aboutusdisp"];
                $rootScope.displinks.helpdisp = $scope.config["helpdisp"];
                localStorage.setItem("DisplayArr", JSON.stringify(arr));
                $rootScope.colorset();
                if (sl == $scope.config.language["langkey"]) {
                    $state.go("app.home", {});
                } else {
                    location.reload();
                }
            }
        }
        $scope.cancel = function () {
            $state.go("app.home", {});
        }

        $scope.resetSearch = function () {
            $scope.data.searchtext = '';
        }
    })

    .controller('menuItemSearch', function ($scope, $ionicPopup, $timeout, ngCart, $state, $rootScope, utf8_decodeFilter, $ionicScrollDelegate, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {

            ionicToast.hide();
            $scope.filtername = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl105);
            $scope.foodtype = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl107);
            $scope.dataDefault = {
                namecode: "itemname",
                veg: "both"
            }
            $scope.data = {
                namecode: "itemname",
                veg: "both",
                searchtext: '',
                tmpsrch: ''
            }
            $scope.currencysymbol = localStorage.getItem("currencysymbol");
            $scope.limit = 20;
        });

        $scope.$on('$ionicView.enter', function () {

            $scope.ratemode = (localStorage.getItem('ratemode') == 'true') ? true : false;
            $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
            $scope.scopeMenuItems = $rootScope.menuItems;
            for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                $scope.scopeMenuItems[i].qty = 1;

                if (i == $scope.scopeMenuItems.length - 1 || i > $scope.limit) {
                    setTimeout(function () {
                        if (document.querySelector('.loadingData') != null)
                            document.querySelector('.loadingData').classList.add('loaded');
                    }, 1000)
                }
            }
        });

        $scope.BackToHome = function () {
            $state.go("app.home", {});
        }

        $scope.showPopup = function () {

            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupFilter.html',
                cssClass: 'filterpopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl120),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) {
                        $timeout(function () {
                            $scope.data.namecode = $scope.dataDefault.namecode;
                            $scope.data.veg = $scope.dataDefault.veg;
                        }, 200);
                    }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: '',
                    onTap: function (e) {
                        $scope.dataDefault.namecode = $scope.data.namecode;
                        $scope.dataDefault.veg = $scope.data.veg;

                        if ($scope.dataDefault.namecode == "itemname")
                            $scope.filtername = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl105);
                        else
                            $scope.filtername = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl106);

                        if ($scope.dataDefault.veg == "both")
                            $scope.foodtype = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl107);
                        else if ($scope.dataDefault.veg == "veg")
                            $scope.foodtype = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl82);
                        else if ($scope.dataDefault.veg == "nonveg")
                            $scope.foodtype = utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl83);

                        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
                    }
                },]
            });
        };

        $scope.resetSearch = function () {
            $scope.data.searchtext = '';
            $scope.data.tmpsrch = '';
        };

        $scope.searchitems = function () {
            $scope.data.searchtext = $scope.data.tmpsrch
        }

        $scope.scrollItemTop = function () {
            $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
        }

        $scope.visibleCancel = function () {
            // console.log(document.querySelector('#srchtxtbox').value)
            if (document.querySelector('#srchtxtbox').value.length > 0) {
                //   console.log("1")
            }
        }

        $scope.loadMore = function () {

            if ($rootScope.cnt != 0) {
                document.querySelector(".loadMoreItems").classList.add("showLoadmoreItems");
                $timeout(function () {
                    $scope.limit += 2;
                }, 50)
                $timeout(function () {
                    $scope.limit += 2;
                }, 100)
                $timeout(function () {
                    $scope.limit += 2;
                }, 150)
                $scope.$broadcast('scroll.infiniteScrollComplete');

                $timeout(function () {
                    if (document.querySelector(".loadMoreItems") != null)
                        document.querySelector(".loadMoreItems").classList.remove("showLoadmoreItems");
                }, 1000)
            } else {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        }

        $scope.updateQTY = function (menugrpitemunkid, number, index) {

            for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                if ($scope.scopeMenuItems[i].menugrpitemunkid == menugrpitemunkid) {
                    if (number == -1 && ($scope.scopeMenuItems[i].qty != 1 || $scope.scopeMenuItems[i].qty != "1")) {
                        $scope.scopeMenuItems[i].qty = parseInt($scope.scopeMenuItems[i].qty) - 1;
                    } else if (number == 1) {
                        $scope.scopeMenuItems[i].qty = parseInt($scope.scopeMenuItems[i].qty) + 1;
                    }
                    break;
                }
            }
        }

        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'topsearch', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.itemDetail = function (menugroupunkid, menugrpitemunkid) {

            if (event.target.classList.contains('cartbtn') == false && event.target.classList.contains('fa-plus') == false && event.target.classList.contains('fa-minus') == false) {
                // $rootScope.openLoading();
                for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                    if ($scope.scopeMenuItems[i].menugrpitemunkid == menugrpitemunkid) {
                        if (window.localStorage.getItem("orderchoice") == true || window.localStorage.getItem("orderchoice") == "true") {
                            $state.go("app.itemDetail/:menuGroupId/:menuItemId/:index/:qty", {
                                menuGroupId: menugroupunkid,
                                menuItemId: menugrpitemunkid,
                                index: -1,
                                qty: $scope.scopeMenuItems[i].qty
                            })
                        } else {
                            $state.go("app.menuItemDetailViewOnly/:menuGroupId/:menuItemId/:index/:qty", {
                                menuGroupId: menugroupunkid,
                                menuItemId: menugrpitemunkid,
                                index: -1
                            })
                        }
                        break;

                    }
                }
            }
        }

        $scope.addtocart = function (id, menugroupunkid, menugrpitemunkid) {
            // var a = event.target;
            // if(!a.classList.contains("diable_addtocart_btn")){
            // a.classList.add("diable_addtocart_btn");
            // $timeout(function(){
            // a.classList.remove("diable_addtocart_btn");
            // }, 2000)

            var added = false;
            for (j = 0; j < $scope.scopeMenuItems.length; j++) {
                if ($scope.scopeMenuItems[j].menugrpitemunkid == id && $scope.scopeMenuItems[j].modifierunkid == '' && JSON.parse($scope.scopeMenuItems[j].price).length == 1) {
                    $scope.data = [];
                    $scope.data.cartid = $rootScope.lastCartId;
                    $scope.data.iscustomremark = '';
                    $scope.data.isordered = 0;
                    $scope.data.itemid = $scope.scopeMenuItems[j].menugrpitemunkid;
                    $scope.data.menugroupcode = $scope.scopeMenuItems[j].menugrpitem_code;
                    $scope.data.menuitemcode = '';
                    $scope.data.menuitemremark = '';
                    $scope.data.menuitemtype = '';
                    $scope.data.modifierunkid = [];
                    $scope.data.orderSeq = ngCart.getItems().length + 1;
                    $scope.data.unit = JSON.parse($scope.scopeMenuItems[j].price)[0].unitname;
                    $scope.data.unitid = JSON.parse($scope.scopeMenuItems[j].price)[0].unitid;
                    $scope.data.rating = 1;

                    $rootScope.foodcart = 2;
                    flag = 1;
                    for (i = 0; i < ngCart.getItems().length; i++) {
                        if (ngCart.getItems()[i]._data.isordered == 0 && ngCart.getItems()[i]._data.itemid == $scope.scopeMenuItems[j].menugrpitemunkid) {
                            flag = 0;
                            document.querySelector('.cartanim').classList.add('cartanimation');
                            var qty = parseInt(ngCart.getItems()[i]._quantity + $scope.scopeMenuItems[j].qty);
                            ngCart.getItems()[i]._quantity = qty;
                            $rootScope.incrementCartRowItem(ngCart.getItems()[i]._data.orderSeq, qty);
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl139) + " " + $scope.scopeMenuItems[j].menugrpitemname + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl140), 'topsearch', false, $rootScope.messagetimeout, '');
                            $timeout(function () {
                                document.querySelector('.cartanim').classList.remove('cartanimation');
                            }, 320);
                            added = true;
                            break;
                        }
                    }

                    if (flag == 1) {
                        document.querySelector('.cartanim').classList.add('cartanimation');
                        ionicToast.show($scope.scopeMenuItems[j].menugrpitemname + " " + utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl136), 'topsearch', false, $rootScope.messagetimeout, '');
                        if (ngCart.getItems().length > 0)
                            var id = (ngCart.getItems()[ngCart.getItems().length - 1]._id) + 1;
                        else
                            var id = 1;
                        $rootScope.cartcounter++;
                        $timeout(function () {
                            document.querySelector('.cartanim').classList.remove('cartanimation');
                        }, 320);
                        ngCart.addItem(id, $scope.scopeMenuItems[j].menugrpitemname, JSON.parse($scope.scopeMenuItems[j].price)[0].unitprice, $scope.scopeMenuItems[j].qty, $scope.data);
                        added = true;
                        $rootScope.addToCart($scope.data.itemid, $scope.scopeMenuItems[j].menugrpitemname, JSON.parse($scope.scopeMenuItems[j].price)[0].unitprice, $scope.data.menugroupcode, $scope.data.menuitemcode, $scope.data.menuitemtype, $scope.data.unitid, $scope.data.unit, JSON.parse($scope.scopeMenuItems[j].price)[0].unitprice, $scope.data.modifierunkid, id, $scope.data.menuitemremark, "", $scope.scopeMenuItems[j].qty);
                        $rootScope.getCartId();
                    }
                }
            }

            if (added == false) {
                // $rootScope.openLoading();
                for (i = 0; i < $scope.scopeMenuItems.length; i++) {
                    if ($scope.scopeMenuItems[i].menugrpitemunkid == menugrpitemunkid) {
                        if (window.localStorage.getItem("orderchoice") == true || window.localStorage.getItem("orderchoice") == "true") {
                            $state.go("app.itemDetail/:menuGroupId/:menuItemId/:index/:qty", {
                                menuGroupId: menugroupunkid,
                                menuItemId: menugrpitemunkid,
                                index: -1,
                                qty: $scope.scopeMenuItems[i].qty
                            })
                        } else {
                            $state.go("app.menuItemDetailViewOnly/:menuGroupId/:menuItemId/:index/:qty", {
                                menuGroupId: menugroupunkid,
                                menuItemId: menugrpitemunkid,
                                index: -1
                            })
                        }
                        break;
                    }
                }
            }
            // }
        }
    })


    .controller('iFeedback', function ($scope, sharedProperties, $state, $rootScope, $ionicPopup, ngCart, $timeout, utf8_decodeFilter, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        var slist = window.localStorage['ifeedbacksurvey'];
        slist = JSON.parse(slist);
        $scope.sname = '';
        $scope.srv = {};
        $scope.companykey = slist['companykey'];
        $scope.startsurvey = function () {
            if ($scope.srv.surveycode == undefined || $scope.srv.surveycode == '') {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg43), 'top', false, $rootScope.messagetimeout, '');
            } else {
                var url = "http://web.ezeeifeedback.com/f/" + $scope.companykey + "/" + $scope.srv.surveycode;
                cordova.InAppBrowser.open(url, '_blank', 'location=yes');
            }
        }

        $scope.selectsurvey = function () {

            $timeout(function () {
                document.querySelector(".tablepopup ion-scroll").style["min-height"] = (document.querySelector(".tablepopup .popup").offsetHeight - (document.querySelector(".tablepopup .popup-head").offsetHeight + document.querySelector(".tablepopup .popup-buttons").offsetHeight + 90)) + 'px';
                document.querySelector(".tablepopup ion-scroll").style["max-height"] = (document.querySelector(".tablepopup .popup").offsetHeight - (document.querySelector(".tablepopup .popup-head").offsetHeight + document.querySelector(".tablepopup .popup-buttons").offsetHeight + 90)) + 'px';
            }, 100);

            $scope.surveylist = slist['surveylist'];
            var myPopup = $ionicPopup.show({
                templateUrl: 'templates/popupSurveyList.html',
                cssClass: 'tablepopup custompopup',
                title: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl85),
                scope: $scope,
                buttons: [{
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl38),
                    onTap: function (e) { }
                }, {
                    text: utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl98),
                    type: 'button-positive',
                    onTap: function (e) {

                        for (i = 0; i < $scope.surveylist.length; i++) {
                            if ($scope.surveylist[i]['surveycode'] == $scope.srv.surveycode) {
                                $scope.sname = $scope.surveylist[i]['surveyname']
                            }
                        }
                    }
                },]
            });
        }

        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }
    })

    .controller('aboutUs', function ($scope, ngCart, $timeout, $state, utf8_decodeFilter, $rootScope, $ionicPopup, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.foodcart = function () {
            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }

        $scope.backToMenu = function () {
            $state.go("app.home", {})
        }
    })

    .controller('customerloginsignup', function ($scope, ngCart, $timeout, $state, utf8_decodeFilter, $rootScope, $ionicPopup, $http, ionicToast) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();

            $scope.ldata = {};
            $scope.active = {};
            $scope.password = {};
            $scope.active['activetab'] = "signup";
            $scope.password['action'] = "true";
        });

        $scope.switchsignup = function () {
            $scope.active['activetab'] = "signup";
        }

        $scope.switchsignin = function () {
            $scope.active['activetab'] = "signin";
        }

        $scope.showPassword = function () {
            $scope.password['action'] = "text";
        }

        $scope.hidePassword = function () {
            $scope.password['action'] = "password";
        }

        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }


        $scope.custsignin = function () {

            if ($scope.active['activetab'] == 'signup' && ($scope.ldata.name == "" || $scope.ldata.name == undefined)) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg8), 'top', false, $rootScope.messagetimeout, '');
            } else if ($scope.ldata.email == "" || $scope.ldata.email == undefined) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg9), 'top', false, $rootScope.messagetimeout, '');
            } else if ($scope.ldata.password == "" || $scope.ldata.password == undefined) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg4), 'top', false, $rootScope.messagetimeout, '');
            } else {
                var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;

                if (re.test($scope.ldata.email)) {
                    $rootScope.openLoading();
                    userdata = [];
                    userdata.push({
                        name: '',
                        email: $scope.ldata.email,
                        password: $scope.ldata.password,
                        restaurantcode: window.localStorage['restaurantcode'],
                        from: '',
                        restaurantname: '',
                        action: 'signin'
                    });
                    var data = JSON.stringify(userdata);
                    var close = false;
                    var res = $http.get($rootScope.SERVER_PATH + 'customerlogin.php', {
                        params: {
                            "data": data
                        }
                    });

                    res.success(function (data, status, headers, config) {

                        if (data == 0) {
                            $rootScope.routingPopup.close();
                            $scope.active['activetab'] = 'signup';
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg79), 'top', false, $rootScope.messagetimeout, '');
                        } else if (data == 2) {
                            $rootScope.routingPopup.close();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg44), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            var data = data;
                            var allordr = [];
                            window.localStorage.setItem("orderunkid_array", "");
                            for (a = 0; a < data["order_master"].length; a++) {
                                var obj = new Object;
                                obj.orderunkid = data["order_master"][a].orderno;
                                obj.tableno = '';
                                obj.israted = data["order_master"][a].ratingflag;
                                allordr.unshift(obj);

                                if (a == data["order_master"].length - 1) {
                                    window.localStorage.setItem("orderunkid_array", JSON.stringify(allordr));
                                }
                            }

                            $rootScope.droprecreate();
                            $rootScope.clearCartItems(1);
                            $rootScope.lastCartId = 1;
                            ngCart.empty();
                            var hdata = [];
                            for (i = 0; i < data['order_master'].length; i++) {
                                for (j = 0; j < data['order_transaction'].length; j++) {
                                    if (data['order_master'][i]['orderunkid'] == data['order_transaction'][j]['orderunkid']) {
                                        if (data['order_transaction'][j]['modifierparentid'] == 0) {

                                            var mdata = [];
                                            var rflag;
                                            var dtldata = [];

                                            for (k = 0; k < data['order_transaction'].length; k++) {
                                                if (data['order_transaction'][k]['modifierparentid'] == data['order_transaction'][j]['ordertransunkid']) {
                                                    mdata.push({
                                                        cartid: '',
                                                        modifiergrpunkid: '',
                                                        modifieritem_code: '',
                                                        modifieritemname: data['order_transaction'][k]['menugrpitemname'],
                                                        modifieritemprice: data['order_transaction'][k]['menugrpitemprice'],
                                                        modifieritemunkid: data['order_transaction'][k]['menugrpitemunkid'],
                                                        modifiertype: true,
                                                        unitid: data['order_transaction'][k]['unitid'],
                                                        unitname: data['order_transaction'][k]['unitname'],
                                                    })
                                                }
                                            }
                                            if (data['order_master'][i]['ratingflag'] == 0) {
                                                rflag = 2;
                                            } else {
                                                rflag = 1;
                                            }
                                            dtldata.push({
                                                cartid: data['order_master'][i]['orderno'],
                                                orderunkid: data['order_master'][i]['orderno'],
                                                iscustomremark: '',
                                                isordered: rflag,
                                                rating: data['order_transaction'][j]['rating'],
                                                itemid: data['order_transaction'][j]['menugrpitemunkid'],
                                                length: 0,
                                                menugroupcode: '',
                                                menuitemcode: '',
                                                menuitemremark: '',
                                                menuitemtype: '',
                                                modifierunkid: mdata,
                                                unit: data['order_transaction'][j]['unitname'],
                                                unitid: data['order_transaction'][j]['unitid'],

                                            });

                                            hdata.push({
                                                _id: data['order_transaction'][j]['menugrpitemunkid'],
                                                _name: data['order_transaction'][j]['menugrpitemname'],
                                                _quantity: data['order_transaction'][j]['itemquantity'],
                                                _price: data['order_transaction'][j]['unitprice'],
                                                _data: dtldata,
                                            });
                                        }
                                    }
                                }
                            }

                            if (data.customerunkid != '') {
                                window.localStorage['cid'] = data.customerunkid;
                                window.localStorage['cmail'] = $scope.ldata.email;
                            }
                            $rootScope.custHistory(hdata);

                            $timeout(function () {
                                $rootScope.LoadCart();

                                $timeout(function () {
                                    if (window.localStorage.getItem("cartitems") != null && window.localStorage.getItem("cartitems") != 'null' && window.localStorage.getItem("cartitems").length > 0) {
                                        cartItems = JSON.parse(window.localStorage.getItem("cartitems"));
                                        window.localStorage.removeItem("cartitems")
                                        if (cartItems != null) {
                                            for (i = 0; i < cartItems.length; i++) {
                                                var data = [];
                                                data.cartid = cartItems[i].cartid;
                                                data.itemid = cartItems[i].itemid;
                                                data.menugroupcode = cartItems[i].menugroupcode;
                                                data.menuitemcode = cartItems[i].menuitemcode;
                                                data.menuitemtype = cartItems[i].menuitemtype;
                                                data.orderSeq = cartItems[i].orderSeq;
                                                data.unit = cartItems[i].unit;
                                                data.unitid = cartItems[i].unitid;
                                                data.menuitemremark = cartItems[i].menuitemremark;
                                                data.iscustomremark = cartItems[i].iscustomremark;
                                                data.isordered = cartItems[i].isordered;
                                                data.orderunkid = cartItems[i].orderunkid;
                                                data.rating = cartItems[i].rating;

                                                data.modifierunkid = [];
                                                if (cartItems[i].modifierunkid != undefined) {
                                                    for (j = 0; j < cartItems[i].modifierunkid.length; j++) {
                                                        var tmp = [];
                                                        tmp.cartid = cartItems[i].cartid;
                                                        tmp.modifiergrpunkid = '';
                                                        tmp.modifieritem_code = cartItems[i].modifierunkid[j].modifieritemname;
                                                        tmp.modifieritemname = cartItems[i].modifierunkid[j].modifieritemname;
                                                        tmp.modifieritemprice = cartItems[i].modifierunkid[j].modifieritemprice;
                                                        tmp.modifieritemunkid = cartItems[i].modifierunkid[j].modifieritemunkid;
                                                        tmp.modifiertype = true;
                                                        tmp.unitid = cartItems[i].modifierunkid[j].modifierunitunkid;
                                                        tmp.unitname = cartItems[i].modifierunkid[j].unitname;
                                                        data.modifierunkid.push(tmp);
                                                    }
                                                }

                                                if (data.isordered == 0)
                                                    $rootScope.cartcounter++;
                                                ngCart.addItem(parseInt(cartItems[i].cartid), cartItems[i].name, parseFloat(cartItems[i].menugrpitemprice), parseInt(cartItems[i].quantity), data);
                                            }
                                        }
                                    }
                                }, 1000)

                            }, 5000);

                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl112), 'top', false, $rootScope.messagetimeout, '');
                            $scope.signinmthd = "signout";
                            $scope.classn = "fa fa-sign-out icns";
                            $state.go("app.home", {})
                            $rootScope.routingPopup.close();
                            $rootScope.cartcounter = 0;
                        }
                    });
                    res.error(function (data, status, headers, config) {
                        $timeout(function () {
                            $rootScope.routingPopup.close();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
                        }, 1000);
                    });


                    if (close == true)
                        $state.go("app.home", {})
                } else {
                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl111), 'top', false, $rootScope.messagetimeout, '');
                }
            }
        }

        $scope.custsignup = function () {

            if ($scope.active['activetab'] == 'signup' && $scope.ldata.name == "" || $scope.ldata.name == undefined) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg8), 'top', false, $rootScope.messagetimeout, '');
            } else if ($scope.ldata.email == "" || $scope.ldata.email == undefined) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg9), 'top', false, $rootScope.messagetimeout, '');
            } else if ($scope.ldata.password == "" || $scope.ldata.password == undefined) {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg4), 'top', false, $rootScope.messagetimeout, '');
            } else {
                var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;

                if (re.test($scope.ldata.email)) {
                    $rootScope.openLoading();
                    userdata = [];
                    userdata.push({
                        name: $scope.ldata.name,
                        email: $scope.ldata.email,
                        password: $scope.ldata.password,
                        restaurantcode: window.localStorage['restaurantcode'],
                        restaurantname: JSON.parse(window.localStorage.getItem("restaurantData"))[0].restaurantname,
                        from: JSON.parse(window.localStorage.getItem("restaurantData"))[0].feedbackemailid,
                        action: "signup"
                    });

                    var data = JSON.stringify(userdata);
                    var close = false;

                    var res = $http.get($rootScope.SERVER_PATH + 'customerlogin.php', {
                        params: {
                            "data": data
                        }
                    });

                    res.success(function (data, status, headers, config) {
                        if (data == 1 || data == 0) {
                            $rootScope.routingPopup.close();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg82), 'top', false, $rootScope.messagetimeout, '');
                        } else {
                            if (data["customerunkid"] != 0) {
                                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg81), 'top', false, $rootScope.messagetimeout, '');
                                $scope.signinmthd = "signout";
                                $scope.classn = "fa fa-sign-out icns";
                                window.localStorage['cid'] = data['customerunkid'];
                                window.localStorage['cmail'] = $scope.ldata.email;
                                $state.go("app.home", {});
                                $rootScope.routingPopup.close();
                            }
                        }
                    });

                    res.error(function (data, status, headers, config) {
                        $timeout(function () {
                            $rootScope.routingPopup.close();
                            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg47), 'top', false, $rootScope.messagetimeout, '');
                        }, 1000);
                    });
                } else {
                    ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.LABEL.lbl111), 'top', false, $rootScope.messagetimeout, '');
                }
            }
        }

        $scope.cancel = function () {
            $state.go("app.home", {})
        }
    })
    
    .controller('notification', function ($scope, $timeout, $http, ngCart, $state, utf8_decodeFilter, $rootScope, $ionicPopup, ionicToast, $ionicGesture,$ionicLoading)
    {
        var restaurantcode = window.localStorage.getItem("restaurantcode");
        $scope.notificationlist = [];
        $scope.color = window.localStorage.getItem("theme");
        if ($scope.color == null || $scope.color == '') {
            $scope.color = "#3f4392";
        }
        $scope.limit = 10;
        
        var restaurantcode = window.localStorage.getItem("restaurantcode");
        var res = $http.get($rootScope.SERVER_PATH + 'notification.php?action=getNotification', {
            params: { "restaurantcode": restaurantcode }
        });
        res.success(function (data)
        {
            $timeout(function(){
                $scope.notificationlist = data;
            }, 100);
        })
        
        $rootScope.refresh = function()
        {
            ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg49), 'bottom', false, $rootScope.messagetimeout, '');
            //$rootScope.routingPopup = $ionicPopup.show({
            //    template: '<img src="img/359.GIF"><div>'+ $rootScope.utf8_decode($rootScope.languageLabels.MESSAGE.msg49) +'</div>',
            //    cssClass: 'notiLoader'
            //});
            
            var restaurantcode = window.localStorage.getItem("restaurantcode");
            var res = $http.get($rootScope.SERVER_PATH + 'notification.php?action=getNotification', {
                params: { "restaurantcode": restaurantcode }
            });
            res.success(function (data)
            {
                $scope.notificationlist = data;
                //$rootScope.routingPopup.close();
            })
        }
        
        $scope.read = function(record){
            if (record.is_read==0) {
                var res = $http.get($rootScope.SERVER_PATH + 'notification.php?action=readNotification', {
                    params: { "notificationunkid": record.notificationunkid }
                });
                res.success(function (data)
                {
                    record.is_read = 1;
                })
            }
        }
        
        $scope.loadMore = function(){
            $scope.limit += 10;
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }
        //$rootScope.refresh();
    })

    .controller('help', function ($scope, $timeout, ngCart, $state, utf8_decodeFilter, $rootScope, $ionicPopup, ionicToast, $ionicGesture) {

        $scope.$on('$ionicView.beforeEnter', function () {
            ionicToast.hide();
        });

        $scope.backToMenu = function () {
            $state.go("app.home", {});
        }

        $scope.foodcart = function () {

            var flag = 0;
            var ngcrt = ngCart.getItems();
            if (ngcrt.length > 0) {
                for (i = 0; i < ngcrt.length; i++) {
                    if (ngcrt[i]._data.isordered == 0) {
                        flag = 1;
                        break;
                    }
                }
            }

            if (flag == 1) {
                $state.go("app.foodcart", {})
            } else {
                ionicToast.show(utf8_decodeFilter($rootScope.languageLabels.MESSAGE.msg28), 'top', false, $rootScope.messagetimeout, '');
            }
        }
    })

    .directive("starRating", function () {
        return {
            restrict: "EA",
            template: "<ul class='rating' ng-class='{readonly: readonly}'>" +
            "  <li ng-repeat='star in stars' ng-class='star' ng-click='toggle($index)'>" +
            "    <i class='fa fa-star'></i>" + //&#9733
            "  </li>" +
            "</ul>",
            scope: {
                ratingValue: "=ngModel",
                max: "=?", //optional: default is 5
                onRatingSelected: "&?",
                readonly: "=?"
            },
            link: function (scope, elem, attrs) {
                if (scope.max == undefined) {
                    scope.max = 5;
                }

                function updateStars() {
                    scope.stars = [];
                    for (var i = 0; i < scope.max; i++) {
                        scope.stars.push({
                            filled: i < scope.ratingValue
                        });
                    }
                };
                scope.toggle = function (index) {
                    if (scope.readonly == undefined || scope.readonly == false) {
                        scope.ratingValue = index + 1;
                        // scope.onRatingSelected({
                        //   rating: index + 1
                        // });
                    }
                };
                scope.$watch("ratingValue", function (oldVal, newVal) {
                    //if (newVal) { updateStars(); }
                    updateStars();
                });
            }
        };
    })

angular.module('ionicApp', ['ionic'])

    .controller('MyCtrl', function ($scope, $timeout) {
        $scope.myTitle = 'Template';

        $scope.data = {
            swipe: 0,
            swiperight: 0,
            swipeleft: 0,
            tap: 0,
            doubletap: 0
        };

        $scope.reportEvent = function (event) {
            $timeout(function () {
                $scope.data[event.type]++;
            })
        }
    });